/* FlickrPublishingAuthenticator.c generated by valac 0.56.13, the Vala compiler
 * generated from FlickrPublishingAuthenticator.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "shotwell-plugin-common.h"
#include <glib-object.h>
#include <webkit2/webkit2.h>
#include <libsoup/soup.h>
#include <gio/gio.h>
#include "shotwell-plugin-dev-1.0.h"
#include "shotwell-authenticator.h"

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_ENDPOINT_URL "https://api.flickr.com/services/rest"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_EXPIRED_SESSION_ERROR_CODE "98"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_API_KEY "60dd96d4a2ad04888b09c9e18d82c26f"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_API_SECRET "d0960565e03547c1"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_SERVICE_WELCOME_MESSAGE _ ("You are not currently logged into Flickr.\n" \
"\n" \
"Click Log in to log into Flickr in your Web browser. You will have to " \
"authorize Shotwell Connect to link to your Flickr account.")
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_SERVICE_DISCLAIMER "<b>This product uses the Flickr API but is not endorsed or certified b" \
"y SmugMug, Inc.</b>"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_LOGIN_URI "https://www.flickr.com/services/oauth/authorize?oauth_token=%s&perms=w" \
"rite"

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION (publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_AUTHENTICATION_REQUEST_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION, PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_AUTHENTICATION_REQUEST_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION, PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_AUTHENTICATION_REQUEST_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_AUTHENTICATION_REQUEST_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_AUTHENTICATION_REQUEST_TRANSACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION, PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass))

typedef struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction;
typedef struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass;
typedef struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionPrivate PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionPrivate;

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION (publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_ACCESS_TOKEN_FETCH_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION, PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_ACCESS_TOKEN_FETCH_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION, PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_ACCESS_TOKEN_FETCH_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_ACCESS_TOKEN_FETCH_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_ACCESS_TOKEN_FETCH_TRANSACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION, PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass))

typedef struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction;
typedef struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass;
typedef struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionPrivate PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE (publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_WEB_AUTHENTICATION_PANE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_WEB_AUTHENTICATION_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass))

typedef struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPane PublishingAuthenticatorShotwellFlickrWebAuthenticationPane;
typedef struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass;
typedef struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate;
enum  {
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_0_PROPERTY,
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_NUM_PROPERTIES
};
static GParamSpec* publishing_authenticator_shotwell_flickr_web_authentication_pane_properties[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_AUTHORIZED_SIGNAL,
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_ERROR_SIGNAL,
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_NUM_SIGNALS
};
static guint publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_NUM_SIGNALS] = {0};

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR (publishing_authenticator_shotwell_oauth1_authenticator_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_AUTHENTICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_AUTHENTICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1AuthenticatorClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_IS_AUTHENTICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_IS_AUTHENTICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_AUTHENTICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1AuthenticatorClass))

typedef struct _PublishingAuthenticatorShotwellOAuth1Authenticator PublishingAuthenticatorShotwellOAuth1Authenticator;
typedef struct _PublishingAuthenticatorShotwellOAuth1AuthenticatorClass PublishingAuthenticatorShotwellOAuth1AuthenticatorClass;
typedef struct _PublishingAuthenticatorShotwellOAuth1AuthenticatorPrivate PublishingAuthenticatorShotwellOAuth1AuthenticatorPrivate;

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR (publishing_authenticator_shotwell_flickr_flickr_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickrClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickrClass))

typedef struct _PublishingAuthenticatorShotwellFlickrFlickr PublishingAuthenticatorShotwellFlickrFlickr;
typedef struct _PublishingAuthenticatorShotwellFlickrFlickrClass PublishingAuthenticatorShotwellFlickrFlickrClass;
typedef struct _PublishingAuthenticatorShotwellFlickrFlickrPrivate PublishingAuthenticatorShotwellFlickrFlickrPrivate;
enum  {
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_0_PROPERTY,
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_NUM_PROPERTIES
};
static GParamSpec* publishing_authenticator_shotwell_flickr_flickr_properties[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_NUM_PROPERTIES];
#define _publishing_rest_support_transaction_unref0(var) ((var == NULL) ? NULL : (var = (publishing_rest_support_transaction_unref (var), NULL)))
typedef struct _PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData;
typedef struct _PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData;

struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction {
	PublishingRESTSupportOAuth1Transaction parent_instance;
	PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionPrivate * priv;
};

struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass {
	PublishingRESTSupportOAuth1TransactionClass parent_class;
};

struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction {
	PublishingRESTSupportOAuth1Transaction parent_instance;
	PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionPrivate * priv;
};

struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass {
	PublishingRESTSupportOAuth1TransactionClass parent_class;
};

struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPane {
	ShotwellPluginsCommonWebAuthenticationPane parent_instance;
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate * priv;
};

struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass {
	ShotwellPluginsCommonWebAuthenticationPaneClass parent_class;
};

struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate {
	gchar* auth_code;
};

struct _PublishingAuthenticatorShotwellOAuth1Authenticator {
	GObject parent_instance;
	PublishingAuthenticatorShotwellOAuth1AuthenticatorPrivate * priv;
	GHashTable* params;
	PublishingRESTSupportOAuth1Session* session;
	SpitPublishingPluginHost* host;
};

struct _PublishingAuthenticatorShotwellOAuth1AuthenticatorClass {
	GObjectClass parent_class;
	void (*authenticate) (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
	gboolean (*can_logout) (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
	void (*logout) (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
	void (*refresh) (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
	void (*set_accountname) (PublishingAuthenticatorShotwellOAuth1Authenticator* self, const gchar* name);
};

struct _PublishingAuthenticatorShotwellFlickrFlickr {
	PublishingAuthenticatorShotwellOAuth1Authenticator parent_instance;
	PublishingAuthenticatorShotwellFlickrFlickrPrivate * priv;
};

struct _PublishingAuthenticatorShotwellFlickrFlickrClass {
	PublishingAuthenticatorShotwellOAuth1AuthenticatorClass parent_class;
};

struct _PublishingAuthenticatorShotwellFlickrFlickrPrivate {
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* pane;
};

struct _PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PublishingAuthenticatorShotwellFlickrFlickr* self;
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* txn;
	PublishingRESTSupportOAuth1Session* _tmp2_;
	PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* err;
	SpitPublishingPluginHost* _tmp8_;
	GError* _tmp9_;
	GError* _inner_error0_;
};

struct _PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PublishingAuthenticatorShotwellFlickrFlickr* self;
	gchar* pin;
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* txn;
	PublishingRESTSupportOAuth1Session* _tmp2_;
	PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* err;
	SpitPublishingPluginHost* _tmp6_;
	GError* _tmp7_;
	GError* _inner_error0_;
};

static gpointer publishing_authenticator_shotwell_flickr_authentication_request_transaction_parent_class = NULL;
static gpointer publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_parent_class = NULL;
static gint PublishingAuthenticatorShotwellFlickrWebAuthenticationPane_private_offset;
static gpointer publishing_authenticator_shotwell_flickr_web_authentication_pane_parent_class = NULL;
static gint PublishingAuthenticatorShotwellFlickrFlickr_private_offset;
static gpointer publishing_authenticator_shotwell_flickr_flickr_parent_class = NULL;

VALA_EXTERN GType publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* publishing_authenticator_shotwell_flickr_authentication_request_transaction_new (PublishingRESTSupportOAuth1Session* session);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* publishing_authenticator_shotwell_flickr_authentication_request_transaction_construct (GType object_type,
                                                                                                                                                              PublishingRESTSupportOAuth1Session* session);
static GType publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type_once (void);
VALA_EXTERN GType publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_new (PublishingRESTSupportOAuth1Session* session,
                                                                                                                                               const gchar* user_verifier);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_construct (GType object_type,
                                                                                                                                                     PublishingRESTSupportOAuth1Session* session,
                                                                                                                                                     const gchar* user_verifier);
static GType publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type_once (void);
VALA_EXTERN GType publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* publishing_authenticator_shotwell_flickr_web_authentication_pane_new (const gchar* token);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* publishing_authenticator_shotwell_flickr_web_authentication_pane_construct (GType object_type,
                                                                                                                                        const gchar* token);
static void publishing_authenticator_shotwell_flickr_web_authentication_pane_real_constructed (GObject* base);
static void publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* self,
                                                                                                   WebKitURISchemeRequest* request);
static void _publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb_web_kit_uri_scheme_request_callback (WebKitURISchemeRequest* request,
                                                                                                                                        gpointer self);
static void publishing_authenticator_shotwell_flickr_web_authentication_pane_real_on_page_load (ShotwellPluginsCommonWebAuthenticationPane* base);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
static void publishing_authenticator_shotwell_flickr_web_authentication_pane_finalize (GObject * obj);
static GType publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type_once (void);
VALA_EXTERN GType publishing_authenticator_shotwell_oauth1_authenticator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType publishing_authenticator_shotwell_flickr_flickr_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void publishing_authenticator_shotwell_oauth1_authenticator_authenticate (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN gboolean publishing_authenticator_shotwell_oauth1_authenticator_can_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN void publishing_authenticator_shotwell_oauth1_authenticator_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN void publishing_authenticator_shotwell_oauth1_authenticator_refresh (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrFlickr* publishing_authenticator_shotwell_flickr_flickr_new (SpitPublishingPluginHost* host);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrFlickr* publishing_authenticator_shotwell_flickr_flickr_construct (GType object_type,
                                                                                                        SpitPublishingPluginHost* host);
VALA_EXTERN PublishingAuthenticatorShotwellOAuth1Authenticator* publishing_authenticator_shotwell_oauth1_authenticator_construct (GType object_type,
                                                                                                                      const gchar* service,
                                                                                                                      const gchar* api_key,
                                                                                                                      const gchar* api_secret,
                                                                                                                      SpitPublishingPluginHost* host);
static void publishing_authenticator_shotwell_flickr_flickr_real_authenticate (PublishingAuthenticatorShotwellOAuth1Authenticator* base);
VALA_EXTERN gboolean publishing_authenticator_shotwell_oauth1_authenticator_is_persistent_session_valid (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN gchar* publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_token (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN gchar* publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_token_secret (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN gchar* publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_username (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
static void publishing_authenticator_shotwell_flickr_flickr_do_show_login_welcome_pane (PublishingAuthenticatorShotwellFlickrFlickr* self);
static gboolean publishing_authenticator_shotwell_flickr_flickr_real_can_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* base);
static void publishing_authenticator_shotwell_flickr_flickr_real_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* base);
VALA_EXTERN void publishing_authenticator_shotwell_oauth1_authenticator_invalidate_persistent_session (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
static void publishing_authenticator_shotwell_flickr_flickr_real_refresh (PublishingAuthenticatorShotwellOAuth1Authenticator* base);
static void publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked (PublishingAuthenticatorShotwellFlickrFlickr* self);
static void _publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked_spit_publishing_login_callback (gpointer self);
static void publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                GAsyncReadyCallback _callback_,
                                                                                                gpointer _user_data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_finish (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                       GAsyncResult* _res_);
static void publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_data_free (gpointer _data);
static gboolean publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_co (PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_ready (GObject* source_object,
                                                                                                      GAsyncResult* _res_,
                                                                                                      gpointer _user_data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_parse_token_info_from_auth_request (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                            const gchar* response);
static void publishing_authenticator_shotwell_flickr_flickr_on_authentication_token_available (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                        const gchar* token,
                                                                                        const gchar* token_secret);
static void publishing_authenticator_shotwell_flickr_flickr_do_web_authentication (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                            const gchar* token);
static void __lambda4_ (PublishingAuthenticatorShotwellFlickrFlickr* self,
                 const gchar* pin);
static void publishing_authenticator_shotwell_flickr_flickr_do_verify_pin (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                    const gchar* pin,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_finish (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                           GAsyncResult* _res_);
static void ___lambda4__publishing_authenticator_shotwell_flickr_web_authentication_pane_authorized (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _sender,
                                                                                              const gchar* auth_code,
                                                                                              gpointer self);
static void publishing_authenticator_shotwell_flickr_flickr_on_web_login_error (PublishingAuthenticatorShotwellFlickrFlickr* self);
static void _publishing_authenticator_shotwell_flickr_flickr_on_web_login_error_publishing_authenticator_shotwell_flickr_web_authentication_pane_error (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _sender,
                                                                                                                                                 gpointer self);
static void publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_data_free (gpointer _data);
static gboolean publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_co (PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_ready (GObject* source_object,
                                                                          GAsyncResult* _res_,
                                                                          gpointer _user_data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_extract_access_phase_credentials_from_response (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                        const gchar* response);
static void publishing_authenticator_shotwell_flickr_flickr_finalize (GObject * obj);
static GType publishing_authenticator_shotwell_flickr_flickr_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction*
publishing_authenticator_shotwell_flickr_authentication_request_transaction_construct (GType object_type,
                                                                                       PublishingRESTSupportOAuth1Session* session)
{
	PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* self = NULL;
#line 21 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (session, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION), NULL);
#line 22 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction*) publishing_rest_support_oauth1_transaction_construct_with_uri (object_type, session, "https://www.flickr.com/services/oauth/request_token", PUBLISHING_REST_SUPPORT_HTTP_METHOD_GET);
#line 24 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_callback", "shotwell-auth://local-callback");
#line 21 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return self;
#line 327 "FlickrPublishingAuthenticator.c"
}

PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction*
publishing_authenticator_shotwell_flickr_authentication_request_transaction_new (PublishingRESTSupportOAuth1Session* session)
{
#line 21 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return publishing_authenticator_shotwell_flickr_authentication_request_transaction_construct (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION, session);
#line 335 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_authentication_request_transaction_class_init (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass * klass,
                                                                                        gpointer klass_data)
{
#line 20 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_authentication_request_transaction_parent_class = g_type_class_peek_parent (klass);
#line 344 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_authentication_request_transaction_instance_init (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction * self,
                                                                                           gpointer klass)
{
}

static GType
publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_authenticator_shotwell_flickr_authentication_request_transaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction), 0, (GInstanceInitFunc) publishing_authenticator_shotwell_flickr_authentication_request_transaction_instance_init, NULL };
	GType publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id;
	publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_TRANSACTION, "PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction", &g_define_type_info, 0);
	return publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id;
}

GType
publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type (void)
{
	static volatile gsize publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id__once = 0;
	if (g_once_init_enter (&publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id__once)) {
		GType publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id;
		publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id = publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type_once ();
		g_once_init_leave (&publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id__once, publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id);
	}
	return publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id__once;
}

PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction*
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_construct (GType object_type,
                                                                                   PublishingRESTSupportOAuth1Session* session,
                                                                                   const gchar* user_verifier)
{
	PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (session, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION), NULL);
#line 29 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_val_if_fail (user_verifier != NULL, NULL);
#line 30 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction*) publishing_rest_support_oauth1_transaction_construct_with_uri (object_type, session, "https://www.flickr.com/services/oauth/access_token", PUBLISHING_REST_SUPPORT_HTTP_METHOD_GET);
#line 32 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_verifier", user_verifier);
#line 33 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = publishing_rest_support_oauth1_session_get_request_phase_token (session);
#line 33 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = _tmp0_;
#line 33 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_token", _tmp1_);
#line 33 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (_tmp1_);
#line 34 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_callback", "shotwell-auth://local-callback");
#line 29 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return self;
#line 402 "FlickrPublishingAuthenticator.c"
}

PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction*
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_new (PublishingRESTSupportOAuth1Session* session,
                                                                             const gchar* user_verifier)
{
#line 29 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_construct (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION, session, user_verifier);
#line 411 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_class_init (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass * klass,
                                                                                    gpointer klass_data)
{
#line 28 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_parent_class = g_type_class_peek_parent (klass);
#line 420 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_instance_init (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction * self,
                                                                                       gpointer klass)
{
}

static GType
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction), 0, (GInstanceInitFunc) publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_instance_init, NULL };
	GType publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id;
	publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_TRANSACTION, "PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction", &g_define_type_info, 0);
	return publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id;
}

GType
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type (void)
{
	static volatile gsize publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id__once = 0;
	if (g_once_init_enter (&publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id__once)) {
		GType publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id;
		publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id = publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type_once ();
		g_once_init_leave (&publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id__once, publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id);
	}
	return publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id__once;
}

static inline gpointer
publishing_authenticator_shotwell_flickr_web_authentication_pane_get_instance_private (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane_private_offset);
}

PublishingAuthenticatorShotwellFlickrWebAuthenticationPane*
publishing_authenticator_shotwell_flickr_web_authentication_pane_construct (GType object_type,
                                                                            const gchar* token)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 45 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_val_if_fail (token != NULL, NULL);
#line 46 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = g_strdup_printf (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_LOGIN_URI, token);
#line 46 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = _tmp0_;
#line 46 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane*) g_object_new (object_type, "login-uri", _tmp1_, NULL);
#line 46 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (_tmp1_);
#line 45 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return self;
#line 475 "FlickrPublishingAuthenticator.c"
}

PublishingAuthenticatorShotwellFlickrWebAuthenticationPane*
publishing_authenticator_shotwell_flickr_web_authentication_pane_new (const gchar* token)
{
#line 45 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return publishing_authenticator_shotwell_flickr_web_authentication_pane_construct (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, token);
#line 483 "FlickrPublishingAuthenticator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return self ? g_object_ref (self) : NULL;
#line 491 "FlickrPublishingAuthenticator.c"
}

static void
_publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb_web_kit_uri_scheme_request_callback (WebKitURISchemeRequest* request,
                                                                                                                                   gpointer self)
{
#line 53 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb ((PublishingAuthenticatorShotwellFlickrWebAuthenticationPane*) self, request);
#line 500 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_real_constructed (GObject* base)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self;
	WebKitWebContext* ctx = NULL;
	WebKitWebContext* _tmp0_;
	WebKitWebContext* _tmp1_;
	WebKitSecurityManager* mgr = NULL;
	WebKitSecurityManager* _tmp2_;
	WebKitSecurityManager* _tmp3_;
#line 49 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane);
#line 50 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	G_OBJECT_CLASS (publishing_authenticator_shotwell_flickr_web_authentication_pane_parent_class)->constructed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane), G_TYPE_OBJECT, GObject));
#line 52 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = webkit_web_context_get_default ();
#line 52 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 52 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	ctx = _tmp1_;
#line 53 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	webkit_web_context_register_uri_scheme (ctx, "shotwell-auth", _publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb_web_kit_uri_scheme_request_callback, g_object_ref (self), g_object_unref);
#line 55 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp2_ = webkit_web_context_get_security_manager (ctx);
#line 55 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 55 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	mgr = _tmp3_;
#line 56 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	webkit_security_manager_register_uri_scheme_as_secure (mgr, "shotwell-auth");
#line 57 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	webkit_security_manager_register_uri_scheme_as_cors_enabled (mgr, "shotwell-auth");
#line 49 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_object_unref0 (mgr);
#line 49 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_object_unref0 (ctx);
#line 539 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_real_on_page_load (ShotwellPluginsCommonWebAuthenticationPane* base)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self;
	GError* _tmp0_;
	GError* _tmp1_;
	const gchar* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 60 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane);
#line 61 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = shotwell_plugins_common_web_authentication_pane_get_load_error (G_TYPE_CHECK_INSTANCE_CAST (self, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane));
#line 61 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = _tmp0_;
#line 61 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_tmp1_ != NULL) {
#line 62 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_signal_emit (self, publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_ERROR_SIGNAL], 0);
#line 64 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return;
#line 562 "FlickrPublishingAuthenticator.c"
	}
	{
		GUri* uri = NULL;
		WebKitWebView* _tmp2_;
		WebKitWebView* _tmp3_;
		const gchar* _tmp4_;
		GUri* _tmp5_;
		GUri* _tmp6_;
		gboolean _tmp7_ = FALSE;
		GUri* _tmp8_;
		const gchar* _tmp9_;
#line 68 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp2_ = shotwell_plugins_common_web_authentication_pane_get_view (G_TYPE_CHECK_INSTANCE_CAST (self, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane));
#line 68 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp3_ = _tmp2_;
#line 68 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp4_ = webkit_web_view_get_uri (_tmp3_);
#line 68 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp5_ = g_uri_parse (_tmp4_, G_URI_FLAGS_NONE, &_inner_error0_);
#line 68 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp6_ = _tmp5_;
#line 68 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_object_unref0 (_tmp3_);
#line 68 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		uri = _tmp6_;
#line 68 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 590 "FlickrPublishingAuthenticator.c"
			goto __catch0_g_error;
		}
#line 69 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp8_ = uri;
#line 69 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp9_ = g_uri_get_scheme (_tmp8_);
#line 69 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		if (g_strcmp0 (_tmp9_, "shotwell-auth") == 0) {
#line 599 "FlickrPublishingAuthenticator.c"
			const gchar* _tmp10_;
#line 69 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp10_ = self->priv->auth_code;
#line 69 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp7_ = _tmp10_ == NULL;
#line 605 "FlickrPublishingAuthenticator.c"
		} else {
#line 69 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp7_ = FALSE;
#line 609 "FlickrPublishingAuthenticator.c"
		}
#line 69 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		if (_tmp7_) {
#line 613 "FlickrPublishingAuthenticator.c"
			GHashTable* form_data = NULL;
			GUri* _tmp11_;
			const gchar* _tmp12_;
			GHashTable* _tmp13_;
			GHashTable* _tmp14_;
			gconstpointer _tmp15_;
			gchar* _tmp16_;
#line 70 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp11_ = uri;
#line 70 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp12_ = g_uri_get_query (_tmp11_);
#line 70 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp13_ = soup_form_decode (_tmp12_);
#line 70 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			form_data = _tmp13_;
#line 71 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp14_ = form_data;
#line 71 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp15_ = g_hash_table_lookup (_tmp14_, "oauth_verifier");
#line 71 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_tmp16_ = g_strdup ((const gchar*) _tmp15_);
#line 71 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_g_free0 (self->priv->auth_code);
#line 71 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			self->priv->auth_code = _tmp16_;
#line 69 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			_g_hash_table_unref0 (form_data);
#line 641 "FlickrPublishingAuthenticator.c"
		}
#line 67 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_uri_unref0 (uri);
#line 645 "FlickrPublishingAuthenticator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 67 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_clear_error (&_inner_error0_);
#line 74 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_signal_emit (self, publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_ERROR_SIGNAL], 0);
#line 76 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return;
#line 656 "FlickrPublishingAuthenticator.c"
	}
	__finally0:
#line 67 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_clear_error (&_inner_error0_);
#line 67 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return;
#line 667 "FlickrPublishingAuthenticator.c"
	}
#line 79 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp17_ = self->priv->auth_code;
#line 79 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_tmp17_ != NULL) {
#line 673 "FlickrPublishingAuthenticator.c"
		const gchar* _tmp18_;
#line 80 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp18_ = self->priv->auth_code;
#line 80 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_signal_emit (self, publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_AUTHORIZED_SIGNAL], 0, _tmp18_);
#line 679 "FlickrPublishingAuthenticator.c"
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1563 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1564 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1564 "glib-2.0.vapi"
	res_length1 = -1;
#line 1564 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1565 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1565 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1565 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1566 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1566 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1566 "glib-2.0.vapi"
	if (result_length1) {
#line 1566 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 717 "FlickrPublishingAuthenticator.c"
	}
#line 1566 "glib-2.0.vapi"
	result = _tmp2_;
#line 1566 "glib-2.0.vapi"
	return result;
#line 723 "FlickrPublishingAuthenticator.c"
}

static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (length > 0) {
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 734 "FlickrPublishingAuthenticator.c"
	}
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return NULL;
#line 738 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* self,
                                                                                              WebKitURISchemeRequest* request)
{
	gchar* response = NULL;
	gchar* _tmp10_;
	GMemoryInputStream* mins = NULL;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp12_ = 0;
	guint8* _tmp13_;
	gint _tmp13__length1;
	guint8* _tmp14_;
	gint _tmp14__length1;
	GDestroyNotify _tmp15_;
	GMemoryInputStream* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 84 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_WEB_AUTHENTICATION_PANE (self));
#line 84 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (request, webkit_uri_scheme_request_get_type ()));
#line 762 "FlickrPublishingAuthenticator.c"
	{
		GUri* uri = NULL;
		const gchar* _tmp0_;
		GUri* _tmp1_;
		GHashTable* form_data = NULL;
		const gchar* _tmp2_;
		GHashTable* _tmp3_;
		GHashTable* _tmp4_;
		gconstpointer _tmp5_;
		gchar* _tmp6_;
#line 86 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp0_ = webkit_uri_scheme_request_get_uri (request);
#line 86 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp1_ = g_uri_parse (_tmp0_, G_URI_FLAGS_NONE, &_inner_error0_);
#line 86 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		uri = _tmp1_;
#line 86 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 781 "FlickrPublishingAuthenticator.c"
			goto __catch0_g_error;
		}
#line 87 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp2_ = g_uri_get_query (uri);
#line 87 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp3_ = soup_form_decode (_tmp2_);
#line 87 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		form_data = _tmp3_;
#line 88 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp4_ = form_data;
#line 88 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp5_ = g_hash_table_lookup (_tmp4_, "oauth_verifier");
#line 88 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp6_ = g_strdup ((const gchar*) _tmp5_);
#line 88 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_free0 (self->priv->auth_code);
#line 88 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		self->priv->auth_code = _tmp6_;
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_hash_table_unref0 (form_data);
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_uri_unref0 (uri);
#line 804 "FlickrPublishingAuthenticator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		err = _inner_error0_;
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_inner_error0_ = NULL;
#line 90 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp7_ = webkit_uri_scheme_request_get_uri (request);
#line 90 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp8_ = err;
#line 90 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp9_ = _tmp8_->message;
#line 90 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_debug ("FlickrPublishingAuthenticator.vala:90: Failed to parse URI %s: %s", _tmp7_, _tmp9_);
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_error_free0 (err);
#line 827 "FlickrPublishingAuthenticator.c"
	}
	__finally0:
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return;
#line 838 "FlickrPublishingAuthenticator.c"
	}
#line 93 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp10_ = g_strdup ("");
#line 93 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	response = _tmp10_;
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp11_ = string_get_data (response, &_tmp12_);
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp11__length1 = _tmp12_;
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp13_ = _tmp11_;
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp13__length1 = _tmp11__length1;
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup1 (_tmp13_, _tmp13__length1) : _tmp13_;
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp14__length1 = _tmp13__length1;
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp15_ = g_free;
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp16_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp14_, _tmp14__length1, _tmp15_);
#line 94 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	mins = _tmp16_;
#line 95 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	webkit_uri_scheme_request_finish (request, G_TYPE_CHECK_INSTANCE_CAST (mins, g_input_stream_get_type (), GInputStream), (gint64) -1, "text/plain");
#line 84 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_object_unref0 (mins);
#line 84 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (response);
#line 868 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_class_init (PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass * klass,
                                                                             gpointer klass_data)
{
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_web_authentication_pane_parent_class = g_type_class_peek_parent (klass);
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_type_class_adjust_private_offset (klass, &PublishingAuthenticatorShotwellFlickrWebAuthenticationPane_private_offset);
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) publishing_authenticator_shotwell_flickr_web_authentication_pane_real_constructed;
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	((ShotwellPluginsCommonWebAuthenticationPaneClass *) klass)->on_page_load = (void (*) (ShotwellPluginsCommonWebAuthenticationPane*)) publishing_authenticator_shotwell_flickr_web_authentication_pane_real_on_page_load;
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	G_OBJECT_CLASS (klass)->finalize = publishing_authenticator_shotwell_flickr_web_authentication_pane_finalize;
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_AUTHORIZED_SIGNAL] = g_signal_new ("authorized", PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_ERROR_SIGNAL] = g_signal_new ("error", PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 889 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_instance_init (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self,
                                                                                gpointer klass)
{
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self->priv = publishing_authenticator_shotwell_flickr_web_authentication_pane_get_instance_private (self);
#line 39 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self->priv->auth_code = NULL;
#line 900 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_finalize (GObject * obj)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self;
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane);
#line 39 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (self->priv->auth_code);
#line 38 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	G_OBJECT_CLASS (publishing_authenticator_shotwell_flickr_web_authentication_pane_parent_class)->finalize (obj);
#line 913 "FlickrPublishingAuthenticator.c"
}

static GType
publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_authenticator_shotwell_flickr_web_authentication_pane_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane), 0, (GInstanceInitFunc) publishing_authenticator_shotwell_flickr_web_authentication_pane_instance_init, NULL };
	GType publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id;
	publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id = g_type_register_static (SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, "PublishingAuthenticatorShotwellFlickrWebAuthenticationPane", &g_define_type_info, 0);
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane_private_offset = g_type_add_instance_private (publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id, sizeof (PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate));
	return publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id;
}

GType
publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type (void)
{
	static volatile gsize publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id__once = 0;
	if (g_once_init_enter (&publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id__once)) {
		GType publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id;
		publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id = publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type_once ();
		g_once_init_leave (&publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id__once, publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id);
	}
	return publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id__once;
}

static inline gpointer
publishing_authenticator_shotwell_flickr_flickr_get_instance_private (PublishingAuthenticatorShotwellFlickrFlickr* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingAuthenticatorShotwellFlickrFlickr_private_offset);
}

PublishingAuthenticatorShotwellFlickrFlickr*
publishing_authenticator_shotwell_flickr_flickr_construct (GType object_type,
                                                           SpitPublishingPluginHost* host)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self = NULL;
#line 102 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (host, SPIT_PUBLISHING_TYPE_PLUGIN_HOST), NULL);
#line 103 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = (PublishingAuthenticatorShotwellFlickrFlickr*) publishing_authenticator_shotwell_oauth1_authenticator_construct (object_type, "Flickr", PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_API_KEY, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_API_SECRET, host);
#line 102 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return self;
#line 955 "FlickrPublishingAuthenticator.c"
}

PublishingAuthenticatorShotwellFlickrFlickr*
publishing_authenticator_shotwell_flickr_flickr_new (SpitPublishingPluginHost* host)
{
#line 102 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return publishing_authenticator_shotwell_flickr_flickr_construct (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, host);
#line 963 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_real_authenticate (PublishingAuthenticatorShotwellOAuth1Authenticator* base)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
#line 106 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
#line 107 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (publishing_authenticator_shotwell_oauth1_authenticator_is_persistent_session_valid (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator))) {
#line 974 "FlickrPublishingAuthenticator.c"
		PublishingRESTSupportOAuth1Session* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 108 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_debug ("FlickrPublishingAuthenticator.vala:108: attempt start: a persistent se" \
"ssion is available; using it");
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp1_ = publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_token (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator));
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp2_ = _tmp1_;
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp3_ = publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_token_secret (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator));
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp4_ = _tmp3_;
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp5_ = publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_username (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator));
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp6_ = _tmp5_;
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_rest_support_oauth1_session_authenticate_from_persistent_credentials (_tmp0_, _tmp2_, _tmp4_, _tmp6_);
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_free0 (_tmp6_);
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_free0 (_tmp4_);
#line 110 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_free0 (_tmp2_);
#line 1006 "FlickrPublishingAuthenticator.c"
	} else {
#line 113 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_debug ("FlickrPublishingAuthenticator.vala:113: attempt start: no persistent s" \
"ession available; showing login welcome pane");
#line 114 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_authenticator_shotwell_flickr_flickr_do_show_login_welcome_pane (self);
#line 1012 "FlickrPublishingAuthenticator.c"
	}
}

static gboolean
publishing_authenticator_shotwell_flickr_flickr_real_can_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* base)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
	gboolean result;
#line 118 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
#line 119 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	result = TRUE;
#line 119 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return result;
#line 1027 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_real_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* base)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
	PublishingRESTSupportOAuth1Session* _tmp0_;
#line 122 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
#line 123 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
#line 123 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_rest_support_oauth1_session_deauthenticate (_tmp0_);
#line 124 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_oauth1_authenticator_invalidate_persistent_session (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator));
#line 1043 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_real_refresh (PublishingAuthenticatorShotwellOAuth1Authenticator* base)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
#line 127 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
#line 1052 "FlickrPublishingAuthenticator.c"
}

static void
_publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked_spit_publishing_login_callback (gpointer self)
{
#line 135 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked ((PublishingAuthenticatorShotwellFlickrFlickr*) self);
#line 1060 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_show_login_welcome_pane (PublishingAuthenticatorShotwellFlickrFlickr* self)
{
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 131 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 132 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_debug ("FlickrPublishingAuthenticator.vala:132: ACTION: installing login welco" \
"me pane");
#line 134 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 134 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	spit_publishing_plugin_host_set_service_locked (_tmp0_, FALSE);
#line 135 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 135 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp2_ = g_strdup_printf ("%s\n\n%s", PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_SERVICE_WELCOME_MESSAGE, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_SERVICE_DISCLAIMER);
#line 135 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp3_ = _tmp2_;
#line 135 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	spit_publishing_plugin_host_install_welcome_pane (_tmp1_, _tmp3_, _publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked_spit_publishing_login_callback, self);
#line 135 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (_tmp3_);
#line 1088 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked (PublishingAuthenticatorShotwellFlickrFlickr* self)
{
#line 138 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 139 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_debug ("FlickrPublishingAuthenticator.vala:139: EVENT: user clicked 'Login' bu" \
"tton in the welcome pane");
#line 141 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction (self, NULL, NULL);
#line 1100 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_data_free (gpointer _data)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_;
	_data_ = _data;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_object_unref0 (_data_->self);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_slice_free (PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData, _data_);
#line 1112 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                           GAsyncReadyCallback _callback_,
                                                                                           gpointer _user_data_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_;
	PublishingAuthenticatorShotwellFlickrFlickr* _tmp0_;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_ = g_slice_new0 (PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_data_free);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->self = _tmp0_;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_co (_data_);
#line 1136 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_finish (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                  GAsyncResult* _res_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1146 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_ready (GObject* source_object,
                                                                                                 GAsyncResult* _res_,
                                                                                                 gpointer _user_data_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_;
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_ = _user_data_;
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_source_object_ = source_object;
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_res_ = _res_;
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_co (_data_);
#line 1163 "FlickrPublishingAuthenticator.c"
}

static gboolean
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_co (PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_)
{
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	switch (_data_->_state_) {
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		case 0:
#line 1173 "FlickrPublishingAuthenticator.c"
		goto _state_0;
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		case 1:
#line 1177 "FlickrPublishingAuthenticator.c"
		goto _state_1;
		default:
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_assert_not_reached ();
#line 1182 "FlickrPublishingAuthenticator.c"
	}
	_state_0:
#line 145 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_debug ("FlickrPublishingAuthenticator.vala:145: ACTION: running authentication" \
" request transaction");
#line 147 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 147 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	spit_publishing_plugin_host_set_service_locked (_data_->_tmp0_, TRUE);
#line 148 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 148 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	spit_publishing_plugin_host_install_static_message_pane (_data_->_tmp1_, _ ("Preparing for login…"), SPIT_PUBLISHING_PLUGIN_HOST_BUTTON_MODE_CANCEL);
#line 150 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
#line 150 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_tmp3_ = publishing_authenticator_shotwell_flickr_authentication_request_transaction_new (_data_->_tmp2_);
#line 150 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->txn = _data_->_tmp3_;
#line 1201 "FlickrPublishingAuthenticator.c"
	{
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_state_ = 1;
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_rest_support_transaction_execute_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_ready, _data_);
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return FALSE;
#line 1209 "FlickrPublishingAuthenticator.c"
		_state_1:
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_rest_support_transaction_execute_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), _data_->_res_, &_data_->_inner_error0_);
#line 152 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1215 "FlickrPublishingAuthenticator.c"
			goto __catch0_g_error;
		}
#line 153 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp4_ = publishing_rest_support_transaction_get_response (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
#line 153 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 153 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_debug ("FlickrPublishingAuthenticator.vala:153: EVENT: OAuth authentication re" \
"quest transaction completed; response = '%s'", _data_->_tmp5_);
#line 153 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_free0 (_data_->_tmp5_);
#line 155 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp6_ = publishing_rest_support_transaction_get_response (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
#line 155 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 155 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_authenticator_shotwell_flickr_flickr_do_parse_token_info_from_auth_request (_data_->self, _data_->_tmp7_);
#line 155 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_free0 (_data_->_tmp7_);
#line 1234 "FlickrPublishingAuthenticator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->err = _data_->_inner_error0_;
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_inner_error0_ = NULL;
#line 157 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_debug ("FlickrPublishingAuthenticator.vala:157: EVENT: OAuth authentication re" \
"quest transaction caused a network error");
#line 158 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 158 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp9_ = _data_->err;
#line 158 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		spit_publishing_plugin_host_post_error (_data_->_tmp8_, _data_->_tmp9_);
#line 160 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, SPIT_PUBLISHING_TYPE_AUTHENTICATOR, SpitPublishingAuthenticator), "authentication-failed");
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_error_free0 (_data_->err);
#line 1255 "FlickrPublishingAuthenticator.c"
	}
	__finally0:
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_publishing_rest_support_transaction_unref0 (_data_->txn);
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_object_unref (_data_->_async_result);
#line 151 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return FALSE;
#line 1270 "FlickrPublishingAuthenticator.c"
	}
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_publishing_rest_support_transaction_unref0 (_data_->txn);
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_data_->_state_ != 0) {
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1282 "FlickrPublishingAuthenticator.c"
		}
	}
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_object_unref (_data_->_async_result);
#line 144 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return FALSE;
#line 1289 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_parse_token_info_from_auth_request (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                       const gchar* response)
{
	gchar* oauth_token = NULL;
	gchar* oauth_token_secret = NULL;
	GHashTable* data = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_ = NULL;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_ = NULL;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
#line 164 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 164 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (response != NULL);
#line 165 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_debug ("FlickrPublishingAuthenticator.vala:165: ACTION: parsing authorization " \
"request response '%s' into token and secret", response);
#line 167 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	oauth_token = NULL;
#line 168 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	oauth_token_secret = NULL;
#line 170 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = soup_form_decode (response);
#line 170 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	data = _tmp0_;
#line 171 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = data;
#line 171 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_hash_table_lookup_extended (_tmp1_, "oauth_token", NULL, &_tmp2_);
#line 171 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (oauth_token);
#line 171 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 171 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	oauth_token = _tmp3_;
#line 172 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp4_ = data;
#line 172 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_hash_table_lookup_extended (_tmp4_, "oauth_token_secret", NULL, &_tmp5_);
#line 172 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (oauth_token_secret);
#line 172 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp6_ = g_strdup ((const gchar*) _tmp5_);
#line 172 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	oauth_token_secret = _tmp6_;
#line 174 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp8_ = oauth_token;
#line 174 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_tmp8_ == NULL) {
#line 174 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp7_ = TRUE;
#line 1350 "FlickrPublishingAuthenticator.c"
	} else {
		const gchar* _tmp9_;
#line 174 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp9_ = oauth_token_secret;
#line 174 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp7_ = _tmp9_ == NULL;
#line 1357 "FlickrPublishingAuthenticator.c"
	}
#line 174 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_tmp7_) {
#line 1361 "FlickrPublishingAuthenticator.c"
		SpitPublishingPluginHost* _tmp10_;
		GError* _tmp11_;
		GError* _tmp12_;
#line 175 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 175 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp11_ = g_error_new (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_MALFORMED_RESPONSE, "'%s' isn't a valid response to an OAuth authentication request", response);
#line 175 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp12_ = _tmp11_;
#line 175 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		spit_publishing_plugin_host_post_error (_tmp10_, _tmp12_);
#line 175 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_error_free0 (_tmp12_);
#line 1375 "FlickrPublishingAuthenticator.c"
	}
#line 179 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp13_ = oauth_token;
#line 179 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp14_ = oauth_token_secret;
#line 179 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_on_authentication_token_available (self, _tmp13_, _tmp14_);
#line 164 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_hash_table_unref0 (data);
#line 164 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (oauth_token_secret);
#line 164 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (oauth_token);
#line 1389 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_on_authentication_token_available (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                   const gchar* token,
                                                                                   const gchar* token_secret)
{
	PublishingRESTSupportOAuth1Session* _tmp0_;
#line 182 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 182 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (token != NULL);
#line 182 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (token_secret != NULL);
#line 183 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_debug ("FlickrPublishingAuthenticator.vala:183: EVENT: OAuth authentication to" \
"ken (%s) and token secret (%s) available", token, token_secret);
#line 186 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
#line 186 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_rest_support_oauth1_session_set_request_phase_credentials (_tmp0_, token, token_secret);
#line 188 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_do_web_authentication (self, token);
#line 1412 "FlickrPublishingAuthenticator.c"
}

static void
__lambda4_ (PublishingAuthenticatorShotwellFlickrFlickr* self,
            const gchar* pin)
{
#line 194 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (pin != NULL);
#line 194 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_do_verify_pin (self, pin, NULL, NULL);
#line 1423 "FlickrPublishingAuthenticator.c"
}

static void
___lambda4__publishing_authenticator_shotwell_flickr_web_authentication_pane_authorized (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _sender,
                                                                                         const gchar* auth_code,
                                                                                         gpointer self)
{
#line 194 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	__lambda4_ ((PublishingAuthenticatorShotwellFlickrFlickr*) self, auth_code);
#line 1433 "FlickrPublishingAuthenticator.c"
}

static void
_publishing_authenticator_shotwell_flickr_flickr_on_web_login_error_publishing_authenticator_shotwell_flickr_web_authentication_pane_error (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _sender,
                                                                                                                                            gpointer self)
{
#line 195 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_on_web_login_error ((PublishingAuthenticatorShotwellFlickrFlickr*) self);
#line 1442 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_web_authentication (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                       const gchar* token)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp2_;
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp3_;
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp4_;
#line 191 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 191 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (token != NULL);
#line 192 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = publishing_authenticator_shotwell_flickr_web_authentication_pane_new (token);
#line 192 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_object_unref0 (self->priv->pane);
#line 192 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self->priv->pane = _tmp0_;
#line 193 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 193 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp2_ = self->priv->pane;
#line 193 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	spit_publishing_plugin_host_install_dialog_pane (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SPIT_PUBLISHING_TYPE_DIALOG_PANE, SpitPublishingDialogPane), SPIT_PUBLISHING_PLUGIN_HOST_BUTTON_MODE_CANCEL);
#line 194 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp3_ = self->priv->pane;
#line 194 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_signal_connect_object (_tmp3_, "authorized", (GCallback) ___lambda4__publishing_authenticator_shotwell_flickr_web_authentication_pane_authorized, self, 0);
#line 195 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp4_ = self->priv->pane;
#line 195 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_signal_connect_object (_tmp4_, "error", (GCallback) _publishing_authenticator_shotwell_flickr_flickr_on_web_login_error_publishing_authenticator_shotwell_flickr_web_authentication_pane_error, self, 0);
#line 1478 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_on_web_login_error (PublishingAuthenticatorShotwellFlickrFlickr* self)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp0_;
	GError* _tmp1_;
	GError* _tmp2_;
	SpitPublishingPluginHost* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
#line 198 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 199 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = self->priv->pane;
#line 199 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = shotwell_plugins_common_web_authentication_pane_get_load_error (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane));
#line 199 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp2_ = _tmp1_;
#line 199 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_tmp2_ != NULL) {
#line 1500 "FlickrPublishingAuthenticator.c"
		SpitPublishingPluginHost* _tmp3_;
		PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 200 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 200 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp4_ = self->priv->pane;
#line 200 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp5_ = shotwell_plugins_common_web_authentication_pane_get_load_error (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane));
#line 200 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp6_ = _tmp5_;
#line 200 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		spit_publishing_plugin_host_post_error (_tmp3_, _tmp6_);
#line 201 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return;
#line 1517 "FlickrPublishingAuthenticator.c"
	}
#line 203 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 203 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp8_ = g_error_new_literal (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_PROTOCOL_ERROR, _ ("Flickr authorization failed"));
#line 203 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp9_ = _tmp8_;
#line 203 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	spit_publishing_plugin_host_post_error (_tmp7_, _tmp9_);
#line 203 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_error_free0 (_tmp9_);
#line 1529 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_data_free (gpointer _data)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_;
	_data_ = _data;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (_data_->pin);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_object_unref0 (_data_->self);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_slice_free (PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData, _data_);
#line 1543 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                               const gchar* pin,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_;
	PublishingAuthenticatorShotwellFlickrFlickr* _tmp0_;
	gchar* _tmp1_;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (pin != NULL);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_ = g_slice_new0 (PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_data_free);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->self = _tmp0_;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = g_strdup (pin);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (_data_->pin);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->pin = _tmp1_;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_co (_data_);
#line 1577 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_finish (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                      GAsyncResult* _res_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1587 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_;
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_ = _user_data_;
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_source_object_ = source_object;
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_res_ = _res_;
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_co (_data_);
#line 1604 "FlickrPublishingAuthenticator.c"
}

static gboolean
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_co (PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_)
{
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	switch (_data_->_state_) {
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		case 0:
#line 1614 "FlickrPublishingAuthenticator.c"
		goto _state_0;
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		case 1:
#line 1618 "FlickrPublishingAuthenticator.c"
		goto _state_1;
		default:
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_assert_not_reached ();
#line 1623 "FlickrPublishingAuthenticator.c"
	}
	_state_0:
#line 207 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_debug ("FlickrPublishingAuthenticator.vala:207: ACTION: validating authorizati" \
"on PIN %s", _data_->pin);
#line 209 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 209 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	spit_publishing_plugin_host_set_service_locked (_data_->_tmp0_, TRUE);
#line 210 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 210 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	spit_publishing_plugin_host_install_static_message_pane (_data_->_tmp1_, _ ("Verifying authorization…"), SPIT_PUBLISHING_PLUGIN_HOST_BUTTON_MODE_CANCEL);
#line 212 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
#line 212 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->_tmp3_ = publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_new (_data_->_tmp2_, _data_->pin);
#line 212 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_data_->txn = _data_->_tmp3_;
#line 1642 "FlickrPublishingAuthenticator.c"
	{
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_state_ = 1;
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_rest_support_transaction_execute_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_ready, _data_);
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return FALSE;
#line 1650 "FlickrPublishingAuthenticator.c"
		_state_1:
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_rest_support_transaction_execute_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), _data_->_res_, &_data_->_inner_error0_);
#line 215 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1656 "FlickrPublishingAuthenticator.c"
			goto __catch0_g_error;
		}
#line 216 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_debug ("FlickrPublishingAuthenticator.vala:216: EVENT: fetching OAuth access t" \
"oken over the network succeeded");
#line 218 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp4_ = publishing_rest_support_transaction_get_response (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
#line 218 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 218 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_authenticator_shotwell_flickr_flickr_do_extract_access_phase_credentials_from_response (_data_->self, _data_->_tmp5_);
#line 218 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_free0 (_data_->_tmp5_);
#line 1669 "FlickrPublishingAuthenticator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->err = _data_->_inner_error0_;
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_inner_error0_ = NULL;
#line 220 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_debug ("FlickrPublishingAuthenticator.vala:220: EVENT: fetching OAuth access t" \
"oken over the network caused an error.");
#line 222 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 222 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_data_->_tmp7_ = _data_->err;
#line 222 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		spit_publishing_plugin_host_post_error (_data_->_tmp6_, _data_->_tmp7_);
#line 223 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, SPIT_PUBLISHING_TYPE_AUTHENTICATOR, SpitPublishingAuthenticator), "authentication-failed");
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_error_free0 (_data_->err);
#line 1690 "FlickrPublishingAuthenticator.c"
	}
	__finally0:
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_publishing_rest_support_transaction_unref0 (_data_->txn);
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_object_unref (_data_->_async_result);
#line 214 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		return FALSE;
#line 1705 "FlickrPublishingAuthenticator.c"
	}
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_publishing_rest_support_transaction_unref0 (_data_->txn);
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_data_->_state_ != 0) {
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1717 "FlickrPublishingAuthenticator.c"
		}
	}
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_object_unref (_data_->_async_result);
#line 206 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	return FALSE;
#line 1724 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_extract_access_phase_credentials_from_response (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                   const gchar* response)
{
	gchar* token = NULL;
	gchar* token_secret = NULL;
	gchar* username = NULL;
	GHashTable* data = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_ = NULL;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_ = NULL;
	gchar* _tmp6_;
	GHashTable* _tmp7_;
	gconstpointer _tmp8_ = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
#line 227 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
#line 227 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_return_if_fail (response != NULL);
#line 228 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_debug ("FlickrPublishingAuthenticator.vala:228: ACTION: extracting access phas" \
"e credentials from '%s'", response);
#line 230 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	token = NULL;
#line 231 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	token_secret = NULL;
#line 232 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	username = NULL;
#line 234 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp0_ = soup_form_decode (response);
#line 234 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	data = _tmp0_;
#line 235 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp1_ = data;
#line 235 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_hash_table_lookup_extended (_tmp1_, "oauth_token", NULL, &_tmp2_);
#line 235 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (token);
#line 235 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 235 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	token = _tmp3_;
#line 236 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp4_ = data;
#line 236 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_hash_table_lookup_extended (_tmp4_, "oauth_token_secret", NULL, &_tmp5_);
#line 236 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (token_secret);
#line 236 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp6_ = g_strdup ((const gchar*) _tmp5_);
#line 236 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	token_secret = _tmp6_;
#line 237 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp7_ = data;
#line 237 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_hash_table_lookup_extended (_tmp7_, "username", NULL, &_tmp8_);
#line 237 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (username);
#line 237 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 237 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	username = _tmp9_;
#line 239 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp10_ = token;
#line 239 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp11_ = token_secret;
#line 239 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp12_ = username;
#line 239 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_debug ("FlickrPublishingAuthenticator.vala:239: access phase credentials: { to" \
"ken = '%s'; token_secret = '%s'; username = '%s' }", _tmp10_, _tmp11_, _tmp12_);
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_tmp15_ = token;
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_tmp15_ == NULL) {
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp14_ = TRUE;
#line 1811 "FlickrPublishingAuthenticator.c"
	} else {
		const gchar* _tmp16_;
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp16_ = token_secret;
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp14_ = _tmp16_ == NULL;
#line 1818 "FlickrPublishingAuthenticator.c"
	}
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_tmp14_) {
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp13_ = TRUE;
#line 1824 "FlickrPublishingAuthenticator.c"
	} else {
		const gchar* _tmp17_;
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp17_ = username;
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp13_ = _tmp17_ == NULL;
#line 1831 "FlickrPublishingAuthenticator.c"
	}
#line 242 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	if (_tmp13_) {
#line 1835 "FlickrPublishingAuthenticator.c"
		SpitPublishingPluginHost* _tmp18_;
		GError* _tmp19_;
		GError* _tmp20_;
#line 243 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
#line 243 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp19_ = g_error_new_literal (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_MALFORMED_RESPONSE, "expected " "access phase credentials to contain token, token secret, and username " \
"but at " "least one of these is absent");
#line 243 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp20_ = _tmp19_;
#line 243 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		spit_publishing_plugin_host_post_error (_tmp18_, _tmp20_);
#line 243 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_g_error_free0 (_tmp20_);
#line 246 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_AUTHENTICATOR, SpitPublishingAuthenticator), "authentication-failed");
#line 1851 "FlickrPublishingAuthenticator.c"
	} else {
		PublishingRESTSupportOAuth1Session* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
#line 248 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp21_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
#line 248 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp22_ = token;
#line 248 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp23_ = token_secret;
#line 248 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		_tmp24_ = username;
#line 248 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
		publishing_rest_support_oauth1_session_set_access_phase_credentials (_tmp21_, _tmp22_, _tmp23_, _tmp24_);
#line 1867 "FlickrPublishingAuthenticator.c"
	}
#line 227 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_hash_table_unref0 (data);
#line 227 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (username);
#line 227 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (token_secret);
#line 227 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_free0 (token);
#line 1877 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_class_init (PublishingAuthenticatorShotwellFlickrFlickrClass * klass,
                                                            gpointer klass_data)
{
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	publishing_authenticator_shotwell_flickr_flickr_parent_class = g_type_class_peek_parent (klass);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	g_type_class_adjust_private_offset (klass, &PublishingAuthenticatorShotwellFlickrFlickr_private_offset);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	((PublishingAuthenticatorShotwellOAuth1AuthenticatorClass *) klass)->authenticate = (void (*) (PublishingAuthenticatorShotwellOAuth1Authenticator*)) publishing_authenticator_shotwell_flickr_flickr_real_authenticate;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	((PublishingAuthenticatorShotwellOAuth1AuthenticatorClass *) klass)->can_logout = (gboolean (*) (PublishingAuthenticatorShotwellOAuth1Authenticator*)) publishing_authenticator_shotwell_flickr_flickr_real_can_logout;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	((PublishingAuthenticatorShotwellOAuth1AuthenticatorClass *) klass)->logout = (void (*) (PublishingAuthenticatorShotwellOAuth1Authenticator*)) publishing_authenticator_shotwell_flickr_flickr_real_logout;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	((PublishingAuthenticatorShotwellOAuth1AuthenticatorClass *) klass)->refresh = (void (*) (PublishingAuthenticatorShotwellOAuth1Authenticator*)) publishing_authenticator_shotwell_flickr_flickr_real_refresh;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	G_OBJECT_CLASS (klass)->finalize = publishing_authenticator_shotwell_flickr_flickr_finalize;
#line 1898 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_instance_init (PublishingAuthenticatorShotwellFlickrFlickr * self,
                                                               gpointer klass)
{
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self->priv = publishing_authenticator_shotwell_flickr_flickr_get_instance_private (self);
#line 1907 "FlickrPublishingAuthenticator.c"
}

static void
publishing_authenticator_shotwell_flickr_flickr_finalize (GObject * obj)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
#line 100 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	_g_object_unref0 (self->priv->pane);
#line 99 "../plugins/authenticator/shotwell/FlickrPublishingAuthenticator.vala"
	G_OBJECT_CLASS (publishing_authenticator_shotwell_flickr_flickr_parent_class)->finalize (obj);
#line 1920 "FlickrPublishingAuthenticator.c"
}

static GType
publishing_authenticator_shotwell_flickr_flickr_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingAuthenticatorShotwellFlickrFlickrClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_authenticator_shotwell_flickr_flickr_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingAuthenticatorShotwellFlickrFlickr), 0, (GInstanceInitFunc) publishing_authenticator_shotwell_flickr_flickr_instance_init, NULL };
	GType publishing_authenticator_shotwell_flickr_flickr_type_id;
	publishing_authenticator_shotwell_flickr_flickr_type_id = g_type_register_static (PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, "PublishingAuthenticatorShotwellFlickrFlickr", &g_define_type_info, 0);
	PublishingAuthenticatorShotwellFlickrFlickr_private_offset = g_type_add_instance_private (publishing_authenticator_shotwell_flickr_flickr_type_id, sizeof (PublishingAuthenticatorShotwellFlickrFlickrPrivate));
	return publishing_authenticator_shotwell_flickr_flickr_type_id;
}

GType
publishing_authenticator_shotwell_flickr_flickr_get_type (void)
{
	static volatile gsize publishing_authenticator_shotwell_flickr_flickr_type_id__once = 0;
	if (g_once_init_enter (&publishing_authenticator_shotwell_flickr_flickr_type_id__once)) {
		GType publishing_authenticator_shotwell_flickr_flickr_type_id;
		publishing_authenticator_shotwell_flickr_flickr_type_id = publishing_authenticator_shotwell_flickr_flickr_get_type_once ();
		g_once_init_leave (&publishing_authenticator_shotwell_flickr_flickr_type_id__once, publishing_authenticator_shotwell_flickr_flickr_type_id);
	}
	return publishing_authenticator_shotwell_flickr_flickr_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

