/* Box.c generated by valac 0.56.13, the Vala compiler
 * generated from Box.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>

#define BOX_HAND_GRENADES 12
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;

#define TYPE_BOX_LOCATION (box_location_get_type ())
typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;

#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _Dimensions {
	gint width;
	gint height;
};

VALA_EXTERN GType box_location_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType box_complements_get_type (void) G_GNUC_CONST ;
VALA_EXTERN BoxComplements box_complements_derive (gboolean horizontal_complement,
                                       gboolean vertical_complement);
VALA_EXTERN GType box_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Box* box_dup (const Box* self);
VALA_EXTERN void box_free (Box* self);
VALA_EXTERN void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
VALA_EXTERN void box_from_rectangle (GdkRectangle* rect,
                         Box* result);
VALA_EXTERN void box_from_allocation (GtkAllocation* alloc,
                          Box* result);
VALA_EXTERN void box_from_points (GdkPoint* corner1,
                      GdkPoint* corner2,
                      Box* result);
VALA_EXTERN void box_from_center (GdkPoint* center,
                      gint width,
                      gint height,
                      Box* result);
VALA_EXTERN gint box_get_width (Box *self);
VALA_EXTERN gint box_get_height (Box *self);
VALA_EXTERN gboolean box_is_valid (Box *self);
VALA_EXTERN gboolean box_equals (Box *self,
                     Box* box);
VALA_EXTERN void box_adjust_width (Box *self,
                       gint width);
VALA_EXTERN void box_adjust_height (Box *self,
                        gint height);
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
VALA_EXTERN void box_get_dimensions (Box *self,
                         Dimensions* result);
VALA_EXTERN void dimensions_get_scale_ratios (Dimensions *self,
                                  Dimensions* scaled,
                                  gdouble* width_ratio,
                                  gdouble* height_ratio);
VALA_EXTERN void box_get_scaled_similar (Box *self,
                             Dimensions* original,
                             Dimensions* scaled,
                             Box* result);
VALA_EXTERN void box_get_offset (Box *self,
                     gint xofs,
                     gint yofs,
                     Box* result);
VALA_EXTERN void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
VALA_EXTERN void box_get_points (Box *self,
                     GdkPoint* top_left,
                     GdkPoint* bottom_right);
VALA_EXTERN void box_get_rectangle (Box *self,
                        GdkRectangle* result);
VALA_EXTERN void box_get_center (Box *self,
                     GdkPoint* result);
VALA_EXTERN void box_rotate_clockwise (Box *self,
                           Dimensions* space,
                           Box* result);
VALA_EXTERN void box_rotate_counterclockwise (Box *self,
                                  Dimensions* space,
                                  Box* result);
VALA_EXTERN void box_flip_left_to_right (Box *self,
                             Dimensions* space,
                             Box* result);
VALA_EXTERN void box_flip_top_to_bottom (Box *self,
                             Dimensions* space,
                             Box* result);
VALA_EXTERN gboolean box_intersects (Box *self,
                         Box* compare);
VALA_EXTERN void box_get_reduced (Box *self,
                      gint amount,
                      Box* result);
VALA_EXTERN void box_get_expanded (Box *self,
                       gint amount,
                       Box* result);
VALA_EXTERN gboolean box_contains (Box *self,
                       GdkPoint* point);
VALA_EXTERN BoxComplements box_resized_complements (Box *self,
                                        Box* resized,
                                        Box* horizontal,
                                        gboolean* horizontal_enlarged,
                                        Box* vertical,
                                        gboolean* vertical_enlarged);
VALA_EXTERN BoxComplements box_shifted_complements (Box *self,
                                        Box* shifted,
                                        Box* horizontal_this,
                                        Box* vertical_this,
                                        Box* horizontal_shifted,
                                        Box* vertical_shifted);
VALA_EXTERN void box_rubber_band (Box *self,
                      GdkPoint* point,
                      Box* result);
VALA_EXTERN gchar* box_to_string (Box *self);
VALA_EXTERN gchar* dimensions_to_string (Dimensions *self);
static gboolean box_in_zone (gdouble pos,
                      gint zone);
static gboolean box_in_between (gdouble pos,
                         gint top,
                         gint bottom);
static gboolean box_near_in_between (gdouble pos,
                              gint top,
                              gint bottom);
VALA_EXTERN BoxLocation box_approx_location (Box *self,
                                 gint x,
                                 gint y);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
box_location_get_type_once (void)
{
	static const GEnumValue values[] = {{BOX_LOCATION_OUTSIDE, "BOX_LOCATION_OUTSIDE", "outside"}, {BOX_LOCATION_INSIDE, "BOX_LOCATION_INSIDE", "inside"}, {BOX_LOCATION_TOP_SIDE, "BOX_LOCATION_TOP_SIDE", "top-side"}, {BOX_LOCATION_LEFT_SIDE, "BOX_LOCATION_LEFT_SIDE", "left-side"}, {BOX_LOCATION_RIGHT_SIDE, "BOX_LOCATION_RIGHT_SIDE", "right-side"}, {BOX_LOCATION_BOTTOM_SIDE, "BOX_LOCATION_BOTTOM_SIDE", "bottom-side"}, {BOX_LOCATION_TOP_LEFT, "BOX_LOCATION_TOP_LEFT", "top-left"}, {BOX_LOCATION_BOTTOM_LEFT, "BOX_LOCATION_BOTTOM_LEFT", "bottom-left"}, {BOX_LOCATION_TOP_RIGHT, "BOX_LOCATION_TOP_RIGHT", "top-right"}, {BOX_LOCATION_BOTTOM_RIGHT, "BOX_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
	GType box_location_type_id;
	box_location_type_id = g_enum_register_static ("BoxLocation", values);
	return box_location_type_id;
}

GType
box_location_get_type (void)
{
	static volatile gsize box_location_type_id__once = 0;
	if (g_once_init_enter (&box_location_type_id__once)) {
		GType box_location_type_id;
		box_location_type_id = box_location_get_type_once ();
		g_once_init_leave (&box_location_type_id__once, box_location_type_id);
	}
	return box_location_type_id__once;
}

BoxComplements
box_complements_derive (gboolean horizontal_complement,
                        gboolean vertical_complement)
{
	gboolean _tmp0_ = FALSE;
	BoxComplements result;
#line 27 "../src/Box.vala"
	if (horizontal_complement) {
#line 27 "../src/Box.vala"
		_tmp0_ = vertical_complement;
#line 224 "Box.c"
	} else {
#line 27 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 228 "Box.c"
	}
#line 27 "../src/Box.vala"
	if (_tmp0_) {
#line 28 "../src/Box.vala"
		result = BOX_COMPLEMENTS_BOTH;
#line 28 "../src/Box.vala"
		return result;
#line 236 "Box.c"
	} else {
#line 29 "../src/Box.vala"
		if (horizontal_complement) {
#line 30 "../src/Box.vala"
			result = BOX_COMPLEMENTS_HORIZONTAL;
#line 30 "../src/Box.vala"
			return result;
#line 244 "Box.c"
		} else {
#line 31 "../src/Box.vala"
			if (vertical_complement) {
#line 32 "../src/Box.vala"
				result = BOX_COMPLEMENTS_VERTICAL;
#line 32 "../src/Box.vala"
				return result;
#line 252 "Box.c"
			}
		}
	}
#line 34 "../src/Box.vala"
	result = BOX_COMPLEMENTS_NONE;
#line 34 "../src/Box.vala"
	return result;
#line 260 "Box.c"
}

static GType
box_complements_get_type_once (void)
{
	static const GEnumValue values[] = {{BOX_COMPLEMENTS_NONE, "BOX_COMPLEMENTS_NONE", "none"}, {BOX_COMPLEMENTS_VERTICAL, "BOX_COMPLEMENTS_VERTICAL", "vertical"}, {BOX_COMPLEMENTS_HORIZONTAL, "BOX_COMPLEMENTS_HORIZONTAL", "horizontal"}, {BOX_COMPLEMENTS_BOTH, "BOX_COMPLEMENTS_BOTH", "both"}, {0, NULL, NULL}};
	GType box_complements_type_id;
	box_complements_type_id = g_enum_register_static ("BoxComplements", values);
	return box_complements_type_id;
}

GType
box_complements_get_type (void)
{
	static volatile gsize box_complements_type_id__once = 0;
	if (g_once_init_enter (&box_complements_type_id__once)) {
		GType box_complements_type_id;
		box_complements_type_id = box_complements_get_type_once ();
		g_once_init_leave (&box_complements_type_id__once, box_complements_type_id);
	}
	return box_complements_type_id__once;
}

void
box_init (Box *self,
          gint left,
          gint top,
          gint right,
          gint bottom)
{
#line 46 "../src/Box.vala"
	memset (self, 0, sizeof (Box));
#line 48 "../src/Box.vala"
	left = CLAMP (left, 0, G_MAXINT);
#line 49 "../src/Box.vala"
	top = CLAMP (top, 0, G_MAXINT);
#line 53 "../src/Box.vala"
	if (right <= left) {
#line 54 "../src/Box.vala"
		right = left + 1;
#line 301 "Box.c"
	}
#line 56 "../src/Box.vala"
	if (bottom <= top) {
#line 57 "../src/Box.vala"
		bottom = top + 1;
#line 307 "Box.c"
	}
#line 59 "../src/Box.vala"
	(*self).left = left;
#line 60 "../src/Box.vala"
	(*self).top = top;
#line 61 "../src/Box.vala"
	(*self).right = right;
#line 62 "../src/Box.vala"
	(*self).bottom = bottom;
#line 317 "Box.c"
}

void
box_from_rectangle (GdkRectangle* rect,
                    Box* result)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	Box _tmp6_ = {0};
#line 65 "../src/Box.vala"
	g_return_if_fail (rect != NULL);
#line 66 "../src/Box.vala"
	_tmp0_ = *rect;
#line 66 "../src/Box.vala"
	_tmp1_ = *rect;
#line 66 "../src/Box.vala"
	_tmp2_ = *rect;
#line 66 "../src/Box.vala"
	_tmp3_ = *rect;
#line 66 "../src/Box.vala"
	_tmp4_ = *rect;
#line 66 "../src/Box.vala"
	_tmp5_ = *rect;
#line 66 "../src/Box.vala"
	box_init (&_tmp6_, _tmp0_.x, _tmp1_.y, (_tmp2_.x + _tmp3_.width) - 1, (_tmp4_.y + _tmp5_.height) - 1);
#line 66 "../src/Box.vala"
	*result = _tmp6_;
#line 66 "../src/Box.vala"
	return;
#line 351 "Box.c"
}

void
box_from_allocation (GtkAllocation* alloc,
                     Box* result)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	GtkAllocation _tmp3_;
	GtkAllocation _tmp4_;
	GtkAllocation _tmp5_;
	Box _tmp6_ = {0};
#line 69 "../src/Box.vala"
	g_return_if_fail (alloc != NULL);
#line 70 "../src/Box.vala"
	_tmp0_ = *alloc;
#line 70 "../src/Box.vala"
	_tmp1_ = *alloc;
#line 70 "../src/Box.vala"
	_tmp2_ = *alloc;
#line 70 "../src/Box.vala"
	_tmp3_ = *alloc;
#line 70 "../src/Box.vala"
	_tmp4_ = *alloc;
#line 70 "../src/Box.vala"
	_tmp5_ = *alloc;
#line 70 "../src/Box.vala"
	box_init (&_tmp6_, _tmp0_.x, _tmp1_.y, (_tmp2_.x + _tmp3_.width) - 1, (_tmp4_.y + _tmp5_.height) - 1);
#line 70 "../src/Box.vala"
	*result = _tmp6_;
#line 70 "../src/Box.vala"
	return;
#line 385 "Box.c"
}

void
box_from_points (GdkPoint* corner1,
                 GdkPoint* corner2,
                 Box* result)
{
	GdkPoint _tmp0_;
	GdkPoint _tmp1_;
	GdkPoint _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_;
	GdkPoint _tmp5_;
	GdkPoint _tmp6_;
	GdkPoint _tmp7_;
	Box _tmp8_ = {0};
#line 75 "../src/Box.vala"
	g_return_if_fail (corner1 != NULL);
#line 75 "../src/Box.vala"
	g_return_if_fail (corner2 != NULL);
#line 76 "../src/Box.vala"
	_tmp0_ = *corner1;
#line 76 "../src/Box.vala"
	_tmp1_ = *corner2;
#line 76 "../src/Box.vala"
	_tmp2_ = *corner1;
#line 76 "../src/Box.vala"
	_tmp3_ = *corner2;
#line 76 "../src/Box.vala"
	_tmp4_ = *corner1;
#line 76 "../src/Box.vala"
	_tmp5_ = *corner2;
#line 76 "../src/Box.vala"
	_tmp6_ = *corner1;
#line 76 "../src/Box.vala"
	_tmp7_ = *corner2;
#line 76 "../src/Box.vala"
	box_init (&_tmp8_, MIN (_tmp0_.x, _tmp1_.x), MIN (_tmp2_.y, _tmp3_.y), MAX (_tmp4_.x, _tmp5_.x), MAX (_tmp6_.y, _tmp7_.y));
#line 76 "../src/Box.vala"
	*result = _tmp8_;
#line 76 "../src/Box.vala"
	return;
#line 428 "Box.c"
}

void
box_from_center (GdkPoint* center,
                 gint width,
                 gint height,
                 Box* result)
{
	GdkPoint _tmp0_;
	GdkPoint _tmp1_;
	GdkPoint _tmp2_;
	GdkPoint _tmp3_;
	Box _tmp4_ = {0};
#line 80 "../src/Box.vala"
	g_return_if_fail (center != NULL);
#line 81 "../src/Box.vala"
	_tmp0_ = *center;
#line 81 "../src/Box.vala"
	_tmp1_ = *center;
#line 81 "../src/Box.vala"
	_tmp2_ = *center;
#line 81 "../src/Box.vala"
	_tmp3_ = *center;
#line 81 "../src/Box.vala"
	box_init (&_tmp4_, _tmp0_.x - (width / 2), _tmp1_.y - (height / 2), _tmp2_.x + (width / 2), _tmp3_.y + (height / 2));
#line 81 "../src/Box.vala"
	*result = _tmp4_;
#line 81 "../src/Box.vala"
	return;
#line 458 "Box.c"
}

gint
box_get_width (Box *self)
{
	gint result;
#line 86 "../src/Box.vala"
	_vala_assert ((*self).right >= (*self).left, "right >= left");
#line 88 "../src/Box.vala"
	result = ((*self).right - (*self).left) + 1;
#line 88 "../src/Box.vala"
	return result;
#line 471 "Box.c"
}

gint
box_get_height (Box *self)
{
	gint result;
#line 92 "../src/Box.vala"
	_vala_assert ((*self).bottom >= (*self).top, "bottom >= top");
#line 94 "../src/Box.vala"
	result = ((*self).bottom - (*self).top) + 1;
#line 94 "../src/Box.vala"
	return result;
#line 484 "Box.c"
}

gboolean
box_is_valid (Box *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 98 "../src/Box.vala"
	if ((*self).left >= 0) {
#line 98 "../src/Box.vala"
		_tmp2_ = (*self).top >= 0;
#line 498 "Box.c"
	} else {
#line 98 "../src/Box.vala"
		_tmp2_ = FALSE;
#line 502 "Box.c"
	}
#line 98 "../src/Box.vala"
	if (_tmp2_) {
#line 98 "../src/Box.vala"
		_tmp1_ = (*self).right >= (*self).left;
#line 508 "Box.c"
	} else {
#line 98 "../src/Box.vala"
		_tmp1_ = FALSE;
#line 512 "Box.c"
	}
#line 98 "../src/Box.vala"
	if (_tmp1_) {
#line 98 "../src/Box.vala"
		_tmp0_ = (*self).bottom >= (*self).top;
#line 518 "Box.c"
	} else {
#line 98 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 522 "Box.c"
	}
#line 98 "../src/Box.vala"
	result = _tmp0_;
#line 98 "../src/Box.vala"
	return result;
#line 528 "Box.c"
}

gboolean
box_equals (Box *self,
            Box* box)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Box _tmp3_;
	gboolean result;
#line 101 "../src/Box.vala"
	g_return_val_if_fail (box != NULL, FALSE);
#line 102 "../src/Box.vala"
	_tmp3_ = *box;
#line 102 "../src/Box.vala"
	if ((*self).left == _tmp3_.left) {
#line 546 "Box.c"
		Box _tmp4_;
#line 102 "../src/Box.vala"
		_tmp4_ = *box;
#line 102 "../src/Box.vala"
		_tmp2_ = (*self).top == _tmp4_.top;
#line 552 "Box.c"
	} else {
#line 102 "../src/Box.vala"
		_tmp2_ = FALSE;
#line 556 "Box.c"
	}
#line 102 "../src/Box.vala"
	if (_tmp2_) {
#line 560 "Box.c"
		Box _tmp5_;
#line 102 "../src/Box.vala"
		_tmp5_ = *box;
#line 102 "../src/Box.vala"
		_tmp1_ = (*self).right == _tmp5_.right;
#line 566 "Box.c"
	} else {
#line 102 "../src/Box.vala"
		_tmp1_ = FALSE;
#line 570 "Box.c"
	}
#line 102 "../src/Box.vala"
	if (_tmp1_) {
#line 574 "Box.c"
		Box _tmp6_;
#line 102 "../src/Box.vala"
		_tmp6_ = *box;
#line 102 "../src/Box.vala"
		_tmp0_ = (*self).bottom == _tmp6_.bottom;
#line 580 "Box.c"
	} else {
#line 102 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 584 "Box.c"
	}
#line 102 "../src/Box.vala"
	result = _tmp0_;
#line 102 "../src/Box.vala"
	return result;
#line 590 "Box.c"
}

void
box_adjust_width (Box *self,
                  gint width)
{
	gint center_x = 0;
#line 107 "../src/Box.vala"
	center_x = ((*self).left + (*self).right) / 2;
#line 108 "../src/Box.vala"
	(*self).left = center_x - (width / 2);
#line 109 "../src/Box.vala"
	(*self).right = center_x + (width / 2);
#line 604 "Box.c"
}

void
box_adjust_height (Box *self,
                   gint height)
{
	gint center_y = 0;
#line 114 "../src/Box.vala"
	center_y = ((*self).top + (*self).bottom) / 2;
#line 115 "../src/Box.vala"
	(*self).top = center_y - (height / 2);
#line 116 "../src/Box.vala"
	(*self).bottom = center_y + (height / 2);
#line 618 "Box.c"
}

void
box_get_scaled (Box *self,
                Dimensions* scaled,
                Box* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint l = 0;
	gint t = 0;
	gint r = 0;
	Dimensions _tmp4_;
	gint b = 0;
	Dimensions _tmp5_;
	Box box = {0};
	gboolean _tmp6_ = FALSE;
	Dimensions _tmp7_;
#line 119 "../src/Box.vala"
	g_return_if_fail (scaled != NULL);
#line 121 "../src/Box.vala"
	box_get_dimensions (&(*self), &_tmp0_);
#line 121 "../src/Box.vala"
	_tmp1_ = *scaled;
#line 121 "../src/Box.vala"
	dimensions_get_scale_ratios (&_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 121 "../src/Box.vala"
	x_scale = _tmp2_;
#line 121 "../src/Box.vala"
	y_scale = _tmp3_;
#line 123 "../src/Box.vala"
	l = (gint) round (((gdouble) (*self).left) * x_scale);
#line 124 "../src/Box.vala"
	t = (gint) round (((gdouble) (*self).top) * y_scale);
#line 127 "../src/Box.vala"
	_tmp4_ = *scaled;
#line 127 "../src/Box.vala"
	r = (l + _tmp4_.width) - 1;
#line 128 "../src/Box.vala"
	_tmp5_ = *scaled;
#line 128 "../src/Box.vala"
	b = (t + _tmp5_.height) - 1;
#line 130 "../src/Box.vala"
	box_init (&box, l, t, r, b);
#line 131 "../src/Box.vala"
	_tmp7_ = *scaled;
#line 131 "../src/Box.vala"
	if (box_get_width (&box) == _tmp7_.width) {
#line 131 "../src/Box.vala"
		_tmp6_ = TRUE;
#line 673 "Box.c"
	} else {
		Dimensions _tmp8_;
#line 131 "../src/Box.vala"
		_tmp8_ = *scaled;
#line 131 "../src/Box.vala"
		_tmp6_ = box_get_height (&box) == _tmp8_.height;
#line 680 "Box.c"
	}
#line 131 "../src/Box.vala"
	_vala_assert (_tmp6_, "box.get_width() == scaled.width || box.get_height() == scaled.height");
#line 133 "../src/Box.vala"
	*result = box;
#line 133 "../src/Box.vala"
	return;
#line 688 "Box.c"
}

void
box_get_scaled_similar (Box *self,
                        Dimensions* original,
                        Dimensions* scaled,
                        Box* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gint l = 0;
	gint t = 0;
	gint r = 0;
	gint b = 0;
	Dimensions _tmp3_;
	Dimensions _tmp5_;
	Box _tmp7_ = {0};
#line 136 "../src/Box.vala"
	g_return_if_fail (original != NULL);
#line 136 "../src/Box.vala"
	g_return_if_fail (scaled != NULL);
#line 138 "../src/Box.vala"
	_tmp0_ = *scaled;
#line 138 "../src/Box.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 138 "../src/Box.vala"
	x_scale = _tmp1_;
#line 138 "../src/Box.vala"
	y_scale = _tmp2_;
#line 140 "../src/Box.vala"
	l = (gint) round (((gdouble) (*self).left) * x_scale);
#line 141 "../src/Box.vala"
	t = (gint) round (((gdouble) (*self).top) * y_scale);
#line 142 "../src/Box.vala"
	r = (gint) round (((gdouble) (*self).right) * x_scale);
#line 143 "../src/Box.vala"
	b = (gint) round (((gdouble) (*self).bottom) * y_scale);
#line 146 "../src/Box.vala"
	_tmp3_ = *scaled;
#line 146 "../src/Box.vala"
	if (r >= _tmp3_.width) {
#line 733 "Box.c"
		Dimensions _tmp4_;
#line 147 "../src/Box.vala"
		_tmp4_ = *scaled;
#line 147 "../src/Box.vala"
		r = _tmp4_.width - 1;
#line 739 "Box.c"
	}
#line 149 "../src/Box.vala"
	_tmp5_ = *scaled;
#line 149 "../src/Box.vala"
	if (b >= _tmp5_.height) {
#line 745 "Box.c"
		Dimensions _tmp6_;
#line 150 "../src/Box.vala"
		_tmp6_ = *scaled;
#line 150 "../src/Box.vala"
		b = _tmp6_.height - 1;
#line 751 "Box.c"
	}
#line 152 "../src/Box.vala"
	box_init (&_tmp7_, l, t, r, b);
#line 152 "../src/Box.vala"
	*result = _tmp7_;
#line 152 "../src/Box.vala"
	return;
#line 759 "Box.c"
}

void
box_get_offset (Box *self,
                gint xofs,
                gint yofs,
                Box* result)
{
	Box _tmp0_ = {0};
#line 156 "../src/Box.vala"
	box_init (&_tmp0_, (*self).left + xofs, (*self).top + yofs, (*self).right + xofs, (*self).bottom + yofs);
#line 156 "../src/Box.vala"
	*result = _tmp0_;
#line 156 "../src/Box.vala"
	return;
#line 775 "Box.c"
}

void
box_get_dimensions (Box *self,
                    Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 160 "../src/Box.vala"
	dimensions_init (&_tmp0_, box_get_width (&(*self)), box_get_height (&(*self)));
#line 160 "../src/Box.vala"
	*result = _tmp0_;
#line 160 "../src/Box.vala"
	return;
#line 789 "Box.c"
}

void
box_get_points (Box *self,
                GdkPoint* top_left,
                GdkPoint* bottom_right)
{
	GdkPoint _vala_top_left = {0};
	GdkPoint _vala_bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
#line 164 "../src/Box.vala"
	_tmp0_.x = (*self).left;
#line 164 "../src/Box.vala"
	_tmp0_.y = (*self).top;
#line 164 "../src/Box.vala"
	_vala_top_left = _tmp0_;
#line 165 "../src/Box.vala"
	_tmp1_.x = (*self).right;
#line 165 "../src/Box.vala"
	_tmp1_.y = (*self).bottom;
#line 165 "../src/Box.vala"
	_vala_bottom_right = _tmp1_;
#line 163 "../src/Box.vala"
	if (top_left) {
#line 163 "../src/Box.vala"
		*top_left = _vala_top_left;
#line 817 "Box.c"
	}
#line 163 "../src/Box.vala"
	if (bottom_right) {
#line 163 "../src/Box.vala"
		*bottom_right = _vala_bottom_right;
#line 823 "Box.c"
	}
}

void
box_get_rectangle (Box *self,
                   GdkRectangle* result)
{
	GdkRectangle rect = {0};
#line 169 "../src/Box.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 170 "../src/Box.vala"
	rect.x = (*self).left;
#line 171 "../src/Box.vala"
	rect.y = (*self).top;
#line 172 "../src/Box.vala"
	rect.width = box_get_width (&(*self));
#line 173 "../src/Box.vala"
	rect.height = box_get_height (&(*self));
#line 175 "../src/Box.vala"
	*result = rect;
#line 175 "../src/Box.vala"
	return;
#line 846 "Box.c"
}

void
box_get_center (Box *self,
                GdkPoint* result)
{
	GdkPoint _tmp0_ = {0};
#line 179 "../src/Box.vala"
	_tmp0_.x = ((*self).left + (*self).right) / 2;
#line 179 "../src/Box.vala"
	_tmp0_.y = ((*self).top + (*self).bottom) / 2;
#line 179 "../src/Box.vala"
	*result = _tmp0_;
#line 179 "../src/Box.vala"
	return;
#line 862 "Box.c"
}

void
box_rotate_clockwise (Box *self,
                      Dimensions* space,
                      Box* result)
{
	gint l = 0;
	Dimensions _tmp0_;
	gint t = 0;
	gint r = 0;
	Dimensions _tmp1_;
	gint b = 0;
	Box _tmp2_ = {0};
#line 182 "../src/Box.vala"
	g_return_if_fail (space != NULL);
#line 183 "../src/Box.vala"
	_tmp0_ = *space;
#line 183 "../src/Box.vala"
	l = (_tmp0_.width - (*self).bottom) - 1;
#line 184 "../src/Box.vala"
	t = (*self).left;
#line 185 "../src/Box.vala"
	_tmp1_ = *space;
#line 185 "../src/Box.vala"
	r = (_tmp1_.width - (*self).top) - 1;
#line 186 "../src/Box.vala"
	b = (*self).right;
#line 188 "../src/Box.vala"
	box_init (&_tmp2_, l, t, r, b);
#line 188 "../src/Box.vala"
	*result = _tmp2_;
#line 188 "../src/Box.vala"
	return;
#line 897 "Box.c"
}

void
box_rotate_counterclockwise (Box *self,
                             Dimensions* space,
                             Box* result)
{
	gint l = 0;
	gint t = 0;
	Dimensions _tmp0_;
	gint r = 0;
	gint b = 0;
	Dimensions _tmp1_;
	Box _tmp2_ = {0};
#line 191 "../src/Box.vala"
	g_return_if_fail (space != NULL);
#line 192 "../src/Box.vala"
	l = (*self).top;
#line 193 "../src/Box.vala"
	_tmp0_ = *space;
#line 193 "../src/Box.vala"
	t = (_tmp0_.height - (*self).right) - 1;
#line 194 "../src/Box.vala"
	r = (*self).bottom;
#line 195 "../src/Box.vala"
	_tmp1_ = *space;
#line 195 "../src/Box.vala"
	b = (_tmp1_.height - (*self).left) - 1;
#line 197 "../src/Box.vala"
	box_init (&_tmp2_, l, t, r, b);
#line 197 "../src/Box.vala"
	*result = _tmp2_;
#line 197 "../src/Box.vala"
	return;
#line 932 "Box.c"
}

void
box_flip_left_to_right (Box *self,
                        Dimensions* space,
                        Box* result)
{
	gint l = 0;
	Dimensions _tmp0_;
	gint r = 0;
	Dimensions _tmp1_;
	Box _tmp2_ = {0};
#line 200 "../src/Box.vala"
	g_return_if_fail (space != NULL);
#line 201 "../src/Box.vala"
	_tmp0_ = *space;
#line 201 "../src/Box.vala"
	l = (_tmp0_.width - (*self).right) - 1;
#line 202 "../src/Box.vala"
	_tmp1_ = *space;
#line 202 "../src/Box.vala"
	r = (_tmp1_.width - (*self).left) - 1;
#line 204 "../src/Box.vala"
	box_init (&_tmp2_, l, (*self).top, r, (*self).bottom);
#line 204 "../src/Box.vala"
	*result = _tmp2_;
#line 204 "../src/Box.vala"
	return;
#line 961 "Box.c"
}

void
box_flip_top_to_bottom (Box *self,
                        Dimensions* space,
                        Box* result)
{
	gint t = 0;
	Dimensions _tmp0_;
	gint b = 0;
	Dimensions _tmp1_;
	Box _tmp2_ = {0};
#line 207 "../src/Box.vala"
	g_return_if_fail (space != NULL);
#line 208 "../src/Box.vala"
	_tmp0_ = *space;
#line 208 "../src/Box.vala"
	t = (_tmp0_.height - (*self).bottom) - 1;
#line 209 "../src/Box.vala"
	_tmp1_ = *space;
#line 209 "../src/Box.vala"
	b = (_tmp1_.height - (*self).top) - 1;
#line 211 "../src/Box.vala"
	box_init (&_tmp2_, (*self).left, t, (*self).right, b);
#line 211 "../src/Box.vala"
	*result = _tmp2_;
#line 211 "../src/Box.vala"
	return;
#line 990 "Box.c"
}

gboolean
box_intersects (Box *self,
                Box* compare)
{
	gint left_intersect = 0;
	Box _tmp0_;
	gint top_intersect = 0;
	Box _tmp1_;
	gint right_intersect = 0;
	Box _tmp2_;
	gint bottom_intersect = 0;
	Box _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 214 "../src/Box.vala"
	g_return_val_if_fail (compare != NULL, FALSE);
#line 215 "../src/Box.vala"
	_tmp0_ = *compare;
#line 215 "../src/Box.vala"
	left_intersect = MAX ((*self).left, _tmp0_.left);
#line 216 "../src/Box.vala"
	_tmp1_ = *compare;
#line 216 "../src/Box.vala"
	top_intersect = MAX ((*self).top, _tmp1_.top);
#line 217 "../src/Box.vala"
	_tmp2_ = *compare;
#line 217 "../src/Box.vala"
	right_intersect = MIN ((*self).right, _tmp2_.right);
#line 218 "../src/Box.vala"
	_tmp3_ = *compare;
#line 218 "../src/Box.vala"
	bottom_intersect = MIN ((*self).bottom, _tmp3_.bottom);
#line 220 "../src/Box.vala"
	if (right_intersect >= left_intersect) {
#line 220 "../src/Box.vala"
		_tmp4_ = bottom_intersect >= top_intersect;
#line 1029 "Box.c"
	} else {
#line 220 "../src/Box.vala"
		_tmp4_ = FALSE;
#line 1033 "Box.c"
	}
#line 220 "../src/Box.vala"
	result = _tmp4_;
#line 220 "../src/Box.vala"
	return result;
#line 1039 "Box.c"
}

void
box_get_reduced (Box *self,
                 gint amount,
                 Box* result)
{
	Box _tmp0_ = {0};
#line 224 "../src/Box.vala"
	box_init (&_tmp0_, (*self).left + amount, (*self).top + amount, (*self).right - amount, (*self).bottom - amount);
#line 224 "../src/Box.vala"
	*result = _tmp0_;
#line 224 "../src/Box.vala"
	return;
#line 1054 "Box.c"
}

void
box_get_expanded (Box *self,
                  gint amount,
                  Box* result)
{
	Box _tmp0_ = {0};
#line 228 "../src/Box.vala"
	box_init (&_tmp0_, (*self).left - amount, (*self).top - amount, (*self).right + amount, (*self).bottom + amount);
#line 228 "../src/Box.vala"
	*result = _tmp0_;
#line 228 "../src/Box.vala"
	return;
#line 1069 "Box.c"
}

gboolean
box_contains (Box *self,
              GdkPoint* point)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPoint _tmp3_;
	gboolean result;
#line 231 "../src/Box.vala"
	g_return_val_if_fail (point != NULL, FALSE);
#line 232 "../src/Box.vala"
	_tmp3_ = *point;
#line 232 "../src/Box.vala"
	if (_tmp3_.x >= (*self).left) {
#line 1087 "Box.c"
		GdkPoint _tmp4_;
#line 232 "../src/Box.vala"
		_tmp4_ = *point;
#line 232 "../src/Box.vala"
		_tmp2_ = _tmp4_.x <= (*self).right;
#line 1093 "Box.c"
	} else {
#line 232 "../src/Box.vala"
		_tmp2_ = FALSE;
#line 1097 "Box.c"
	}
#line 232 "../src/Box.vala"
	if (_tmp2_) {
#line 1101 "Box.c"
		GdkPoint _tmp5_;
#line 232 "../src/Box.vala"
		_tmp5_ = *point;
#line 232 "../src/Box.vala"
		_tmp1_ = _tmp5_.y >= (*self).top;
#line 1107 "Box.c"
	} else {
#line 232 "../src/Box.vala"
		_tmp1_ = FALSE;
#line 1111 "Box.c"
	}
#line 232 "../src/Box.vala"
	if (_tmp1_) {
#line 1115 "Box.c"
		GdkPoint _tmp6_;
#line 232 "../src/Box.vala"
		_tmp6_ = *point;
#line 232 "../src/Box.vala"
		_tmp0_ = _tmp6_.y <= (*self).bottom;
#line 1121 "Box.c"
	} else {
#line 232 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 1125 "Box.c"
	}
#line 232 "../src/Box.vala"
	result = _tmp0_;
#line 232 "../src/Box.vala"
	return result;
#line 1131 "Box.c"
}

BoxComplements
box_resized_complements (Box *self,
                         Box* resized,
                         Box* horizontal,
                         gboolean* horizontal_enlarged,
                         Box* vertical,
                         gboolean* vertical_enlarged)
{
	Box _vala_horizontal = {0};
	gboolean _vala_horizontal_enlarged = FALSE;
	Box _vala_vertical = {0};
	gboolean _vala_vertical_enlarged = FALSE;
	gboolean horizontal_complement = FALSE;
	Box _tmp0_;
	gboolean vertical_complement = FALSE;
	Box _tmp12_;
	BoxComplements result;
#line 238 "../src/Box.vala"
	g_return_val_if_fail (resized != NULL, 0);
#line 241 "../src/Box.vala"
	horizontal_complement = TRUE;
#line 242 "../src/Box.vala"
	_tmp0_ = *resized;
#line 242 "../src/Box.vala"
	if (_tmp0_.top < (*self).top) {
#line 1159 "Box.c"
		Box _tmp1_;
		Box _tmp2_;
		Box _tmp3_;
#line 244 "../src/Box.vala"
		_tmp1_ = *resized;
#line 244 "../src/Box.vala"
		_tmp2_ = *resized;
#line 244 "../src/Box.vala"
		_tmp3_ = *resized;
#line 244 "../src/Box.vala"
		box_init (&_vala_horizontal, _tmp1_.left, _tmp2_.top, _tmp3_.right, (*self).top);
#line 245 "../src/Box.vala"
		_vala_horizontal_enlarged = TRUE;
#line 1173 "Box.c"
	} else {
		Box _tmp4_;
#line 246 "../src/Box.vala"
		_tmp4_ = *resized;
#line 246 "../src/Box.vala"
		if (_tmp4_.top > (*self).top) {
#line 1180 "Box.c"
			Box _tmp5_;
#line 248 "../src/Box.vala"
			_tmp5_ = *resized;
#line 248 "../src/Box.vala"
			box_init (&_vala_horizontal, (*self).left, (*self).top, (*self).right, _tmp5_.top);
#line 249 "../src/Box.vala"
			_vala_horizontal_enlarged = FALSE;
#line 1188 "Box.c"
		} else {
			Box _tmp6_;
#line 250 "../src/Box.vala"
			_tmp6_ = *resized;
#line 250 "../src/Box.vala"
			if (_tmp6_.bottom < (*self).bottom) {
#line 1195 "Box.c"
				Box _tmp7_;
#line 252 "../src/Box.vala"
				_tmp7_ = *resized;
#line 252 "../src/Box.vala"
				box_init (&_vala_horizontal, (*self).left, _tmp7_.bottom, (*self).right, (*self).bottom);
#line 253 "../src/Box.vala"
				_vala_horizontal_enlarged = FALSE;
#line 1203 "Box.c"
			} else {
				Box _tmp8_;
#line 254 "../src/Box.vala"
				_tmp8_ = *resized;
#line 254 "../src/Box.vala"
				if (_tmp8_.bottom > (*self).bottom) {
#line 1210 "Box.c"
					Box _tmp9_;
					Box _tmp10_;
					Box _tmp11_;
#line 256 "../src/Box.vala"
					_tmp9_ = *resized;
#line 256 "../src/Box.vala"
					_tmp10_ = *resized;
#line 256 "../src/Box.vala"
					_tmp11_ = *resized;
#line 256 "../src/Box.vala"
					box_init (&_vala_horizontal, _tmp9_.left, (*self).bottom, _tmp10_.right, _tmp11_.bottom);
#line 257 "../src/Box.vala"
					_vala_horizontal_enlarged = TRUE;
#line 1224 "Box.c"
				} else {
#line 259 "../src/Box.vala"
					box_init (&_vala_horizontal, 0, 0, 0, 0);
#line 260 "../src/Box.vala"
					_vala_horizontal_enlarged = FALSE;
#line 261 "../src/Box.vala"
					horizontal_complement = FALSE;
#line 1232 "Box.c"
				}
			}
		}
	}
#line 264 "../src/Box.vala"
	vertical_complement = TRUE;
#line 265 "../src/Box.vala"
	_tmp12_ = *resized;
#line 265 "../src/Box.vala"
	if (_tmp12_.left < (*self).left) {
#line 1243 "Box.c"
		Box _tmp13_;
		Box _tmp14_;
		Box _tmp15_;
#line 267 "../src/Box.vala"
		_tmp13_ = *resized;
#line 267 "../src/Box.vala"
		_tmp14_ = *resized;
#line 267 "../src/Box.vala"
		_tmp15_ = *resized;
#line 267 "../src/Box.vala"
		box_init (&_vala_vertical, _tmp13_.left, _tmp14_.top, (*self).left, _tmp15_.bottom);
#line 268 "../src/Box.vala"
		_vala_vertical_enlarged = TRUE;
#line 1257 "Box.c"
	} else {
		Box _tmp16_;
#line 269 "../src/Box.vala"
		_tmp16_ = *resized;
#line 269 "../src/Box.vala"
		if (_tmp16_.left > (*self).left) {
#line 1264 "Box.c"
			Box _tmp17_;
#line 271 "../src/Box.vala"
			_tmp17_ = *resized;
#line 271 "../src/Box.vala"
			box_init (&_vala_vertical, (*self).left, (*self).top, _tmp17_.left, (*self).bottom);
#line 272 "../src/Box.vala"
			_vala_vertical_enlarged = FALSE;
#line 1272 "Box.c"
		} else {
			Box _tmp18_;
#line 273 "../src/Box.vala"
			_tmp18_ = *resized;
#line 273 "../src/Box.vala"
			if (_tmp18_.right < (*self).right) {
#line 1279 "Box.c"
				Box _tmp19_;
#line 275 "../src/Box.vala"
				_tmp19_ = *resized;
#line 275 "../src/Box.vala"
				box_init (&_vala_vertical, _tmp19_.right, (*self).top, (*self).right, (*self).bottom);
#line 276 "../src/Box.vala"
				_vala_vertical_enlarged = FALSE;
#line 1287 "Box.c"
			} else {
				Box _tmp20_;
#line 277 "../src/Box.vala"
				_tmp20_ = *resized;
#line 277 "../src/Box.vala"
				if (_tmp20_.right > (*self).right) {
#line 1294 "Box.c"
					Box _tmp21_;
					Box _tmp22_;
					Box _tmp23_;
#line 279 "../src/Box.vala"
					_tmp21_ = *resized;
#line 279 "../src/Box.vala"
					_tmp22_ = *resized;
#line 279 "../src/Box.vala"
					_tmp23_ = *resized;
#line 279 "../src/Box.vala"
					box_init (&_vala_vertical, (*self).right, _tmp21_.top, _tmp22_.right, _tmp23_.bottom);
#line 280 "../src/Box.vala"
					_vala_vertical_enlarged = TRUE;
#line 1308 "Box.c"
				} else {
#line 282 "../src/Box.vala"
					box_init (&_vala_vertical, 0, 0, 0, 0);
#line 283 "../src/Box.vala"
					_vala_vertical_enlarged = FALSE;
#line 284 "../src/Box.vala"
					vertical_complement = FALSE;
#line 1316 "Box.c"
				}
			}
		}
	}
#line 287 "../src/Box.vala"
	result = box_complements_derive (horizontal_complement, vertical_complement);
#line 287 "../src/Box.vala"
	if (horizontal) {
#line 287 "../src/Box.vala"
		*horizontal = _vala_horizontal;
#line 1327 "Box.c"
	}
#line 287 "../src/Box.vala"
	if (horizontal_enlarged) {
#line 287 "../src/Box.vala"
		*horizontal_enlarged = _vala_horizontal_enlarged;
#line 1333 "Box.c"
	}
#line 287 "../src/Box.vala"
	if (vertical) {
#line 287 "../src/Box.vala"
		*vertical = _vala_vertical;
#line 1339 "Box.c"
	}
#line 287 "../src/Box.vala"
	if (vertical_enlarged) {
#line 287 "../src/Box.vala"
		*vertical_enlarged = _vala_vertical_enlarged;
#line 1345 "Box.c"
	}
#line 287 "../src/Box.vala"
	return result;
#line 1349 "Box.c"
}

BoxComplements
box_shifted_complements (Box *self,
                         Box* shifted,
                         Box* horizontal_this,
                         Box* vertical_this,
                         Box* horizontal_shifted,
                         Box* vertical_shifted)
{
	Box _vala_horizontal_this = {0};
	Box _vala_vertical_this = {0};
	Box _vala_horizontal_shifted = {0};
	Box _vala_vertical_shifted = {0};
	gboolean horizontal_complement = FALSE;
	gboolean _tmp0_ = FALSE;
	Box _tmp1_;
	gboolean vertical_complement = FALSE;
	gboolean _tmp14_ = FALSE;
	Box _tmp15_;
	BoxComplements result;
#line 293 "../src/Box.vala"
	g_return_val_if_fail (shifted != NULL, 0);
#line 295 "../src/Box.vala"
	_vala_assert (box_get_width (&(*self)) == box_get_width (shifted), "get_width() == shifted.get_width()");
#line 296 "../src/Box.vala"
	_vala_assert (box_get_height (&(*self)) == box_get_height (shifted), "get_height() == shifted.get_height()");
#line 298 "../src/Box.vala"
	horizontal_complement = TRUE;
#line 299 "../src/Box.vala"
	_tmp1_ = *shifted;
#line 299 "../src/Box.vala"
	if (_tmp1_.top < (*self).top) {
#line 1383 "Box.c"
		Box _tmp2_;
#line 299 "../src/Box.vala"
		_tmp2_ = *shifted;
#line 299 "../src/Box.vala"
		_tmp0_ = _tmp2_.bottom > (*self).top;
#line 1389 "Box.c"
	} else {
#line 299 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 1393 "Box.c"
	}
#line 299 "../src/Box.vala"
	if (_tmp0_) {
#line 1397 "Box.c"
		Box _tmp3_;
		Box _tmp4_;
		Box _tmp5_;
		Box _tmp6_;
#line 301 "../src/Box.vala"
		_tmp3_ = *shifted;
#line 301 "../src/Box.vala"
		box_init (&_vala_horizontal_this, (*self).left, _tmp3_.bottom, (*self).right, (*self).bottom);
#line 302 "../src/Box.vala"
		_tmp4_ = *shifted;
#line 302 "../src/Box.vala"
		_tmp5_ = *shifted;
#line 302 "../src/Box.vala"
		_tmp6_ = *shifted;
#line 302 "../src/Box.vala"
		box_init (&_vala_horizontal_shifted, _tmp4_.left, _tmp5_.top, _tmp6_.right, (*self).top);
#line 1414 "Box.c"
	} else {
		gboolean _tmp7_ = FALSE;
		Box _tmp8_;
#line 303 "../src/Box.vala"
		_tmp8_ = *shifted;
#line 303 "../src/Box.vala"
		if (_tmp8_.top > (*self).top) {
#line 1422 "Box.c"
			Box _tmp9_;
#line 303 "../src/Box.vala"
			_tmp9_ = *shifted;
#line 303 "../src/Box.vala"
			_tmp7_ = _tmp9_.top < (*self).bottom;
#line 1428 "Box.c"
		} else {
#line 303 "../src/Box.vala"
			_tmp7_ = FALSE;
#line 1432 "Box.c"
		}
#line 303 "../src/Box.vala"
		if (_tmp7_) {
#line 1436 "Box.c"
			Box _tmp10_;
			Box _tmp11_;
			Box _tmp12_;
			Box _tmp13_;
#line 305 "../src/Box.vala"
			_tmp10_ = *shifted;
#line 305 "../src/Box.vala"
			box_init (&_vala_horizontal_this, (*self).left, (*self).top, (*self).right, _tmp10_.top);
#line 306 "../src/Box.vala"
			_tmp11_ = *shifted;
#line 306 "../src/Box.vala"
			_tmp12_ = *shifted;
#line 306 "../src/Box.vala"
			_tmp13_ = *shifted;
#line 306 "../src/Box.vala"
			box_init (&_vala_horizontal_shifted, _tmp11_.left, (*self).bottom, _tmp12_.right, _tmp13_.bottom);
#line 1453 "Box.c"
		} else {
#line 309 "../src/Box.vala"
			box_init (&_vala_horizontal_this, 0, 0, 0, 0);
#line 310 "../src/Box.vala"
			box_init (&_vala_horizontal_shifted, 0, 0, 0, 0);
#line 311 "../src/Box.vala"
			horizontal_complement = FALSE;
#line 1461 "Box.c"
		}
	}
#line 314 "../src/Box.vala"
	vertical_complement = TRUE;
#line 315 "../src/Box.vala"
	_tmp15_ = *shifted;
#line 315 "../src/Box.vala"
	if (_tmp15_.left < (*self).left) {
#line 1470 "Box.c"
		Box _tmp16_;
#line 315 "../src/Box.vala"
		_tmp16_ = *shifted;
#line 315 "../src/Box.vala"
		_tmp14_ = _tmp16_.right > (*self).left;
#line 1476 "Box.c"
	} else {
#line 315 "../src/Box.vala"
		_tmp14_ = FALSE;
#line 1480 "Box.c"
	}
#line 315 "../src/Box.vala"
	if (_tmp14_) {
#line 1484 "Box.c"
		Box _tmp17_;
		Box _tmp18_;
		Box _tmp19_;
		Box _tmp20_;
#line 317 "../src/Box.vala"
		_tmp17_ = *shifted;
#line 317 "../src/Box.vala"
		box_init (&_vala_vertical_this, _tmp17_.right, (*self).top, (*self).right, (*self).bottom);
#line 318 "../src/Box.vala"
		_tmp18_ = *shifted;
#line 318 "../src/Box.vala"
		_tmp19_ = *shifted;
#line 318 "../src/Box.vala"
		_tmp20_ = *shifted;
#line 318 "../src/Box.vala"
		box_init (&_vala_vertical_shifted, _tmp18_.left, _tmp19_.top, (*self).left, _tmp20_.bottom);
#line 1501 "Box.c"
	} else {
		gboolean _tmp21_ = FALSE;
		Box _tmp22_;
#line 319 "../src/Box.vala"
		_tmp22_ = *shifted;
#line 319 "../src/Box.vala"
		if (_tmp22_.left > (*self).left) {
#line 1509 "Box.c"
			Box _tmp23_;
#line 319 "../src/Box.vala"
			_tmp23_ = *shifted;
#line 319 "../src/Box.vala"
			_tmp21_ = _tmp23_.left < (*self).right;
#line 1515 "Box.c"
		} else {
#line 319 "../src/Box.vala"
			_tmp21_ = FALSE;
#line 1519 "Box.c"
		}
#line 319 "../src/Box.vala"
		if (_tmp21_) {
#line 1523 "Box.c"
			Box _tmp24_;
			Box _tmp25_;
			Box _tmp26_;
			Box _tmp27_;
#line 321 "../src/Box.vala"
			_tmp24_ = *shifted;
#line 321 "../src/Box.vala"
			box_init (&_vala_vertical_this, (*self).left, (*self).top, _tmp24_.left, (*self).bottom);
#line 322 "../src/Box.vala"
			_tmp25_ = *shifted;
#line 322 "../src/Box.vala"
			_tmp26_ = *shifted;
#line 322 "../src/Box.vala"
			_tmp27_ = *shifted;
#line 322 "../src/Box.vala"
			box_init (&_vala_vertical_shifted, (*self).right, _tmp25_.top, _tmp26_.right, _tmp27_.bottom);
#line 1540 "Box.c"
		} else {
#line 325 "../src/Box.vala"
			box_init (&_vala_vertical_this, 0, 0, 0, 0);
#line 326 "../src/Box.vala"
			box_init (&_vala_vertical_shifted, 0, 0, 0, 0);
#line 327 "../src/Box.vala"
			vertical_complement = FALSE;
#line 1548 "Box.c"
		}
	}
#line 330 "../src/Box.vala"
	result = box_complements_derive (horizontal_complement, vertical_complement);
#line 330 "../src/Box.vala"
	if (horizontal_this) {
#line 330 "../src/Box.vala"
		*horizontal_this = _vala_horizontal_this;
#line 1557 "Box.c"
	}
#line 330 "../src/Box.vala"
	if (vertical_this) {
#line 330 "../src/Box.vala"
		*vertical_this = _vala_vertical_this;
#line 1563 "Box.c"
	}
#line 330 "../src/Box.vala"
	if (horizontal_shifted) {
#line 330 "../src/Box.vala"
		*horizontal_shifted = _vala_horizontal_shifted;
#line 1569 "Box.c"
	}
#line 330 "../src/Box.vala"
	if (vertical_shifted) {
#line 330 "../src/Box.vala"
		*vertical_shifted = _vala_vertical_shifted;
#line 1575 "Box.c"
	}
#line 330 "../src/Box.vala"
	return result;
#line 1579 "Box.c"
}

void
box_rubber_band (Box *self,
                 GdkPoint* point,
                 Box* result)
{
	GdkPoint _tmp0_;
	GdkPoint _tmp1_;
	gint t = 0;
	GdkPoint _tmp2_;
	gint b = 0;
	GdkPoint _tmp3_;
	gint l = 0;
	GdkPoint _tmp4_;
	gint r = 0;
	GdkPoint _tmp5_;
	Box _tmp6_ = {0};
#line 333 "../src/Box.vala"
	g_return_if_fail (point != NULL);
#line 334 "../src/Box.vala"
	_tmp0_ = *point;
#line 334 "../src/Box.vala"
	_vala_assert (_tmp0_.x >= 0, "point.x >= 0");
#line 335 "../src/Box.vala"
	_tmp1_ = *point;
#line 335 "../src/Box.vala"
	_vala_assert (_tmp1_.y >= 0, "point.y >= 0");
#line 337 "../src/Box.vala"
	_tmp2_ = *point;
#line 337 "../src/Box.vala"
	t = MIN ((*self).top, _tmp2_.y);
#line 338 "../src/Box.vala"
	_tmp3_ = *point;
#line 338 "../src/Box.vala"
	b = MAX ((*self).bottom, _tmp3_.y);
#line 339 "../src/Box.vala"
	_tmp4_ = *point;
#line 339 "../src/Box.vala"
	l = MIN ((*self).left, _tmp4_.x);
#line 340 "../src/Box.vala"
	_tmp5_ = *point;
#line 340 "../src/Box.vala"
	r = MAX ((*self).right, _tmp5_.x);
#line 342 "../src/Box.vala"
	box_init (&_tmp6_, l, t, r, b);
#line 342 "../src/Box.vala"
	*result = _tmp6_;
#line 342 "../src/Box.vala"
	return;
#line 1630 "Box.c"
}

gchar*
box_to_string (Box *self)
{
	Dimensions _tmp0_ = {0};
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 346 "../src/Box.vala"
	box_get_dimensions (&(*self), &_tmp0_);
#line 346 "../src/Box.vala"
	_tmp1_ = dimensions_to_string (&_tmp0_);
#line 346 "../src/Box.vala"
	_tmp2_ = _tmp1_;
#line 346 "../src/Box.vala"
	_tmp3_ = g_strdup_printf ("%d,%d %d,%d (%s)", (*self).left, (*self).top, (*self).right, (*self).bottom, _tmp2_);
#line 346 "../src/Box.vala"
	_tmp4_ = _tmp3_;
#line 346 "../src/Box.vala"
	_g_free0 (_tmp2_);
#line 346 "../src/Box.vala"
	result = _tmp4_;
#line 346 "../src/Box.vala"
	return result;
#line 1658 "Box.c"
}

static gboolean
box_in_zone (gdouble pos,
             gint zone)
{
	gint top_zone = 0;
	gint bottom_zone = 0;
	gboolean result;
#line 350 "../src/Box.vala"
	top_zone = zone - BOX_HAND_GRENADES;
#line 351 "../src/Box.vala"
	bottom_zone = zone + BOX_HAND_GRENADES;
#line 353 "../src/Box.vala"
	result = box_in_between (pos, top_zone, bottom_zone);
#line 353 "../src/Box.vala"
	return result;
#line 1676 "Box.c"
}

static gboolean
box_in_between (gdouble pos,
                gint top,
                gint bottom)
{
	gint ipos = 0;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 357 "../src/Box.vala"
	ipos = (gint) pos;
#line 359 "../src/Box.vala"
	if (ipos > top) {
#line 359 "../src/Box.vala"
		_tmp0_ = ipos < bottom;
#line 1693 "Box.c"
	} else {
#line 359 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 1697 "Box.c"
	}
#line 359 "../src/Box.vala"
	result = _tmp0_;
#line 359 "../src/Box.vala"
	return result;
#line 1703 "Box.c"
}

static gboolean
box_near_in_between (gdouble pos,
                     gint top,
                     gint bottom)
{
	gint ipos = 0;
	gint top_zone = 0;
	gint bottom_zone = 0;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 363 "../src/Box.vala"
	ipos = (gint) pos;
#line 364 "../src/Box.vala"
	top_zone = top - BOX_HAND_GRENADES;
#line 365 "../src/Box.vala"
	bottom_zone = bottom + BOX_HAND_GRENADES;
#line 367 "../src/Box.vala"
	if (ipos > top_zone) {
#line 367 "../src/Box.vala"
		_tmp0_ = ipos < bottom_zone;
#line 1726 "Box.c"
	} else {
#line 367 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 1730 "Box.c"
	}
#line 367 "../src/Box.vala"
	result = _tmp0_;
#line 367 "../src/Box.vala"
	return result;
#line 1736 "Box.c"
}

BoxLocation
box_approx_location (Box *self,
                     gint x,
                     gint y)
{
	gboolean near_width = FALSE;
	gboolean near_height = FALSE;
	gboolean _tmp0_ = FALSE;
	BoxLocation result;
#line 371 "../src/Box.vala"
	near_width = box_near_in_between ((gdouble) x, (*self).left, (*self).right);
#line 372 "../src/Box.vala"
	near_height = box_near_in_between ((gdouble) y, (*self).top, (*self).bottom);
#line 374 "../src/Box.vala"
	if (box_in_zone ((gdouble) x, (*self).left)) {
#line 374 "../src/Box.vala"
		_tmp0_ = near_height;
#line 1756 "Box.c"
	} else {
#line 374 "../src/Box.vala"
		_tmp0_ = FALSE;
#line 1760 "Box.c"
	}
#line 374 "../src/Box.vala"
	if (_tmp0_) {
#line 375 "../src/Box.vala"
		if (box_in_zone ((gdouble) y, (*self).top)) {
#line 376 "../src/Box.vala"
			result = BOX_LOCATION_TOP_LEFT;
#line 376 "../src/Box.vala"
			return result;
#line 1770 "Box.c"
		} else {
#line 377 "../src/Box.vala"
			if (box_in_zone ((gdouble) y, (*self).bottom)) {
#line 378 "../src/Box.vala"
				result = BOX_LOCATION_BOTTOM_LEFT;
#line 378 "../src/Box.vala"
				return result;
#line 1778 "Box.c"
			} else {
#line 380 "../src/Box.vala"
				result = BOX_LOCATION_LEFT_SIDE;
#line 380 "../src/Box.vala"
				return result;
#line 1784 "Box.c"
			}
		}
	} else {
		gboolean _tmp1_ = FALSE;
#line 382 "../src/Box.vala"
		if (box_in_zone ((gdouble) x, (*self).right)) {
#line 382 "../src/Box.vala"
			_tmp1_ = near_height;
#line 1793 "Box.c"
		} else {
#line 382 "../src/Box.vala"
			_tmp1_ = FALSE;
#line 1797 "Box.c"
		}
#line 382 "../src/Box.vala"
		if (_tmp1_) {
#line 383 "../src/Box.vala"
			if (box_in_zone ((gdouble) y, (*self).top)) {
#line 384 "../src/Box.vala"
				result = BOX_LOCATION_TOP_RIGHT;
#line 384 "../src/Box.vala"
				return result;
#line 1807 "Box.c"
			} else {
#line 385 "../src/Box.vala"
				if (box_in_zone ((gdouble) y, (*self).bottom)) {
#line 386 "../src/Box.vala"
					result = BOX_LOCATION_BOTTOM_RIGHT;
#line 386 "../src/Box.vala"
					return result;
#line 1815 "Box.c"
				} else {
#line 388 "../src/Box.vala"
					result = BOX_LOCATION_RIGHT_SIDE;
#line 388 "../src/Box.vala"
					return result;
#line 1821 "Box.c"
				}
			}
		} else {
			gboolean _tmp2_ = FALSE;
#line 390 "../src/Box.vala"
			if (box_in_zone ((gdouble) y, (*self).top)) {
#line 390 "../src/Box.vala"
				_tmp2_ = near_width;
#line 1830 "Box.c"
			} else {
#line 390 "../src/Box.vala"
				_tmp2_ = FALSE;
#line 1834 "Box.c"
			}
#line 390 "../src/Box.vala"
			if (_tmp2_) {
#line 392 "../src/Box.vala"
				result = BOX_LOCATION_TOP_SIDE;
#line 392 "../src/Box.vala"
				return result;
#line 1842 "Box.c"
			} else {
				gboolean _tmp3_ = FALSE;
#line 393 "../src/Box.vala"
				if (box_in_zone ((gdouble) y, (*self).bottom)) {
#line 393 "../src/Box.vala"
					_tmp3_ = near_width;
#line 1849 "Box.c"
				} else {
#line 393 "../src/Box.vala"
					_tmp3_ = FALSE;
#line 1853 "Box.c"
				}
#line 393 "../src/Box.vala"
				if (_tmp3_) {
#line 395 "../src/Box.vala"
					result = BOX_LOCATION_BOTTOM_SIDE;
#line 395 "../src/Box.vala"
					return result;
#line 1861 "Box.c"
				} else {
					gboolean _tmp4_ = FALSE;
#line 396 "../src/Box.vala"
					if (box_in_between ((gdouble) x, (*self).left, (*self).right)) {
#line 396 "../src/Box.vala"
						_tmp4_ = box_in_between ((gdouble) y, (*self).top, (*self).bottom);
#line 1868 "Box.c"
					} else {
#line 396 "../src/Box.vala"
						_tmp4_ = FALSE;
#line 1872 "Box.c"
					}
#line 396 "../src/Box.vala"
					if (_tmp4_) {
#line 397 "../src/Box.vala"
						result = BOX_LOCATION_INSIDE;
#line 397 "../src/Box.vala"
						return result;
#line 1880 "Box.c"
					} else {
#line 399 "../src/Box.vala"
						result = BOX_LOCATION_OUTSIDE;
#line 399 "../src/Box.vala"
						return result;
#line 1886 "Box.c"
					}
				}
			}
		}
	}
}

Box*
box_dup (const Box* self)
{
	Box* dup;
#line 38 "../src/Box.vala"
	dup = g_new0 (Box, 1);
#line 38 "../src/Box.vala"
	memcpy (dup, self, sizeof (Box));
#line 38 "../src/Box.vala"
	return dup;
#line 1904 "Box.c"
}

void
box_free (Box* self)
{
#line 38 "../src/Box.vala"
	g_free (self);
#line 1912 "Box.c"
}

static GType
box_get_type_once (void)
{
	GType box_type_id;
	box_type_id = g_boxed_type_register_static ("Box", (GBoxedCopyFunc) box_dup, (GBoxedFreeFunc) box_free);
	return box_type_id;
}

GType
box_get_type (void)
{
	static volatile gsize box_type_id__once = 0;
	if (g_once_init_enter (&box_type_id__once)) {
		GType box_type_id;
		box_type_id = box_get_type_once ();
		g_once_init_leave (&box_type_id__once, box_type_id);
	}
	return box_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

