/* Dimensions.c generated by valac 0.56.13, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define SCALING_NO_SCALE 0
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZOOM_STATE (zoom_state_get_type ())
typedef struct _ZoomState ZoomState;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ZoomState {
	Dimensions content_dimensions;
	Dimensions viewport_dimensions;
	gdouble zoom_factor;
	gdouble interpolation_factor;
	gdouble min_factor;
	gdouble max_factor;
	GdkPoint viewport_center;
};

VALA_EXTERN GType scale_constraint_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* scale_constraint_to_string (ScaleConstraint self);
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
VALA_EXTERN void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
VALA_EXTERN void dimensions_for_allocation (GtkAllocation* allocation,
                                Dimensions* result);
VALA_EXTERN void dimensions_for_widget_allocation (GtkWidget* widget,
                                       Dimensions* result);
VALA_EXTERN void dimensions_for_rectangle (GdkRectangle* rect,
                               Dimensions* result);
VALA_EXTERN gboolean dimensions_has_area (Dimensions *self);
VALA_EXTERN void dimensions_floor (Dimensions *self,
                       Dimensions* min,
                       Dimensions* result);
VALA_EXTERN gchar* dimensions_to_string (Dimensions *self);
VALA_EXTERN gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
VALA_EXTERN gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
VALA_EXTERN gboolean dimensions_approx_scaled (Dimensions *self,
                                   gint scale,
                                   gint fudge);
VALA_EXTERN gint dimensions_major_axis (Dimensions *self);
VALA_EXTERN gint dimensions_minor_axis (Dimensions *self);
VALA_EXTERN void dimensions_with_min (Dimensions *self,
                          gint min_width,
                          gint min_height,
                          Dimensions* result);
VALA_EXTERN void dimensions_with_max (Dimensions *self,
                          gint max_width,
                          gint max_height,
                          Dimensions* result);
VALA_EXTERN void dimensions_get_scaled (Dimensions *self,
                            gint scale,
                            gboolean scale_up,
                            Dimensions* result);
VALA_EXTERN void dimensions_get_scaled_by_width (Dimensions *self,
                                     gint scale,
                                     Dimensions* result);
VALA_EXTERN void dimensions_get_scaled_by_height (Dimensions *self,
                                      gint scale,
                                      Dimensions* result);
VALA_EXTERN void dimensions_get_scale_ratios (Dimensions *self,
                                  Dimensions* scaled,
                                  gdouble* width_ratio,
                                  gdouble* height_ratio);
VALA_EXTERN gdouble dimensions_get_aspect_ratio (Dimensions *self);
VALA_EXTERN void dimensions_get_scaled_proportional (Dimensions *self,
                                         Dimensions* viewport,
                                         Dimensions* result);
VALA_EXTERN void dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                             Dimensions* viewport,
                                             Dimensions* result);
VALA_EXTERN void dimensions_get_scaled_rectangle (Dimensions *self,
                                      Dimensions* scaled,
                                      GdkRectangle* rect,
                                      GdkRectangle* result);
VALA_EXTERN void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
VALA_EXTERN void dimensions_get_scaled_by_constraint (Dimensions *self,
                                          gint scale,
                                          ScaleConstraint constraint,
                                          Dimensions* result);
VALA_EXTERN GType scaling_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Scaling* scaling_dup (const Scaling* self);
VALA_EXTERN void scaling_free (Scaling* self);
static void scaling_init (Scaling *self,
                   ScaleConstraint constraint,
                   gint scale,
                   Dimensions* viewport,
                   gboolean scale_up);
VALA_EXTERN void scaling_for_original (Scaling* result);
VALA_EXTERN void scaling_for_screen (GtkWindow* window,
                         gboolean scale_up,
                         Scaling* result);
VALA_EXTERN void scaling_for_viewport (Dimensions* viewport,
                           gboolean scale_up,
                           Scaling* result);
VALA_EXTERN void scaling_get_screen_dimensions (GtkWindow* window,
                                    Dimensions* result);
VALA_EXTERN void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
VALA_EXTERN void scaling_for_widget (GtkWidget* widget,
                         gboolean scale_up,
                         Scaling* result);
VALA_EXTERN void scaling_to_fill_viewport (Dimensions* viewport,
                               Scaling* result);
VALA_EXTERN void scaling_to_fill_screen (GtkWindow* window,
                             Scaling* result);
VALA_EXTERN void scaling_for_constraint (ScaleConstraint constraint,
                             gint scale,
                             gboolean scale_up,
                             Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
VALA_EXTERN gboolean scaling_is_unscaled (Scaling *self);
VALA_EXTERN gboolean scaling_is_best_fit (Scaling *self,
                              Dimensions* original,
                              gint* pixels);
VALA_EXTERN gboolean scaling_is_best_fit_dimensions (Scaling *self,
                                         Dimensions* original,
                                         Dimensions* scaled);
VALA_EXTERN gboolean scaling_is_for_viewport (Scaling *self,
                                  Dimensions* original,
                                  Dimensions* scaled);
VALA_EXTERN gboolean scaling_is_fill_viewport (Scaling *self,
                                   Dimensions* original,
                                   Dimensions* scaled);
VALA_EXTERN void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
VALA_EXTERN GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
VALA_EXTERN GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf,
                         gint scale,
                         GdkInterpType interp,
                         gboolean scale_up);
VALA_EXTERN GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
VALA_EXTERN gchar* scaling_to_string (Scaling *self);
VALA_EXTERN gboolean scaling_equals (Scaling *self,
                         Scaling* scaling);
VALA_EXTERN GType zoom_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ZoomState* zoom_state_dup (const ZoomState* self);
VALA_EXTERN void zoom_state_free (ZoomState* self);
VALA_EXTERN void zoom_state_init (ZoomState *self,
                      Dimensions* content_dimensions,
                      Dimensions* viewport_dimensions,
                      gdouble slider_val,
                      GdkPoint* viewport_center);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);
VALA_EXTERN void zoom_state_init_rescale (ZoomState *self,
                              ZoomState* existing,
                              gdouble new_slider_val);
VALA_EXTERN void zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                            ZoomState* existing);
VALA_EXTERN void zoom_state_init_pan (ZoomState *self,
                          ZoomState* existing,
                          GdkPoint* new_viewport_center);
VALA_EXTERN gint zoom_state_get_zoomed_width (ZoomState *self);
VALA_EXTERN gint zoom_state_get_zoomed_height (ZoomState *self);
VALA_EXTERN gdouble zoom_state_get_interpolation_factor (ZoomState *self);
VALA_EXTERN void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                                   GdkRectangle* result);
VALA_EXTERN void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                                  GdkRectangle* result);
VALA_EXTERN void zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                                  GdkPixbuf* for_pixbuf,
                                                  GdkRectangle* result);
VALA_EXTERN gdouble zoom_state_get_zoom_factor (ZoomState *self);
VALA_EXTERN void zoom_state_get_viewport_center (ZoomState *self,
                                     GdkPoint* result);
VALA_EXTERN gchar* zoom_state_to_string (ZoomState *self);
VALA_EXTERN gboolean zoom_state_is_min (ZoomState *self);
VALA_EXTERN gboolean zoom_state_is_default (ZoomState *self);
VALA_EXTERN gboolean zoom_state_is_isomorphic (ZoomState *self);
VALA_EXTERN gboolean zoom_state_is_max (ZoomState *self);
VALA_EXTERN gboolean zoom_state_equals (ZoomState *self,
                            ZoomState* other);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gchar*
scale_constraint_to_string (ScaleConstraint self)
{
	gchar* result;
#line 15 "../src/Dimensions.vala"
	switch (self) {
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 265 "Dimensions.c"
		{
			gchar* _tmp0_;
#line 17 "../src/Dimensions.vala"
			_tmp0_ = g_strdup (_ ("Original size"));
#line 17 "../src/Dimensions.vala"
			result = _tmp0_;
#line 17 "../src/Dimensions.vala"
			return result;
#line 274 "Dimensions.c"
		}
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 278 "Dimensions.c"
		{
			gchar* _tmp1_;
#line 20 "../src/Dimensions.vala"
			_tmp1_ = g_strdup (_ ("Longest edge"));
#line 20 "../src/Dimensions.vala"
			result = _tmp1_;
#line 20 "../src/Dimensions.vala"
			return result;
#line 287 "Dimensions.c"
		}
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 291 "Dimensions.c"
		{
			gchar* _tmp2_;
#line 23 "../src/Dimensions.vala"
			_tmp2_ = g_strdup (_ ("Width"));
#line 23 "../src/Dimensions.vala"
			result = _tmp2_;
#line 23 "../src/Dimensions.vala"
			return result;
#line 300 "Dimensions.c"
		}
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 304 "Dimensions.c"
		{
			gchar* _tmp3_;
#line 26 "../src/Dimensions.vala"
			_tmp3_ = g_strdup (_ ("Height"));
#line 26 "../src/Dimensions.vala"
			result = _tmp3_;
#line 26 "../src/Dimensions.vala"
			return result;
#line 313 "Dimensions.c"
		}
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 317 "Dimensions.c"
		{
			gchar* _tmp4_;
#line 30 "../src/Dimensions.vala"
			_tmp4_ = g_strdup ("Fill Viewport");
#line 30 "../src/Dimensions.vala"
			result = _tmp4_;
#line 30 "../src/Dimensions.vala"
			return result;
#line 326 "Dimensions.c"
		}
		default:
#line 15 "../src/Dimensions.vala"
		break;
#line 331 "Dimensions.c"
	}
#line 33 "../src/Dimensions.vala"
	g_warn_if_reached ();
#line 35 "../src/Dimensions.vala"
	result = NULL;
#line 35 "../src/Dimensions.vala"
	return result;
#line 339 "Dimensions.c"
}

static GType
scale_constraint_get_type_once (void)
{
	static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
	GType scale_constraint_type_id;
	scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
	return scale_constraint_type_id;
}

GType
scale_constraint_get_type (void)
{
	static volatile gsize scale_constraint_type_id__once = 0;
	if (g_once_init_enter (&scale_constraint_type_id__once)) {
		GType scale_constraint_type_id;
		scale_constraint_type_id = scale_constraint_get_type_once ();
		g_once_init_leave (&scale_constraint_type_id__once, scale_constraint_type_id);
	}
	return scale_constraint_type_id__once;
}

void
dimensions_init (Dimensions *self,
                 gint width,
                 gint height)
{
	gboolean _tmp0_ = FALSE;
#line 43 "../src/Dimensions.vala"
	memset (self, 0, sizeof (Dimensions));
#line 44 "../src/Dimensions.vala"
	if (width < 0) {
#line 44 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 375 "Dimensions.c"
	} else {
#line 44 "../src/Dimensions.vala"
		_tmp0_ = height < 0;
#line 379 "Dimensions.c"
	}
#line 44 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 45 "../src/Dimensions.vala"
		g_warning ("Dimensions.vala:45: Tried to construct a Dimensions object with negati" \
"ve width or height - forcing sensible default values.");
#line 385 "Dimensions.c"
	}
#line 47 "../src/Dimensions.vala"
	(*self).width = CLAMP (width, 0, width);
#line 48 "../src/Dimensions.vala"
	(*self).height = CLAMP (height, 0, height);
#line 391 "Dimensions.c"
}

void
dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                       Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 51 "../src/Dimensions.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()));
#line 52 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, gdk_pixbuf_get_width (pixbuf), gdk_pixbuf_get_height (pixbuf));
#line 52 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 52 "../src/Dimensions.vala"
	return;
#line 407 "Dimensions.c"
}

void
dimensions_for_allocation (GtkAllocation* allocation,
                           Dimensions* result)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	Dimensions _tmp2_ = {0};
#line 55 "../src/Dimensions.vala"
	g_return_if_fail (allocation != NULL);
#line 56 "../src/Dimensions.vala"
	_tmp0_ = *allocation;
#line 56 "../src/Dimensions.vala"
	_tmp1_ = *allocation;
#line 56 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, _tmp0_.width, _tmp1_.height);
#line 56 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 56 "../src/Dimensions.vala"
	return;
#line 429 "Dimensions.c"
}

void
dimensions_for_widget_allocation (GtkWidget* widget,
                                  Dimensions* result)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	gint scale = 0;
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	Dimensions _tmp3_ = {0};
#line 59 "../src/Dimensions.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 61 "../src/Dimensions.vala"
	gtk_widget_get_allocation (widget, &_tmp0_);
#line 61 "../src/Dimensions.vala"
	allocation = _tmp0_;
#line 62 "../src/Dimensions.vala"
	scale = gtk_widget_get_scale_factor (widget);
#line 64 "../src/Dimensions.vala"
	_tmp1_ = allocation;
#line 64 "../src/Dimensions.vala"
	_tmp2_ = allocation;
#line 64 "../src/Dimensions.vala"
	dimensions_init (&_tmp3_, _tmp1_.width * scale, _tmp2_.height * scale);
#line 64 "../src/Dimensions.vala"
	*result = _tmp3_;
#line 64 "../src/Dimensions.vala"
	return;
#line 460 "Dimensions.c"
}

void
dimensions_for_rectangle (GdkRectangle* rect,
                          Dimensions* result)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	Dimensions _tmp2_ = {0};
#line 67 "../src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 68 "../src/Dimensions.vala"
	_tmp0_ = *rect;
#line 68 "../src/Dimensions.vala"
	_tmp1_ = *rect;
#line 68 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, _tmp0_.width, _tmp1_.height);
#line 68 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 68 "../src/Dimensions.vala"
	return;
#line 482 "Dimensions.c"
}

gboolean
dimensions_has_area (Dimensions *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 72 "../src/Dimensions.vala"
	if ((*self).width > 0) {
#line 72 "../src/Dimensions.vala"
		_tmp0_ = (*self).height > 0;
#line 494 "Dimensions.c"
	} else {
#line 72 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 498 "Dimensions.c"
	}
#line 72 "../src/Dimensions.vala"
	result = _tmp0_;
#line 72 "../src/Dimensions.vala"
	return result;
#line 504 "Dimensions.c"
}

void
dimensions_floor (Dimensions *self,
                  Dimensions* min,
                  Dimensions* result)
{
	gint _tmp0_ = 0;
	Dimensions _tmp1_;
	gint _tmp3_ = 0;
	Dimensions _tmp4_;
	Dimensions _tmp6_ = {0};
#line 75 "../src/Dimensions.vala"
	g_return_if_fail (min != NULL);
#line 76 "../src/Dimensions.vala"
	_tmp1_ = *min;
#line 76 "../src/Dimensions.vala"
	if ((*self).width > _tmp1_.width) {
#line 76 "../src/Dimensions.vala"
		_tmp0_ = (*self).width;
#line 525 "Dimensions.c"
	} else {
		Dimensions _tmp2_;
#line 76 "../src/Dimensions.vala"
		_tmp2_ = *min;
#line 76 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_.width;
#line 532 "Dimensions.c"
	}
#line 77 "../src/Dimensions.vala"
	_tmp4_ = *min;
#line 77 "../src/Dimensions.vala"
	if ((*self).height > _tmp4_.height) {
#line 77 "../src/Dimensions.vala"
		_tmp3_ = (*self).height;
#line 540 "Dimensions.c"
	} else {
		Dimensions _tmp5_;
#line 77 "../src/Dimensions.vala"
		_tmp5_ = *min;
#line 77 "../src/Dimensions.vala"
		_tmp3_ = _tmp5_.height;
#line 547 "Dimensions.c"
	}
#line 76 "../src/Dimensions.vala"
	dimensions_init (&_tmp6_, _tmp0_, _tmp3_);
#line 76 "../src/Dimensions.vala"
	*result = _tmp6_;
#line 76 "../src/Dimensions.vala"
	return;
#line 555 "Dimensions.c"
}

gchar*
dimensions_to_string (Dimensions *self)
{
	gchar* _tmp0_;
	gchar* result;
#line 81 "../src/Dimensions.vala"
	_tmp0_ = g_strdup_printf ("%dx%d", (*self).width, (*self).height);
#line 81 "../src/Dimensions.vala"
	result = _tmp0_;
#line 81 "../src/Dimensions.vala"
	return result;
#line 569 "Dimensions.c"
}

gboolean
dimensions_equals (Dimensions *self,
                   Dimensions* dim)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	gboolean result;
#line 84 "../src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 85 "../src/Dimensions.vala"
	_tmp1_ = *dim;
#line 85 "../src/Dimensions.vala"
	if ((*self).width == _tmp1_.width) {
#line 585 "Dimensions.c"
		Dimensions _tmp2_;
#line 85 "../src/Dimensions.vala"
		_tmp2_ = *dim;
#line 85 "../src/Dimensions.vala"
		_tmp0_ = (*self).height == _tmp2_.height;
#line 591 "Dimensions.c"
	} else {
#line 85 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 595 "Dimensions.c"
	}
#line 85 "../src/Dimensions.vala"
	result = _tmp0_;
#line 85 "../src/Dimensions.vala"
	return result;
#line 601 "Dimensions.c"
}

gboolean
dimensions_approx_equals (Dimensions *self,
                          Dimensions* dim,
                          gint fudge)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	gboolean result;
#line 89 "../src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 90 "../src/Dimensions.vala"
	_tmp1_ = *dim;
#line 90 "../src/Dimensions.vala"
	if (abs ((*self).width - _tmp1_.width) <= fudge) {
#line 618 "Dimensions.c"
		Dimensions _tmp2_;
#line 90 "../src/Dimensions.vala"
		_tmp2_ = *dim;
#line 90 "../src/Dimensions.vala"
		_tmp0_ = abs ((*self).height - _tmp2_.height) <= fudge;
#line 624 "Dimensions.c"
	} else {
#line 90 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 628 "Dimensions.c"
	}
#line 90 "../src/Dimensions.vala"
	result = _tmp0_;
#line 90 "../src/Dimensions.vala"
	return result;
#line 634 "Dimensions.c"
}

gboolean
dimensions_approx_scaled (Dimensions *self,
                          gint scale,
                          gint fudge)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 94 "../src/Dimensions.vala"
	if ((*self).width <= (scale + fudge)) {
#line 94 "../src/Dimensions.vala"
		_tmp0_ = (*self).height <= (scale + fudge);
#line 648 "Dimensions.c"
	} else {
#line 94 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 652 "Dimensions.c"
	}
#line 94 "../src/Dimensions.vala"
	result = _tmp0_;
#line 94 "../src/Dimensions.vala"
	return result;
#line 658 "Dimensions.c"
}

gint
dimensions_major_axis (Dimensions *self)
{
	gint result;
#line 98 "../src/Dimensions.vala"
	result = MAX ((*self).width, (*self).height);
#line 98 "../src/Dimensions.vala"
	return result;
#line 669 "Dimensions.c"
}

gint
dimensions_minor_axis (Dimensions *self)
{
	gint result;
#line 102 "../src/Dimensions.vala"
	result = MIN ((*self).width, (*self).height);
#line 102 "../src/Dimensions.vala"
	return result;
#line 680 "Dimensions.c"
}

void
dimensions_with_min (Dimensions *self,
                     gint min_width,
                     gint min_height,
                     Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 106 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, MAX ((*self).width, min_width), MAX ((*self).height, min_height));
#line 106 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 106 "../src/Dimensions.vala"
	return;
#line 696 "Dimensions.c"
}

void
dimensions_with_max (Dimensions *self,
                     gint max_width,
                     gint max_height,
                     Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 110 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, MIN ((*self).width, max_width), MIN ((*self).height, max_height));
#line 110 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 110 "../src/Dimensions.vala"
	return;
#line 712 "Dimensions.c"
}

void
dimensions_get_scaled (Dimensions *self,
                       gint scale,
                       gboolean scale_up,
                       Dimensions* result)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 114 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 117 "../src/Dimensions.vala"
	if ((*self).width == scale) {
#line 117 "../src/Dimensions.vala"
		_tmp1_ = (*self).height < scale;
#line 730 "Dimensions.c"
	} else {
#line 117 "../src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 734 "Dimensions.c"
	}
#line 117 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 117 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 740 "Dimensions.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 117 "../src/Dimensions.vala"
		if ((*self).height == scale) {
#line 117 "../src/Dimensions.vala"
			_tmp2_ = (*self).width < scale;
#line 747 "Dimensions.c"
		} else {
#line 117 "../src/Dimensions.vala"
			_tmp2_ = FALSE;
#line 751 "Dimensions.c"
		}
#line 117 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_;
#line 755 "Dimensions.c"
	}
#line 117 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 759 "Dimensions.c"
		Dimensions _tmp3_ = {0};
#line 118 "../src/Dimensions.vala"
		dimensions_init (&_tmp3_, (*self).width, (*self).height);
#line 118 "../src/Dimensions.vala"
		*result = _tmp3_;
#line 118 "../src/Dimensions.vala"
		return;
#line 767 "Dimensions.c"
	}
#line 121 "../src/Dimensions.vala"
	if (!scale_up) {
#line 771 "Dimensions.c"
		gboolean _tmp5_ = FALSE;
#line 121 "../src/Dimensions.vala"
		if ((*self).width < scale) {
#line 121 "../src/Dimensions.vala"
			_tmp5_ = (*self).height < scale;
#line 777 "Dimensions.c"
		} else {
#line 121 "../src/Dimensions.vala"
			_tmp5_ = FALSE;
#line 781 "Dimensions.c"
		}
#line 121 "../src/Dimensions.vala"
		_tmp4_ = _tmp5_;
#line 785 "Dimensions.c"
	} else {
#line 121 "../src/Dimensions.vala"
		_tmp4_ = FALSE;
#line 789 "Dimensions.c"
	}
#line 121 "../src/Dimensions.vala"
	if (_tmp4_) {
#line 793 "Dimensions.c"
		Dimensions _tmp6_ = {0};
#line 122 "../src/Dimensions.vala"
		dimensions_init (&_tmp6_, (*self).width, (*self).height);
#line 122 "../src/Dimensions.vala"
		*result = _tmp6_;
#line 122 "../src/Dimensions.vala"
		return;
#line 801 "Dimensions.c"
	}
#line 124 "../src/Dimensions.vala"
	if (((*self).width - scale) > ((*self).height - scale)) {
#line 805 "Dimensions.c"
		Dimensions _tmp7_ = {0};
#line 125 "../src/Dimensions.vala"
		dimensions_get_scaled_by_width (&(*self), scale, &_tmp7_);
#line 125 "../src/Dimensions.vala"
		*result = _tmp7_;
#line 125 "../src/Dimensions.vala"
		return;
#line 813 "Dimensions.c"
	} else {
		Dimensions _tmp8_ = {0};
#line 127 "../src/Dimensions.vala"
		dimensions_get_scaled_by_height (&(*self), scale, &_tmp8_);
#line 127 "../src/Dimensions.vala"
		*result = _tmp8_;
#line 127 "../src/Dimensions.vala"
		return;
#line 822 "Dimensions.c"
	}
}

void
dimensions_get_scale_ratios (Dimensions *self,
                             Dimensions* scaled,
                             gdouble* width_ratio,
                             gdouble* height_ratio)
{
	gdouble _vala_width_ratio = 0.0;
	gdouble _vala_height_ratio = 0.0;
	Dimensions _tmp0_;
	Dimensions _tmp1_;
#line 130 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 131 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 131 "../src/Dimensions.vala"
	_vala_width_ratio = ((gdouble) _tmp0_.width) / ((gdouble) (*self).width);
#line 132 "../src/Dimensions.vala"
	_tmp1_ = *scaled;
#line 132 "../src/Dimensions.vala"
	_vala_height_ratio = ((gdouble) _tmp1_.height) / ((gdouble) (*self).height);
#line 130 "../src/Dimensions.vala"
	if (width_ratio) {
#line 130 "../src/Dimensions.vala"
		*width_ratio = _vala_width_ratio;
#line 850 "Dimensions.c"
	}
#line 130 "../src/Dimensions.vala"
	if (height_ratio) {
#line 130 "../src/Dimensions.vala"
		*height_ratio = _vala_height_ratio;
#line 856 "Dimensions.c"
	}
}

gdouble
dimensions_get_aspect_ratio (Dimensions *self)
{
	gdouble result;
#line 136 "../src/Dimensions.vala"
	result = ((gdouble) (*self).width) / (*self).height;
#line 136 "../src/Dimensions.vala"
	return result;
#line 868 "Dimensions.c"
}

void
dimensions_get_scaled_proportional (Dimensions *self,
                                    Dimensions* viewport,
                                    Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	Dimensions scaled = {0};
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_;
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	Dimensions _tmp11_;
#line 139 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 141 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 141 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 141 "../src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 141 "../src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 144 "../src/Dimensions.vala"
	if (width_ratio < height_ratio) {
#line 903 "Dimensions.c"
		Dimensions _tmp3_;
#line 145 "../src/Dimensions.vala"
		_tmp3_ = *viewport;
#line 145 "../src/Dimensions.vala"
		scaled_width = (gdouble) _tmp3_.width;
#line 146 "../src/Dimensions.vala"
		scaled_height = ((gdouble) (*self).height) * width_ratio;
#line 911 "Dimensions.c"
	} else {
		Dimensions _tmp4_;
#line 148 "../src/Dimensions.vala"
		scaled_width = ((gdouble) (*self).width) * height_ratio;
#line 149 "../src/Dimensions.vala"
		_tmp4_ = *viewport;
#line 149 "../src/Dimensions.vala"
		scaled_height = (gdouble) _tmp4_.height;
#line 920 "Dimensions.c"
	}
#line 152 "../src/Dimensions.vala"
	dimensions_init (&_tmp5_, (gint) round (scaled_width), (gint) round (scaled_height));
#line 152 "../src/Dimensions.vala"
	dimensions_init (&_tmp6_, 1, 1);
#line 152 "../src/Dimensions.vala"
	dimensions_floor (&_tmp5_, &_tmp6_, &_tmp7_);
#line 152 "../src/Dimensions.vala"
	scaled = _tmp7_;
#line 154 "../src/Dimensions.vala"
	_tmp8_ = scaled;
#line 154 "../src/Dimensions.vala"
	_tmp9_ = *viewport;
#line 154 "../src/Dimensions.vala"
	_vala_assert (_tmp8_.height <= _tmp9_.height, "scaled.height <= viewport.height");
#line 155 "../src/Dimensions.vala"
	_tmp10_ = scaled;
#line 155 "../src/Dimensions.vala"
	_tmp11_ = *viewport;
#line 155 "../src/Dimensions.vala"
	_vala_assert (_tmp10_.width <= _tmp11_.width, "scaled.width <= viewport.width");
#line 157 "../src/Dimensions.vala"
	*result = scaled;
#line 157 "../src/Dimensions.vala"
	return;
#line 946 "Dimensions.c"
}

void
dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                        Dimensions* viewport,
                                        Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gboolean _tmp3_ = FALSE;
	Dimensions _tmp4_;
	Dimensions _tmp11_ = {0};
	Dimensions _tmp12_ = {0};
	Dimensions _tmp13_ = {0};
#line 160 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 162 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 162 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 162 "../src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 162 "../src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 165 "../src/Dimensions.vala"
	_tmp4_ = *viewport;
#line 165 "../src/Dimensions.vala"
	if ((*self).width < _tmp4_.width) {
#line 980 "Dimensions.c"
		Dimensions _tmp5_;
#line 165 "../src/Dimensions.vala"
		_tmp5_ = *viewport;
#line 165 "../src/Dimensions.vala"
		_tmp3_ = (*self).height >= _tmp5_.height;
#line 986 "Dimensions.c"
	} else {
#line 165 "../src/Dimensions.vala"
		_tmp3_ = FALSE;
#line 990 "Dimensions.c"
	}
#line 165 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 994 "Dimensions.c"
		Dimensions _tmp6_;
#line 167 "../src/Dimensions.vala"
		_tmp6_ = *viewport;
#line 167 "../src/Dimensions.vala"
		scaled_width = (gdouble) _tmp6_.width;
#line 168 "../src/Dimensions.vala"
		scaled_height = ((gdouble) (*self).height) * width_ratio;
#line 1002 "Dimensions.c"
	} else {
		gboolean _tmp7_ = FALSE;
		Dimensions _tmp8_;
#line 169 "../src/Dimensions.vala"
		_tmp8_ = *viewport;
#line 169 "../src/Dimensions.vala"
		if ((*self).width >= _tmp8_.width) {
#line 1010 "Dimensions.c"
			Dimensions _tmp9_;
#line 169 "../src/Dimensions.vala"
			_tmp9_ = *viewport;
#line 169 "../src/Dimensions.vala"
			_tmp7_ = (*self).height < _tmp9_.height;
#line 1016 "Dimensions.c"
		} else {
#line 169 "../src/Dimensions.vala"
			_tmp7_ = FALSE;
#line 1020 "Dimensions.c"
		}
#line 169 "../src/Dimensions.vala"
		if (_tmp7_) {
#line 1024 "Dimensions.c"
			Dimensions _tmp10_;
#line 171 "../src/Dimensions.vala"
			scaled_width = ((gdouble) (*self).width) * height_ratio;
#line 172 "../src/Dimensions.vala"
			_tmp10_ = *viewport;
#line 172 "../src/Dimensions.vala"
			scaled_height = (gdouble) _tmp10_.height;
#line 1032 "Dimensions.c"
		} else {
			gdouble ratio = 0.0;
#line 175 "../src/Dimensions.vala"
			ratio = MAX (width_ratio, height_ratio);
#line 177 "../src/Dimensions.vala"
			scaled_width = ((gdouble) (*self).width) * ratio;
#line 178 "../src/Dimensions.vala"
			scaled_height = ((gdouble) (*self).height) * ratio;
#line 1041 "Dimensions.c"
		}
	}
#line 181 "../src/Dimensions.vala"
	dimensions_init (&_tmp11_, (gint) round (scaled_width), (gint) round (scaled_height));
#line 181 "../src/Dimensions.vala"
	dimensions_init (&_tmp12_, 1, 1);
#line 181 "../src/Dimensions.vala"
	dimensions_floor (&_tmp11_, &_tmp12_, &_tmp13_);
#line 181 "../src/Dimensions.vala"
	*result = _tmp13_;
#line 181 "../src/Dimensions.vala"
	return;
#line 1054 "Dimensions.c"
}

void
dimensions_get_scaled_rectangle (Dimensions *self,
                                 Dimensions* scaled,
                                 GdkRectangle* rect,
                                 GdkRectangle* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GdkRectangle scaled_rect = {0};
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
#line 184 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 184 "../src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 186 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 186 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 186 "../src/Dimensions.vala"
	x_scale = _tmp1_;
#line 186 "../src/Dimensions.vala"
	y_scale = _tmp2_;
#line 188 "../src/Dimensions.vala"
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
#line 189 "../src/Dimensions.vala"
	_tmp3_ = *rect;
#line 189 "../src/Dimensions.vala"
	scaled_rect.x = (gint) round (((gdouble) _tmp3_.x) * x_scale);
#line 190 "../src/Dimensions.vala"
	_tmp4_ = *rect;
#line 190 "../src/Dimensions.vala"
	scaled_rect.y = (gint) round (((gdouble) _tmp4_.y) * y_scale);
#line 191 "../src/Dimensions.vala"
	_tmp5_ = *rect;
#line 191 "../src/Dimensions.vala"
	scaled_rect.width = (gint) round (((gdouble) _tmp5_.width) * x_scale);
#line 192 "../src/Dimensions.vala"
	_tmp6_ = *rect;
#line 192 "../src/Dimensions.vala"
	scaled_rect.height = (gint) round (((gdouble) _tmp6_.height) * y_scale);
#line 194 "../src/Dimensions.vala"
	_tmp7_ = scaled_rect;
#line 194 "../src/Dimensions.vala"
	if (_tmp7_.width <= 0) {
#line 195 "../src/Dimensions.vala"
		scaled_rect.width = 1;
#line 1111 "Dimensions.c"
	}
#line 197 "../src/Dimensions.vala"
	_tmp8_ = scaled_rect;
#line 197 "../src/Dimensions.vala"
	if (_tmp8_.height <= 0) {
#line 198 "../src/Dimensions.vala"
		scaled_rect.height = 1;
#line 1119 "Dimensions.c"
	}
#line 200 "../src/Dimensions.vala"
	*result = scaled_rect;
#line 200 "../src/Dimensions.vala"
	return;
#line 1125 "Dimensions.c"
}

void
dimensions_get_scaled_similar (Dimensions *self,
                               Dimensions* original,
                               Dimensions* scaled,
                               Dimensions* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scale = 0.0;
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
#line 204 "../src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 204 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 206 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 206 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 206 "../src/Dimensions.vala"
	x_scale = _tmp1_;
#line 206 "../src/Dimensions.vala"
	y_scale = _tmp2_;
#line 208 "../src/Dimensions.vala"
	scale = MIN (x_scale, y_scale);
#line 210 "../src/Dimensions.vala"
	dimensions_init (&_tmp3_, (gint) round (((gdouble) (*self).width) * scale), (gint) round (((gdouble) (*self).height) * scale));
#line 210 "../src/Dimensions.vala"
	dimensions_init (&_tmp4_, 1, 1);
#line 210 "../src/Dimensions.vala"
	dimensions_floor (&_tmp3_, &_tmp4_, &_tmp5_);
#line 210 "../src/Dimensions.vala"
	*result = _tmp5_;
#line 210 "../src/Dimensions.vala"
	return;
#line 1167 "Dimensions.c"
}

void
dimensions_get_scaled_by_width (Dimensions *self,
                                gint scale,
                                Dimensions* result)
{
	gdouble ratio = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 215 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 217 "../src/Dimensions.vala"
	ratio = ((gdouble) scale) / ((gdouble) (*self).width);
#line 219 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, scale, (gint) round (((gdouble) (*self).height) * ratio));
#line 219 "../src/Dimensions.vala"
	dimensions_init (&_tmp1_, 1, 1);
#line 219 "../src/Dimensions.vala"
	dimensions_floor (&_tmp0_, &_tmp1_, &_tmp2_);
#line 219 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 219 "../src/Dimensions.vala"
	return;
#line 1193 "Dimensions.c"
}

void
dimensions_get_scaled_by_height (Dimensions *self,
                                 gint scale,
                                 Dimensions* result)
{
	gdouble ratio = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 223 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 225 "../src/Dimensions.vala"
	ratio = ((gdouble) scale) / ((gdouble) (*self).height);
#line 227 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, (gint) round (((gdouble) (*self).width) * ratio), scale);
#line 227 "../src/Dimensions.vala"
	dimensions_init (&_tmp1_, 1, 1);
#line 227 "../src/Dimensions.vala"
	dimensions_floor (&_tmp0_, &_tmp1_, &_tmp2_);
#line 227 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 227 "../src/Dimensions.vala"
	return;
#line 1219 "Dimensions.c"
}

void
dimensions_get_scaled_by_constraint (Dimensions *self,
                                     gint scale,
                                     ScaleConstraint constraint,
                                     Dimensions* result)
{
#line 231 "../src/Dimensions.vala"
	switch (constraint) {
#line 231 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 1232 "Dimensions.c"
		{
			Dimensions _tmp0_ = {0};
#line 233 "../src/Dimensions.vala"
			dimensions_init (&_tmp0_, (*self).width, (*self).height);
#line 233 "../src/Dimensions.vala"
			*result = _tmp0_;
#line 233 "../src/Dimensions.vala"
			return;
#line 1241 "Dimensions.c"
		}
#line 231 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 1245 "Dimensions.c"
		{
			Dimensions _tmp1_ = {0};
#line 236 "../src/Dimensions.vala"
			if ((*self).width >= (*self).height) {
#line 1250 "Dimensions.c"
				Dimensions _tmp2_ = {0};
#line 236 "../src/Dimensions.vala"
				dimensions_get_scaled_by_width (&(*self), scale, &_tmp2_);
#line 236 "../src/Dimensions.vala"
				_tmp1_ = _tmp2_;
#line 1256 "Dimensions.c"
			} else {
				Dimensions _tmp3_ = {0};
#line 236 "../src/Dimensions.vala"
				dimensions_get_scaled_by_height (&(*self), scale, &_tmp3_);
#line 236 "../src/Dimensions.vala"
				_tmp1_ = _tmp3_;
#line 1263 "Dimensions.c"
			}
#line 236 "../src/Dimensions.vala"
			*result = _tmp1_;
#line 236 "../src/Dimensions.vala"
			return;
#line 1269 "Dimensions.c"
		}
#line 231 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 1273 "Dimensions.c"
		{
			Dimensions _tmp4_ = {0};
#line 239 "../src/Dimensions.vala"
			dimensions_get_scaled_by_width (&(*self), scale, &_tmp4_);
#line 239 "../src/Dimensions.vala"
			*result = _tmp4_;
#line 239 "../src/Dimensions.vala"
			return;
#line 1282 "Dimensions.c"
		}
#line 231 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 1286 "Dimensions.c"
		{
			Dimensions _tmp5_ = {0};
#line 242 "../src/Dimensions.vala"
			dimensions_get_scaled_by_height (&(*self), scale, &_tmp5_);
#line 242 "../src/Dimensions.vala"
			*result = _tmp5_;
#line 242 "../src/Dimensions.vala"
			return;
#line 1295 "Dimensions.c"
		}
		default:
		{
#line 245 "../src/Dimensions.vala"
			g_error ("Dimensions.vala:245: Bad constraint: %d", (gint) constraint);
#line 1301 "Dimensions.c"
		}
	}
}

Dimensions*
dimensions_dup (const Dimensions* self)
{
	Dimensions* dup;
#line 39 "../src/Dimensions.vala"
	dup = g_new0 (Dimensions, 1);
#line 39 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (Dimensions));
#line 39 "../src/Dimensions.vala"
	return dup;
#line 1316 "Dimensions.c"
}

void
dimensions_free (Dimensions* self)
{
#line 39 "../src/Dimensions.vala"
	g_free (self);
#line 1324 "Dimensions.c"
}

static GType
dimensions_get_type_once (void)
{
	GType dimensions_type_id;
	dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
	return dimensions_type_id;
}

GType
dimensions_get_type (void)
{
	static volatile gsize dimensions_type_id__once = 0;
	if (g_once_init_enter (&dimensions_type_id__once)) {
		GType dimensions_type_id;
		dimensions_type_id = dimensions_get_type_once ();
		g_once_init_leave (&dimensions_type_id__once, dimensions_type_id);
	}
	return dimensions_type_id__once;
}

static void
scaling_init (Scaling *self,
              ScaleConstraint constraint,
              gint scale,
              Dimensions* viewport,
              gboolean scale_up)
{
	Dimensions _tmp0_;
#line 258 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 258 "../src/Dimensions.vala"
	memset (self, 0, sizeof (Scaling));
#line 259 "../src/Dimensions.vala"
	(*self).constraint = constraint;
#line 260 "../src/Dimensions.vala"
	(*self).scale = scale;
#line 261 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 261 "../src/Dimensions.vala"
	(*self).viewport = _tmp0_;
#line 262 "../src/Dimensions.vala"
	(*self).scale_up = scale_up;
#line 1369 "Dimensions.c"
}

void
scaling_for_original (Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 266 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 266 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, &_tmp0_, FALSE);
#line 266 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 266 "../src/Dimensions.vala"
	return;
#line 1385 "Dimensions.c"
}

void
scaling_for_screen (GtkWindow* window,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 269 "../src/Dimensions.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (window, gtk_window_get_type ()));
#line 270 "../src/Dimensions.vala"
	scaling_get_screen_dimensions (window, &_tmp0_);
#line 270 "../src/Dimensions.vala"
	scaling_for_viewport (&_tmp0_, scale_up, &_tmp1_);
#line 270 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 270 "../src/Dimensions.vala"
	return;
#line 1405 "Dimensions.c"
}

void
scaling_for_best_fit (gint pixels,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 274 "../src/Dimensions.vala"
	_vala_assert (pixels > 0, "pixels > 0");
#line 276 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 276 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, pixels, &_tmp0_, scale_up);
#line 276 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 276 "../src/Dimensions.vala"
	return;
#line 1425 "Dimensions.c"
}

void
scaling_for_viewport (Dimensions* viewport,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_;
	Scaling _tmp1_ = {0};
#line 279 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 280 "../src/Dimensions.vala"
	_vala_assert (dimensions_has_area (viewport), "viewport.has_area()");
#line 282 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 282 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp0_, scale_up);
#line 282 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 282 "../src/Dimensions.vala"
	return;
#line 1447 "Dimensions.c"
}

void
scaling_for_widget (GtkWidget* widget,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions viewport = {0};
	Dimensions _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_;
	Dimensions _tmp5_;
	Scaling _tmp6_ = {0};
#line 285 "../src/Dimensions.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 286 "../src/Dimensions.vala"
	dimensions_for_widget_allocation (widget, &_tmp0_);
#line 286 "../src/Dimensions.vala"
	viewport = _tmp0_;
#line 296 "../src/Dimensions.vala"
	_tmp2_ = viewport;
#line 296 "../src/Dimensions.vala"
	if (_tmp2_.width <= 1) {
#line 296 "../src/Dimensions.vala"
		_tmp1_ = TRUE;
#line 1473 "Dimensions.c"
	} else {
		Dimensions _tmp3_;
#line 296 "../src/Dimensions.vala"
		_tmp3_ = viewport;
#line 296 "../src/Dimensions.vala"
		_tmp1_ = _tmp3_.height <= 1;
#line 1480 "Dimensions.c"
	}
#line 296 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 1484 "Dimensions.c"
		Scaling _tmp4_ = {0};
#line 297 "../src/Dimensions.vala"
		scaling_for_original (&_tmp4_);
#line 297 "../src/Dimensions.vala"
		*result = _tmp4_;
#line 297 "../src/Dimensions.vala"
		return;
#line 1492 "Dimensions.c"
	}
#line 299 "../src/Dimensions.vala"
	_tmp5_ = viewport;
#line 299 "../src/Dimensions.vala"
	scaling_init (&_tmp6_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp5_, scale_up);
#line 299 "../src/Dimensions.vala"
	*result = _tmp6_;
#line 299 "../src/Dimensions.vala"
	return;
#line 1502 "Dimensions.c"
}

void
scaling_to_fill_viewport (Dimensions* viewport,
                          Scaling* result)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	Dimensions _tmp4_;
	Scaling _tmp5_ = {0};
#line 302 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 305 "../src/Dimensions.vala"
	_tmp1_ = *viewport;
#line 305 "../src/Dimensions.vala"
	if (_tmp1_.width <= 1) {
#line 305 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 1521 "Dimensions.c"
	} else {
		Dimensions _tmp2_;
#line 305 "../src/Dimensions.vala"
		_tmp2_ = *viewport;
#line 305 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_.height <= 1;
#line 1528 "Dimensions.c"
	}
#line 305 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 1532 "Dimensions.c"
		Scaling _tmp3_ = {0};
#line 306 "../src/Dimensions.vala"
		scaling_for_original (&_tmp3_);
#line 306 "../src/Dimensions.vala"
		*result = _tmp3_;
#line 306 "../src/Dimensions.vala"
		return;
#line 1540 "Dimensions.c"
	}
#line 308 "../src/Dimensions.vala"
	_tmp4_ = *viewport;
#line 308 "../src/Dimensions.vala"
	scaling_init (&_tmp5_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, &_tmp4_, TRUE);
#line 308 "../src/Dimensions.vala"
	*result = _tmp5_;
#line 308 "../src/Dimensions.vala"
	return;
#line 1550 "Dimensions.c"
}

void
scaling_to_fill_screen (GtkWindow* window,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 311 "../src/Dimensions.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (window, gtk_window_get_type ()));
#line 312 "../src/Dimensions.vala"
	scaling_get_screen_dimensions (window, &_tmp0_);
#line 312 "../src/Dimensions.vala"
	scaling_to_fill_viewport (&_tmp0_, &_tmp1_);
#line 312 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 312 "../src/Dimensions.vala"
	return;
#line 1569 "Dimensions.c"
}

void
scaling_for_constraint (ScaleConstraint constraint,
                        gint scale,
                        gboolean scale_up,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 316 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 316 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, constraint, scale, &_tmp0_, scale_up);
#line 316 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 316 "../src/Dimensions.vala"
	return;
#line 1588 "Dimensions.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 320 "../src/Dimensions.vala"
	return self ? g_object_ref (self) : NULL;
#line 1596 "Dimensions.c"
}

void
scaling_get_screen_dimensions (GtkWindow* window,
                               Dimensions* result)
{
	GdkDisplay* display = NULL;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkMonitor* monitor = NULL;
	GdkWindow* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
	GdkRectangle geom = {0};
	GdkRectangle _tmp6_ = {0};
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	Dimensions _tmp9_ = {0};
#line 319 "../src/Dimensions.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (window, gtk_window_get_type ()));
#line 320 "../src/Dimensions.vala"
	_tmp0_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (window, gtk_widget_get_type (), GtkWidget));
#line 320 "../src/Dimensions.vala"
	_tmp1_ = gdk_window_get_display (_tmp0_);
#line 320 "../src/Dimensions.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 320 "../src/Dimensions.vala"
	display = _tmp2_;
#line 321 "../src/Dimensions.vala"
	_tmp3_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (window, gtk_widget_get_type (), GtkWidget));
#line 321 "../src/Dimensions.vala"
	_tmp4_ = gdk_display_get_monitor_at_window (display, _tmp3_);
#line 321 "../src/Dimensions.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 321 "../src/Dimensions.vala"
	monitor = _tmp5_;
#line 322 "../src/Dimensions.vala"
	gdk_monitor_get_geometry (monitor, &_tmp6_);
#line 322 "../src/Dimensions.vala"
	geom = _tmp6_;
#line 324 "../src/Dimensions.vala"
	_tmp7_ = geom;
#line 324 "../src/Dimensions.vala"
	_tmp8_ = geom;
#line 324 "../src/Dimensions.vala"
	dimensions_init (&_tmp9_, _tmp7_.width, _tmp8_.height);
#line 324 "../src/Dimensions.vala"
	*result = _tmp9_;
#line 324 "../src/Dimensions.vala"
	_g_object_unref0 (monitor);
#line 324 "../src/Dimensions.vala"
	_g_object_unref0 (display);
#line 324 "../src/Dimensions.vala"
	return;
#line 1652 "Dimensions.c"
}

static gint
scaling_scale_to_pixels (Scaling *self)
{
	gint _tmp0_ = 0;
	gint result;
#line 328 "../src/Dimensions.vala"
	if ((*self).scale >= 0) {
#line 328 "../src/Dimensions.vala"
		_tmp0_ = (*self).scale;
#line 1664 "Dimensions.c"
	} else {
#line 328 "../src/Dimensions.vala"
		_tmp0_ = 0;
#line 1668 "Dimensions.c"
	}
#line 328 "../src/Dimensions.vala"
	result = _tmp0_;
#line 328 "../src/Dimensions.vala"
	return result;
#line 1674 "Dimensions.c"
}

gboolean
scaling_is_unscaled (Scaling *self)
{
	gboolean result;
#line 332 "../src/Dimensions.vala"
	result = (*self).constraint == SCALE_CONSTRAINT_ORIGINAL;
#line 332 "../src/Dimensions.vala"
	return result;
#line 1685 "Dimensions.c"
}

gboolean
scaling_is_best_fit (Scaling *self,
                     Dimensions* original,
                     gint* pixels)
{
	gint _vala_pixels = 0;
	gboolean result;
#line 335 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 336 "../src/Dimensions.vala"
	_vala_pixels = 0;
#line 338 "../src/Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 339 "../src/Dimensions.vala"
		result = FALSE;
#line 339 "../src/Dimensions.vala"
		if (pixels) {
#line 339 "../src/Dimensions.vala"
			*pixels = _vala_pixels;
#line 1707 "Dimensions.c"
		}
#line 339 "../src/Dimensions.vala"
		return result;
#line 1711 "Dimensions.c"
	}
#line 341 "../src/Dimensions.vala"
	switch ((*self).constraint) {
#line 341 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 341 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1719 "Dimensions.c"
		{
#line 344 "../src/Dimensions.vala"
			result = FALSE;
#line 344 "../src/Dimensions.vala"
			if (pixels) {
#line 344 "../src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 1727 "Dimensions.c"
			}
#line 344 "../src/Dimensions.vala"
			return result;
#line 1731 "Dimensions.c"
		}
		default:
		{
#line 347 "../src/Dimensions.vala"
			_vala_pixels = scaling_scale_to_pixels (&(*self));
#line 348 "../src/Dimensions.vala"
			_vala_assert (_vala_pixels > 0, "pixels > 0");
#line 350 "../src/Dimensions.vala"
			result = TRUE;
#line 350 "../src/Dimensions.vala"
			if (pixels) {
#line 350 "../src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 1745 "Dimensions.c"
			}
#line 350 "../src/Dimensions.vala"
			return result;
#line 1749 "Dimensions.c"
		}
	}
}

gboolean
scaling_is_best_fit_dimensions (Scaling *self,
                                Dimensions* original,
                                Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result;
#line 354 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 355 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 357 "../src/Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 358 "../src/Dimensions.vala"
		result = FALSE;
#line 358 "../src/Dimensions.vala"
		if (scaled) {
#line 358 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1773 "Dimensions.c"
		}
#line 358 "../src/Dimensions.vala"
		return result;
#line 1777 "Dimensions.c"
	}
#line 360 "../src/Dimensions.vala"
	switch ((*self).constraint) {
#line 360 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 360 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1785 "Dimensions.c"
		{
#line 363 "../src/Dimensions.vala"
			result = FALSE;
#line 363 "../src/Dimensions.vala"
			if (scaled) {
#line 363 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1793 "Dimensions.c"
			}
#line 363 "../src/Dimensions.vala"
			return result;
#line 1797 "Dimensions.c"
		}
		default:
		{
			gint pixels = 0;
			Dimensions _tmp0_ = {0};
#line 366 "../src/Dimensions.vala"
			pixels = scaling_scale_to_pixels (&(*self));
#line 367 "../src/Dimensions.vala"
			_vala_assert (pixels > 0, "pixels > 0");
#line 369 "../src/Dimensions.vala"
			dimensions_get_scaled_by_constraint (original, pixels, (*self).constraint, &_tmp0_);
#line 369 "../src/Dimensions.vala"
			_vala_scaled = _tmp0_;
#line 371 "../src/Dimensions.vala"
			result = TRUE;
#line 371 "../src/Dimensions.vala"
			if (scaled) {
#line 371 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1817 "Dimensions.c"
			}
#line 371 "../src/Dimensions.vala"
			return result;
#line 1821 "Dimensions.c"
		}
	}
}

gboolean
scaling_is_for_viewport (Scaling *self,
                         Dimensions* original,
                         Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result;
#line 375 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 376 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 378 "../src/Dimensions.vala"
	if ((*self).scale != SCALING_NO_SCALE) {
#line 379 "../src/Dimensions.vala"
		result = FALSE;
#line 379 "../src/Dimensions.vala"
		if (scaled) {
#line 379 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1845 "Dimensions.c"
		}
#line 379 "../src/Dimensions.vala"
		return result;
#line 1849 "Dimensions.c"
	}
#line 381 "../src/Dimensions.vala"
	switch ((*self).constraint) {
#line 381 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 381 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1857 "Dimensions.c"
		{
#line 384 "../src/Dimensions.vala"
			result = FALSE;
#line 384 "../src/Dimensions.vala"
			if (scaled) {
#line 384 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1865 "Dimensions.c"
			}
#line 384 "../src/Dimensions.vala"
			return result;
#line 1869 "Dimensions.c"
		}
		default:
		{
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
#line 387 "../src/Dimensions.vala"
			_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area()");
#line 389 "../src/Dimensions.vala"
			if (!(*self).scale_up) {
#line 1879 "Dimensions.c"
				Dimensions _tmp2_;
				Dimensions _tmp3_;
#line 389 "../src/Dimensions.vala"
				_tmp2_ = *original;
#line 389 "../src/Dimensions.vala"
				_tmp3_ = (*self).viewport;
#line 389 "../src/Dimensions.vala"
				_tmp1_ = _tmp2_.width < _tmp3_.width;
#line 1888 "Dimensions.c"
			} else {
#line 389 "../src/Dimensions.vala"
				_tmp1_ = FALSE;
#line 1892 "Dimensions.c"
			}
#line 389 "../src/Dimensions.vala"
			if (_tmp1_) {
#line 1896 "Dimensions.c"
				Dimensions _tmp4_;
				Dimensions _tmp5_;
#line 389 "../src/Dimensions.vala"
				_tmp4_ = *original;
#line 389 "../src/Dimensions.vala"
				_tmp5_ = (*self).viewport;
#line 389 "../src/Dimensions.vala"
				_tmp0_ = _tmp4_.height < _tmp5_.height;
#line 1905 "Dimensions.c"
			} else {
#line 389 "../src/Dimensions.vala"
				_tmp0_ = FALSE;
#line 1909 "Dimensions.c"
			}
#line 389 "../src/Dimensions.vala"
			if (_tmp0_) {
#line 1913 "Dimensions.c"
				Dimensions _tmp6_;
#line 390 "../src/Dimensions.vala"
				_tmp6_ = *original;
#line 390 "../src/Dimensions.vala"
				_vala_scaled = _tmp6_;
#line 1919 "Dimensions.c"
			} else {
				Dimensions _tmp7_;
				Dimensions _tmp8_ = {0};
#line 392 "../src/Dimensions.vala"
				_tmp7_ = (*self).viewport;
#line 392 "../src/Dimensions.vala"
				dimensions_get_scaled_proportional (original, &_tmp7_, &_tmp8_);
#line 392 "../src/Dimensions.vala"
				_vala_scaled = _tmp8_;
#line 1929 "Dimensions.c"
			}
#line 394 "../src/Dimensions.vala"
			result = TRUE;
#line 394 "../src/Dimensions.vala"
			if (scaled) {
#line 394 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1937 "Dimensions.c"
			}
#line 394 "../src/Dimensions.vala"
			return result;
#line 1941 "Dimensions.c"
		}
	}
}

gboolean
scaling_is_fill_viewport (Scaling *self,
                          Dimensions* original,
                          Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	Dimensions _tmp0_;
	Dimensions _tmp1_ = {0};
	gboolean result;
#line 398 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 399 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 401 "../src/Dimensions.vala"
	if ((*self).constraint != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 402 "../src/Dimensions.vala"
		result = FALSE;
#line 402 "../src/Dimensions.vala"
		if (scaled) {
#line 402 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1967 "Dimensions.c"
		}
#line 402 "../src/Dimensions.vala"
		return result;
#line 1971 "Dimensions.c"
	}
#line 404 "../src/Dimensions.vala"
	_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area()");
#line 405 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport;
#line 405 "../src/Dimensions.vala"
	dimensions_get_scaled_to_fill_viewport (original, &_tmp0_, &_tmp1_);
#line 405 "../src/Dimensions.vala"
	_vala_scaled = _tmp1_;
#line 407 "../src/Dimensions.vala"
	result = TRUE;
#line 407 "../src/Dimensions.vala"
	if (scaled) {
#line 407 "../src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 1987 "Dimensions.c"
	}
#line 407 "../src/Dimensions.vala"
	return result;
#line 1991 "Dimensions.c"
}

void
scaling_get_scaled_dimensions (Scaling *self,
                               Dimensions* original,
                               Dimensions* result)
{
	Dimensions scaled = {0};
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp5_ = {0};
	gboolean _tmp6_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp7_;
	Dimensions _tmp8_ = {0};
	gboolean _tmp9_;
#line 410 "../src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 411 "../src/Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 2014 "Dimensions.c"
		Dimensions _tmp0_;
#line 412 "../src/Dimensions.vala"
		_tmp0_ = *original;
#line 412 "../src/Dimensions.vala"
		*result = _tmp0_;
#line 412 "../src/Dimensions.vala"
		return;
#line 2022 "Dimensions.c"
	}
#line 415 "../src/Dimensions.vala"
	_tmp1_ = *original;
#line 415 "../src/Dimensions.vala"
	_tmp3_ = scaling_is_fill_viewport (&(*self), &_tmp1_, &_tmp2_);
#line 415 "../src/Dimensions.vala"
	scaled = _tmp2_;
#line 415 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 416 "../src/Dimensions.vala"
		*result = scaled;
#line 416 "../src/Dimensions.vala"
		return;
#line 2036 "Dimensions.c"
	}
#line 418 "../src/Dimensions.vala"
	_tmp4_ = *original;
#line 418 "../src/Dimensions.vala"
	_tmp6_ = scaling_is_best_fit_dimensions (&(*self), &_tmp4_, &_tmp5_);
#line 418 "../src/Dimensions.vala"
	scaled = _tmp5_;
#line 418 "../src/Dimensions.vala"
	if (_tmp6_) {
#line 419 "../src/Dimensions.vala"
		*result = scaled;
#line 419 "../src/Dimensions.vala"
		return;
#line 2050 "Dimensions.c"
	}
#line 421 "../src/Dimensions.vala"
	_tmp7_ = *original;
#line 421 "../src/Dimensions.vala"
	_tmp9_ = scaling_is_for_viewport (&(*self), &_tmp7_, &_tmp8_);
#line 421 "../src/Dimensions.vala"
	scaled = _tmp8_;
#line 421 "../src/Dimensions.vala"
	is_viewport = _tmp9_;
#line 422 "../src/Dimensions.vala"
	_vala_assert (is_viewport, "is_viewport");
#line 424 "../src/Dimensions.vala"
	*result = scaled;
#line 424 "../src/Dimensions.vala"
	return;
#line 2066 "Dimensions.c"
}

GdkPixbuf*
scaling_perform_on_pixbuf (Scaling *self,
                           GdkPixbuf* pixbuf,
                           GdkInterpType interp,
                           gboolean scale_up)
{
	Dimensions pixbuf_dim = {0};
	Dimensions _tmp1_ = {0};
	gint pixels = 0;
	Dimensions _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	Dimensions scaled = {0};
	Dimensions _tmp6_;
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp11_;
	Dimensions _tmp12_ = {0};
	gboolean _tmp13_;
	Dimensions _tmp14_;
	GdkPixbuf* _tmp15_;
	GdkPixbuf* result;
#line 427 "../src/Dimensions.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 428 "../src/Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 2096 "Dimensions.c"
		GdkPixbuf* _tmp0_;
#line 429 "../src/Dimensions.vala"
		_tmp0_ = _g_object_ref0 (pixbuf);
#line 429 "../src/Dimensions.vala"
		result = _tmp0_;
#line 429 "../src/Dimensions.vala"
		return result;
#line 2104 "Dimensions.c"
	}
#line 431 "../src/Dimensions.vala"
	dimensions_for_pixbuf (pixbuf, &_tmp1_);
#line 431 "../src/Dimensions.vala"
	pixbuf_dim = _tmp1_;
#line 434 "../src/Dimensions.vala"
	_tmp2_ = pixbuf_dim;
#line 434 "../src/Dimensions.vala"
	_tmp4_ = scaling_is_best_fit (&(*self), &_tmp2_, &_tmp3_);
#line 434 "../src/Dimensions.vala"
	pixels = _tmp3_;
#line 434 "../src/Dimensions.vala"
	if (_tmp4_) {
#line 2118 "Dimensions.c"
		GdkPixbuf* _tmp5_;
#line 435 "../src/Dimensions.vala"
		_tmp5_ = scale_pixbuf (pixbuf, pixels, interp, scale_up);
#line 435 "../src/Dimensions.vala"
		result = _tmp5_;
#line 435 "../src/Dimensions.vala"
		return result;
#line 2126 "Dimensions.c"
	}
#line 438 "../src/Dimensions.vala"
	_tmp6_ = pixbuf_dim;
#line 438 "../src/Dimensions.vala"
	_tmp8_ = scaling_is_fill_viewport (&(*self), &_tmp6_, &_tmp7_);
#line 438 "../src/Dimensions.vala"
	scaled = _tmp7_;
#line 438 "../src/Dimensions.vala"
	if (_tmp8_) {
#line 2136 "Dimensions.c"
		Dimensions _tmp9_;
		GdkPixbuf* _tmp10_;
#line 439 "../src/Dimensions.vala"
		_tmp9_ = scaled;
#line 439 "../src/Dimensions.vala"
		_tmp10_ = resize_pixbuf (pixbuf, &_tmp9_, interp);
#line 439 "../src/Dimensions.vala"
		result = _tmp10_;
#line 439 "../src/Dimensions.vala"
		return result;
#line 2147 "Dimensions.c"
	}
#line 441 "../src/Dimensions.vala"
	_tmp11_ = pixbuf_dim;
#line 441 "../src/Dimensions.vala"
	_tmp13_ = scaling_is_for_viewport (&(*self), &_tmp11_, &_tmp12_);
#line 441 "../src/Dimensions.vala"
	scaled = _tmp12_;
#line 441 "../src/Dimensions.vala"
	is_viewport = _tmp13_;
#line 442 "../src/Dimensions.vala"
	_vala_assert (is_viewport, "is_viewport");
#line 444 "../src/Dimensions.vala"
	_tmp14_ = scaled;
#line 444 "../src/Dimensions.vala"
	_tmp15_ = resize_pixbuf (pixbuf, &_tmp14_, interp);
#line 444 "../src/Dimensions.vala"
	result = _tmp15_;
#line 444 "../src/Dimensions.vala"
	return result;
#line 2167 "Dimensions.c"
}

gchar*
scaling_to_string (Scaling *self)
{
	gchar* result;
#line 448 "../src/Dimensions.vala"
	if ((*self).constraint == SCALE_CONSTRAINT_ORIGINAL) {
#line 2176 "Dimensions.c"
		gchar* _tmp0_;
#line 449 "../src/Dimensions.vala"
		_tmp0_ = g_strdup ("scaling: UNSCALED");
#line 449 "../src/Dimensions.vala"
		result = _tmp0_;
#line 449 "../src/Dimensions.vala"
		return result;
#line 2184 "Dimensions.c"
	} else {
#line 450 "../src/Dimensions.vala"
		if ((*self).constraint == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 2188 "Dimensions.c"
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 451 "../src/Dimensions.vala"
			_tmp1_ = dimensions_to_string (&(*self).viewport);
#line 451 "../src/Dimensions.vala"
			_tmp2_ = _tmp1_;
#line 451 "../src/Dimensions.vala"
			_tmp3_ = g_strdup_printf ("scaling: fill viewport %s", _tmp2_);
#line 451 "../src/Dimensions.vala"
			_tmp4_ = _tmp3_;
#line 451 "../src/Dimensions.vala"
			_g_free0 (_tmp2_);
#line 451 "../src/Dimensions.vala"
			result = _tmp4_;
#line 451 "../src/Dimensions.vala"
			return result;
#line 2207 "Dimensions.c"
		} else {
#line 452 "../src/Dimensions.vala"
			if ((*self).scale != SCALING_NO_SCALE) {
#line 2211 "Dimensions.c"
				const gchar* _tmp5_ = NULL;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 454 "../src/Dimensions.vala"
				if ((*self).scale_up) {
#line 454 "../src/Dimensions.vala"
					_tmp5_ = "scaled up";
#line 2221 "Dimensions.c"
				} else {
#line 454 "../src/Dimensions.vala"
					_tmp5_ = "not scaled up";
#line 2225 "Dimensions.c"
				}
#line 453 "../src/Dimensions.vala"
				_tmp6_ = scale_constraint_to_string ((*self).constraint);
#line 453 "../src/Dimensions.vala"
				_tmp7_ = _tmp6_;
#line 453 "../src/Dimensions.vala"
				_tmp8_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp7_, scaling_scale_to_pixels (&(*self)), _tmp5_);
#line 453 "../src/Dimensions.vala"
				_tmp9_ = _tmp8_;
#line 453 "../src/Dimensions.vala"
				_g_free0 (_tmp7_);
#line 453 "../src/Dimensions.vala"
				result = _tmp9_;
#line 453 "../src/Dimensions.vala"
				return result;
#line 2241 "Dimensions.c"
			} else {
				const gchar* _tmp10_ = NULL;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 457 "../src/Dimensions.vala"
				if ((*self).scale_up) {
#line 457 "../src/Dimensions.vala"
					_tmp10_ = "scaled up";
#line 2252 "Dimensions.c"
				} else {
#line 457 "../src/Dimensions.vala"
					_tmp10_ = "not scaled up";
#line 2256 "Dimensions.c"
				}
#line 456 "../src/Dimensions.vala"
				_tmp11_ = dimensions_to_string (&(*self).viewport);
#line 456 "../src/Dimensions.vala"
				_tmp12_ = _tmp11_;
#line 456 "../src/Dimensions.vala"
				_tmp13_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp12_, _tmp10_);
#line 456 "../src/Dimensions.vala"
				_tmp14_ = _tmp13_;
#line 456 "../src/Dimensions.vala"
				_g_free0 (_tmp12_);
#line 456 "../src/Dimensions.vala"
				result = _tmp14_;
#line 456 "../src/Dimensions.vala"
				return result;
#line 2272 "Dimensions.c"
			}
		}
	}
}

gboolean
scaling_equals (Scaling *self,
                Scaling* scaling)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Scaling _tmp2_;
	gboolean result;
#line 460 "../src/Dimensions.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 461 "../src/Dimensions.vala"
	_tmp2_ = *scaling;
#line 461 "../src/Dimensions.vala"
	if ((*self).constraint == _tmp2_.constraint) {
#line 2292 "Dimensions.c"
		Scaling _tmp3_;
#line 461 "../src/Dimensions.vala"
		_tmp3_ = *scaling;
#line 461 "../src/Dimensions.vala"
		_tmp1_ = (*self).scale == _tmp3_.scale;
#line 2298 "Dimensions.c"
	} else {
#line 461 "../src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 2302 "Dimensions.c"
	}
#line 461 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 2306 "Dimensions.c"
		Scaling _tmp4_;
		Dimensions _tmp5_;
#line 462 "../src/Dimensions.vala"
		_tmp4_ = *scaling;
#line 462 "../src/Dimensions.vala"
		_tmp5_ = _tmp4_.viewport;
#line 462 "../src/Dimensions.vala"
		_tmp0_ = dimensions_equals (&(*self).viewport, &_tmp5_);
#line 2315 "Dimensions.c"
	} else {
#line 461 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 2319 "Dimensions.c"
	}
#line 461 "../src/Dimensions.vala"
	result = _tmp0_;
#line 461 "../src/Dimensions.vala"
	return result;
#line 2325 "Dimensions.c"
}

Scaling*
scaling_dup (const Scaling* self)
{
	Scaling* dup;
#line 250 "../src/Dimensions.vala"
	dup = g_new0 (Scaling, 1);
#line 250 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (Scaling));
#line 250 "../src/Dimensions.vala"
	return dup;
#line 2338 "Dimensions.c"
}

void
scaling_free (Scaling* self)
{
#line 250 "../src/Dimensions.vala"
	g_free (self);
#line 2346 "Dimensions.c"
}

static GType
scaling_get_type_once (void)
{
	GType scaling_type_id;
	scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
	return scaling_type_id;
}

GType
scaling_get_type (void)
{
	static volatile gsize scaling_type_id__once = 0;
	if (g_once_init_enter (&scaling_type_id__once)) {
		GType scaling_type_id;
		scaling_type_id = scaling_get_type_once ();
		g_once_init_leave (&scaling_type_id__once, scaling_type_id);
	}
	return scaling_type_id__once;
}

void
zoom_state_init (ZoomState *self,
                 Dimensions* content_dimensions,
                 Dimensions* viewport_dimensions,
                 gdouble slider_val,
                 GdkPoint* viewport_center)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 475 "../src/Dimensions.vala"
	g_return_if_fail (content_dimensions != NULL);
#line 475 "../src/Dimensions.vala"
	g_return_if_fail (viewport_dimensions != NULL);
#line 475 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 477 "../src/Dimensions.vala"
	_tmp0_ = *content_dimensions;
#line 477 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp0_;
#line 478 "../src/Dimensions.vala"
	_tmp1_ = *viewport_dimensions;
#line 478 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp1_;
#line 479 "../src/Dimensions.vala"
	(*self).interpolation_factor = slider_val;
#line 481 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 483 "../src/Dimensions.vala"
	if (viewport_center == NULL) {
#line 483 "../src/Dimensions.vala"
		_tmp3_ = TRUE;
#line 2402 "Dimensions.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 483 "../src/Dimensions.vala"
		if ((*viewport_center).x == 0) {
#line 483 "../src/Dimensions.vala"
			_tmp4_ = (*viewport_center).y == 0;
#line 2409 "Dimensions.c"
		} else {
#line 483 "../src/Dimensions.vala"
			_tmp4_ = FALSE;
#line 2413 "Dimensions.c"
		}
#line 483 "../src/Dimensions.vala"
		_tmp3_ = _tmp4_;
#line 2417 "Dimensions.c"
	}
#line 483 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 483 "../src/Dimensions.vala"
		_tmp2_ = TRUE;
#line 2423 "Dimensions.c"
	} else {
#line 484 "../src/Dimensions.vala"
		_tmp2_ = slider_val == 0.0;
#line 2427 "Dimensions.c"
	}
#line 483 "../src/Dimensions.vala"
	if (_tmp2_) {
#line 485 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2433 "Dimensions.c"
	} else {
#line 487 "../src/Dimensions.vala"
		(*self).viewport_center = *viewport_center;
#line 488 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2439 "Dimensions.c"
	}
}

void
zoom_state_init_rescale (ZoomState *self,
                         ZoomState* existing,
                         gdouble new_slider_val)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
#line 492 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 492 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 493 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 493 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 493 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 494 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 494 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 494 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 495 "../src/Dimensions.vala"
	(*self).interpolation_factor = new_slider_val;
#line 497 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 499 "../src/Dimensions.vala"
	if (new_slider_val == 0.0) {
#line 500 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2476 "Dimensions.c"
	} else {
		ZoomState _tmp4_;
		GdkPoint _tmp5_;
		ZoomState _tmp6_;
		ZoomState _tmp7_;
		GdkPoint _tmp8_;
		ZoomState _tmp9_;
#line 502 "../src/Dimensions.vala"
		_tmp4_ = *existing;
#line 502 "../src/Dimensions.vala"
		_tmp5_ = _tmp4_.viewport_center;
#line 502 "../src/Dimensions.vala"
		_tmp6_ = *existing;
#line 502 "../src/Dimensions.vala"
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * (_tmp5_.x / _tmp6_.zoom_factor));
#line 504 "../src/Dimensions.vala"
		_tmp7_ = *existing;
#line 504 "../src/Dimensions.vala"
		_tmp8_ = _tmp7_.viewport_center;
#line 504 "../src/Dimensions.vala"
		_tmp9_ = *existing;
#line 504 "../src/Dimensions.vala"
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * (_tmp8_.y / _tmp9_.zoom_factor));
#line 506 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2502 "Dimensions.c"
	}
}

void
zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                       ZoomState* existing)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	ZoomState _tmp5_;
	ZoomState _tmp6_;
#line 510 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 510 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 511 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 511 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 511 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 512 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 512 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 512 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 513 "../src/Dimensions.vala"
	_tmp4_ = *existing;
#line 513 "../src/Dimensions.vala"
	_tmp5_ = *existing;
#line 513 "../src/Dimensions.vala"
	_tmp6_ = *existing;
#line 513 "../src/Dimensions.vala"
	(*self).interpolation_factor = log (1.0 / _tmp4_.min_factor) / log (_tmp5_.max_factor / _tmp6_.min_factor);
#line 516 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 518 "../src/Dimensions.vala"
	if ((*self).interpolation_factor == 0.0) {
#line 519 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2547 "Dimensions.c"
	} else {
		ZoomState _tmp7_;
		GdkPoint _tmp8_;
		ZoomState _tmp9_;
		ZoomState _tmp10_;
		GdkPoint _tmp11_;
		ZoomState _tmp12_;
#line 521 "../src/Dimensions.vala"
		_tmp7_ = *existing;
#line 521 "../src/Dimensions.vala"
		_tmp8_ = _tmp7_.viewport_center;
#line 521 "../src/Dimensions.vala"
		_tmp9_ = *existing;
#line 521 "../src/Dimensions.vala"
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * (_tmp8_.x / _tmp9_.zoom_factor));
#line 523 "../src/Dimensions.vala"
		_tmp10_ = *existing;
#line 523 "../src/Dimensions.vala"
		_tmp11_ = _tmp10_.viewport_center;
#line 523 "../src/Dimensions.vala"
		_tmp12_ = *existing;
#line 523 "../src/Dimensions.vala"
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * (_tmp11_.y / _tmp12_.zoom_factor));
#line 525 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2573 "Dimensions.c"
	}
}

void
zoom_state_init_pan (ZoomState *self,
                     ZoomState* existing,
                     GdkPoint* new_viewport_center)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	GdkPoint _tmp5_;
#line 529 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 529 "../src/Dimensions.vala"
	g_return_if_fail (new_viewport_center != NULL);
#line 529 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 530 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 530 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 530 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 531 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 531 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 531 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 532 "../src/Dimensions.vala"
	_tmp4_ = *existing;
#line 532 "../src/Dimensions.vala"
	(*self).interpolation_factor = _tmp4_.interpolation_factor;
#line 534 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 536 "../src/Dimensions.vala"
	_tmp5_ = *new_viewport_center;
#line 536 "../src/Dimensions.vala"
	(*self).viewport_center = _tmp5_;
#line 538 "../src/Dimensions.vala"
	zoom_state_clamp_viewport_center (&(*self));
#line 2618 "Dimensions.c"
}

static void
zoom_state_clamp_viewport_center (ZoomState *self)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkPoint _tmp0_;
	Dimensions _tmp1_;
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp5_;
#line 542 "../src/Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 543 "../src/Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 545 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 545 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport_dimensions;
#line 545 "../src/Dimensions.vala"
	_tmp2_ = (*self).viewport_dimensions;
#line 545 "../src/Dimensions.vala"
	(*self).viewport_center.x = CLAMP (_tmp0_.x, _tmp1_.width / 2, (zoomed_width - (_tmp2_.width / 2)) - 1);
#line 547 "../src/Dimensions.vala"
	_tmp3_ = (*self).viewport_center;
#line 547 "../src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 547 "../src/Dimensions.vala"
	_tmp5_ = (*self).viewport_dimensions;
#line 547 "../src/Dimensions.vala"
	(*self).viewport_center.y = CLAMP (_tmp3_.y, _tmp4_.height / 2, (zoomed_height - (_tmp5_.height / 2)) - 1);
#line 2652 "Dimensions.c"
}

static void
zoom_state_center_viewport (ZoomState *self)
{
#line 552 "../src/Dimensions.vala"
	(*self).viewport_center.x = zoom_state_get_zoomed_width (&(*self)) / 2;
#line 553 "../src/Dimensions.vala"
	(*self).viewport_center.y = zoom_state_get_zoomed_height (&(*self)) / 2;
#line 2662 "Dimensions.c"
}

static void
zoom_state_compute_zoom_factors (ZoomState *self)
{
	gdouble viewport_to_content_x = 0.0;
	gdouble viewport_to_content_y = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 557 "../src/Dimensions.vala"
	(*self).max_factor = 2.0;
#line 561 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 561 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self).content_dimensions, &_tmp0_, &_tmp1_, &_tmp2_);
#line 561 "../src/Dimensions.vala"
	viewport_to_content_x = _tmp1_;
#line 561 "../src/Dimensions.vala"
	viewport_to_content_y = _tmp2_;
#line 563 "../src/Dimensions.vala"
	(*self).min_factor = MIN (viewport_to_content_x, viewport_to_content_y);
#line 564 "../src/Dimensions.vala"
	if ((*self).min_factor > 1.0) {
#line 565 "../src/Dimensions.vala"
		(*self).min_factor = 1.0;
#line 2689 "Dimensions.c"
	}
#line 567 "../src/Dimensions.vala"
	(*self).zoom_factor = (*self).min_factor * pow ((*self).max_factor / (*self).min_factor, (*self).interpolation_factor);
#line 2693 "Dimensions.c"
}

gdouble
zoom_state_get_interpolation_factor (ZoomState *self)
{
	gdouble result;
#line 571 "../src/Dimensions.vala"
	result = (*self).interpolation_factor;
#line 571 "../src/Dimensions.vala"
	return result;
#line 2704 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                              GdkRectangle* result)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkRectangle _result_ = {0};
	Dimensions _tmp0_;
	GdkRectangle _tmp4_;
	Dimensions _tmp5_;
	GdkRectangle _tmp9_;
	gint right = 0;
	GdkRectangle _tmp10_;
	Dimensions _tmp11_;
	GdkRectangle _tmp12_;
	gint bottom = 0;
	GdkRectangle _tmp13_;
	Dimensions _tmp14_;
	GdkRectangle _tmp15_;
	GdkRectangle _tmp16_;
	GdkRectangle _tmp17_;
#line 576 "../src/Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 577 "../src/Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 579 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 581 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 581 "../src/Dimensions.vala"
	if (_tmp0_.width < zoomed_width) {
#line 2738 "Dimensions.c"
		GdkPoint _tmp1_;
		Dimensions _tmp2_;
#line 582 "../src/Dimensions.vala"
		_tmp1_ = (*self).viewport_center;
#line 582 "../src/Dimensions.vala"
		_tmp2_ = (*self).viewport_dimensions;
#line 582 "../src/Dimensions.vala"
		_result_.x = _tmp1_.x - (_tmp2_.width / 2);
#line 2747 "Dimensions.c"
	} else {
		Dimensions _tmp3_;
#line 584 "../src/Dimensions.vala"
		_tmp3_ = (*self).viewport_dimensions;
#line 584 "../src/Dimensions.vala"
		_result_.x = (zoomed_width - _tmp3_.width) / 2;
#line 2754 "Dimensions.c"
	}
#line 586 "../src/Dimensions.vala"
	_tmp4_ = _result_;
#line 586 "../src/Dimensions.vala"
	if (_tmp4_.x < 0) {
#line 587 "../src/Dimensions.vala"
		_result_.x = 0;
#line 2762 "Dimensions.c"
	}
#line 589 "../src/Dimensions.vala"
	_tmp5_ = (*self).viewport_dimensions;
#line 589 "../src/Dimensions.vala"
	if (_tmp5_.height < zoomed_height) {
#line 2768 "Dimensions.c"
		GdkPoint _tmp6_;
		Dimensions _tmp7_;
#line 590 "../src/Dimensions.vala"
		_tmp6_ = (*self).viewport_center;
#line 590 "../src/Dimensions.vala"
		_tmp7_ = (*self).viewport_dimensions;
#line 590 "../src/Dimensions.vala"
		_result_.y = _tmp6_.y - (_tmp7_.height / 2);
#line 2777 "Dimensions.c"
	} else {
		Dimensions _tmp8_;
#line 592 "../src/Dimensions.vala"
		_tmp8_ = (*self).viewport_dimensions;
#line 592 "../src/Dimensions.vala"
		_result_.y = (zoomed_height - _tmp8_.height) / 2;
#line 2784 "Dimensions.c"
	}
#line 594 "../src/Dimensions.vala"
	_tmp9_ = _result_;
#line 594 "../src/Dimensions.vala"
	if (_tmp9_.y < 0) {
#line 595 "../src/Dimensions.vala"
		_result_.y = 0;
#line 2792 "Dimensions.c"
	}
#line 597 "../src/Dimensions.vala"
	_tmp10_ = _result_;
#line 597 "../src/Dimensions.vala"
	_tmp11_ = (*self).viewport_dimensions;
#line 597 "../src/Dimensions.vala"
	right = _tmp10_.x + _tmp11_.width;
#line 598 "../src/Dimensions.vala"
	if (right > zoomed_width) {
#line 599 "../src/Dimensions.vala"
		right = zoomed_width;
#line 2804 "Dimensions.c"
	}
#line 600 "../src/Dimensions.vala"
	_tmp12_ = _result_;
#line 600 "../src/Dimensions.vala"
	_result_.width = right - _tmp12_.x;
#line 602 "../src/Dimensions.vala"
	_tmp13_ = _result_;
#line 602 "../src/Dimensions.vala"
	_tmp14_ = (*self).viewport_dimensions;
#line 602 "../src/Dimensions.vala"
	bottom = _tmp13_.y + _tmp14_.height;
#line 603 "../src/Dimensions.vala"
	if (bottom > zoomed_height) {
#line 604 "../src/Dimensions.vala"
		bottom = zoomed_height;
#line 2820 "Dimensions.c"
	}
#line 605 "../src/Dimensions.vala"
	_tmp15_ = _result_;
#line 605 "../src/Dimensions.vala"
	_result_.height = bottom - _tmp15_.y;
#line 607 "../src/Dimensions.vala"
	_tmp16_ = _result_;
#line 607 "../src/Dimensions.vala"
	_result_.width = CLAMP (_tmp16_.width, 1, G_MAXINT);
#line 608 "../src/Dimensions.vala"
	_tmp17_ = _result_;
#line 608 "../src/Dimensions.vala"
	_result_.height = CLAMP (_tmp17_.height, 1, G_MAXINT);
#line 610 "../src/Dimensions.vala"
	*result = _result_;
#line 610 "../src/Dimensions.vala"
	return;
#line 2838 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                             GdkRectangle* result)
{
	GdkRectangle wrt_content = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _result_ = {0};
	Dimensions _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	Dimensions _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
#line 616 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_);
#line 616 "../src/Dimensions.vala"
	wrt_content = _tmp0_;
#line 618 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 619 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport_dimensions;
#line 619 "../src/Dimensions.vala"
	_tmp2_ = wrt_content;
#line 619 "../src/Dimensions.vala"
	_result_.x = (_tmp1_.width / 2) - (_tmp2_.width / 2);
#line 620 "../src/Dimensions.vala"
	_tmp3_ = _result_;
#line 620 "../src/Dimensions.vala"
	if (_tmp3_.x < 0) {
#line 621 "../src/Dimensions.vala"
		_result_.x = 0;
#line 2874 "Dimensions.c"
	}
#line 622 "../src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 622 "../src/Dimensions.vala"
	_tmp5_ = wrt_content;
#line 622 "../src/Dimensions.vala"
	_result_.y = (_tmp4_.height / 2) - (_tmp5_.height / 2);
#line 623 "../src/Dimensions.vala"
	_tmp6_ = _result_;
#line 623 "../src/Dimensions.vala"
	if (_tmp6_.y < 0) {
#line 624 "../src/Dimensions.vala"
		_result_.y = 0;
#line 2888 "Dimensions.c"
	}
#line 625 "../src/Dimensions.vala"
	_tmp7_ = wrt_content;
#line 625 "../src/Dimensions.vala"
	_result_.width = _tmp7_.width;
#line 626 "../src/Dimensions.vala"
	_tmp8_ = wrt_content;
#line 626 "../src/Dimensions.vala"
	_result_.height = _tmp8_.height;
#line 628 "../src/Dimensions.vala"
	*result = _result_;
#line 628 "../src/Dimensions.vala"
	return;
#line 2902 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                             GdkPixbuf* for_pixbuf,
                                             GdkRectangle* result)
{
	gdouble zoomed_width = 0.0;
	gdouble zoomed_height = 0.0;
	gdouble horiz_scale = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble vert_scale = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble scale = 0.0;
	GdkRectangle viewing_rectangle = {0};
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _result_ = {0};
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint right = 0;
	GdkRectangle _tmp13_;
	GdkRectangle _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint bottom = 0;
	GdkRectangle _tmp17_;
	GdkRectangle _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GdkRectangle _tmp21_;
	GdkRectangle _tmp22_;
#line 632 "../src/Dimensions.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (for_pixbuf, gdk_pixbuf_get_type ()));
#line 633 "../src/Dimensions.vala"
	zoomed_width = (gdouble) zoom_state_get_zoomed_width (&(*self));
#line 634 "../src/Dimensions.vala"
	zoomed_height = (gdouble) zoom_state_get_zoomed_height (&(*self));
#line 636 "../src/Dimensions.vala"
	_tmp0_ = gdk_pixbuf_get_width (for_pixbuf);
#line 636 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_;
#line 636 "../src/Dimensions.vala"
	horiz_scale = _tmp1_ / zoomed_width;
#line 637 "../src/Dimensions.vala"
	_tmp2_ = gdk_pixbuf_get_height (for_pixbuf);
#line 637 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_;
#line 637 "../src/Dimensions.vala"
	vert_scale = _tmp3_ / zoomed_height;
#line 638 "../src/Dimensions.vala"
	scale = (horiz_scale + vert_scale) / 2.0;
#line 640 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp4_);
#line 640 "../src/Dimensions.vala"
	viewing_rectangle = _tmp4_;
#line 642 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 643 "../src/Dimensions.vala"
	_tmp5_ = viewing_rectangle;
#line 643 "../src/Dimensions.vala"
	_result_.x = (gint) (_tmp5_.x * scale);
#line 644 "../src/Dimensions.vala"
	_tmp6_ = _result_;
#line 644 "../src/Dimensions.vala"
	_tmp7_ = gdk_pixbuf_get_width (for_pixbuf);
#line 644 "../src/Dimensions.vala"
	_tmp8_ = _tmp7_;
#line 644 "../src/Dimensions.vala"
	_result_.x = CLAMP (_tmp6_.x, 0, _tmp8_);
#line 645 "../src/Dimensions.vala"
	_tmp9_ = viewing_rectangle;
#line 645 "../src/Dimensions.vala"
	_result_.y = (gint) (_tmp9_.y * scale);
#line 646 "../src/Dimensions.vala"
	_tmp10_ = _result_;
#line 646 "../src/Dimensions.vala"
	_tmp11_ = gdk_pixbuf_get_height (for_pixbuf);
#line 646 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_;
#line 646 "../src/Dimensions.vala"
	_result_.y = CLAMP (_tmp10_.y, 0, _tmp12_);
#line 647 "../src/Dimensions.vala"
	_tmp13_ = viewing_rectangle;
#line 647 "../src/Dimensions.vala"
	_tmp14_ = viewing_rectangle;
#line 647 "../src/Dimensions.vala"
	right = (gint) ((_tmp13_.x + _tmp14_.width) * scale);
#line 648 "../src/Dimensions.vala"
	_tmp15_ = gdk_pixbuf_get_width (for_pixbuf);
#line 648 "../src/Dimensions.vala"
	_tmp16_ = _tmp15_;
#line 648 "../src/Dimensions.vala"
	right = CLAMP (right, 0, _tmp16_);
#line 649 "../src/Dimensions.vala"
	_tmp17_ = viewing_rectangle;
#line 649 "../src/Dimensions.vala"
	_tmp18_ = viewing_rectangle;
#line 649 "../src/Dimensions.vala"
	bottom = (gint) ((_tmp17_.y + _tmp18_.height) * scale);
#line 650 "../src/Dimensions.vala"
	_tmp19_ = gdk_pixbuf_get_height (for_pixbuf);
#line 650 "../src/Dimensions.vala"
	_tmp20_ = _tmp19_;
#line 650 "../src/Dimensions.vala"
	bottom = CLAMP (bottom, 0, _tmp20_);
#line 651 "../src/Dimensions.vala"
	_tmp21_ = _result_;
#line 651 "../src/Dimensions.vala"
	_result_.width = right - _tmp21_.x;
#line 652 "../src/Dimensions.vala"
	_tmp22_ = _result_;
#line 652 "../src/Dimensions.vala"
	_result_.height = bottom - _tmp22_.y;
#line 654 "../src/Dimensions.vala"
	*result = _result_;
#line 654 "../src/Dimensions.vala"
	return;
#line 3028 "Dimensions.c"
}

gdouble
zoom_state_get_zoom_factor (ZoomState *self)
{
	gdouble result;
#line 659 "../src/Dimensions.vala"
	result = (*self).zoom_factor;
#line 659 "../src/Dimensions.vala"
	return result;
#line 3039 "Dimensions.c"
}

gint
zoom_state_get_zoomed_width (ZoomState *self)
{
	Dimensions _tmp0_;
	gint result;
#line 663 "../src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 663 "../src/Dimensions.vala"
	result = (gint) (_tmp0_.width * (*self).zoom_factor);
#line 663 "../src/Dimensions.vala"
	return result;
#line 3053 "Dimensions.c"
}

gint
zoom_state_get_zoomed_height (ZoomState *self)
{
	Dimensions _tmp0_;
	gint result;
#line 667 "../src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 667 "../src/Dimensions.vala"
	result = (gint) (_tmp0_.height * (*self).zoom_factor);
#line 667 "../src/Dimensions.vala"
	return result;
#line 3067 "Dimensions.c"
}

void
zoom_state_get_viewport_center (ZoomState *self,
                                GdkPoint* result)
{
	GdkPoint _tmp0_;
#line 671 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 671 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 671 "../src/Dimensions.vala"
	return;
#line 3081 "Dimensions.c"
}

gchar*
zoom_state_to_string (ZoomState *self)
{
	gchar* named_modes = NULL;
	gchar* _tmp0_;
	const gchar* _tmp17_;
	GdkRectangle viewing_rect = {0};
	GdkRectangle _tmp19_ = {0};
	Dimensions _tmp20_;
	Dimensions _tmp21_;
	Dimensions _tmp22_;
	Dimensions _tmp23_;
	const gchar* _tmp24_;
	GdkRectangle _tmp25_;
	GdkRectangle _tmp26_;
	GdkRectangle _tmp27_;
	GdkRectangle _tmp28_;
	GdkPoint _tmp29_;
	GdkPoint _tmp30_;
	gchar* _tmp31_;
	gchar* result;
#line 675 "../src/Dimensions.vala"
	_tmp0_ = g_strdup ("");
#line 675 "../src/Dimensions.vala"
	named_modes = _tmp0_;
#line 676 "../src/Dimensions.vala"
	if (zoom_state_is_min (&(*self))) {
#line 3111 "Dimensions.c"
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 677 "../src/Dimensions.vala"
		_tmp2_ = named_modes;
#line 677 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp2_, "") == 0) {
#line 677 "../src/Dimensions.vala"
			_tmp1_ = "MIN";
#line 3122 "Dimensions.c"
		} else {
#line 677 "../src/Dimensions.vala"
			_tmp1_ = ", MIN";
#line 3126 "Dimensions.c"
		}
#line 677 "../src/Dimensions.vala"
		_tmp3_ = named_modes;
#line 677 "../src/Dimensions.vala"
		_tmp4_ = g_strconcat (_tmp3_, _tmp1_, NULL);
#line 677 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 677 "../src/Dimensions.vala"
		named_modes = _tmp4_;
#line 3136 "Dimensions.c"
	}
#line 678 "../src/Dimensions.vala"
	if (zoom_state_is_default (&(*self))) {
#line 3140 "Dimensions.c"
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 679 "../src/Dimensions.vala"
		_tmp6_ = named_modes;
#line 679 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp6_, "") == 0) {
#line 679 "../src/Dimensions.vala"
			_tmp5_ = "DEFAULT";
#line 3151 "Dimensions.c"
		} else {
#line 679 "../src/Dimensions.vala"
			_tmp5_ = ", DEFAULT";
#line 3155 "Dimensions.c"
		}
#line 679 "../src/Dimensions.vala"
		_tmp7_ = named_modes;
#line 679 "../src/Dimensions.vala"
		_tmp8_ = g_strconcat (_tmp7_, _tmp5_, NULL);
#line 679 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 679 "../src/Dimensions.vala"
		named_modes = _tmp8_;
#line 3165 "Dimensions.c"
	}
#line 680 "../src/Dimensions.vala"
	if (zoom_state_is_isomorphic (&(*self))) {
#line 3169 "Dimensions.c"
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 681 "../src/Dimensions.vala"
		_tmp10_ = named_modes;
#line 681 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp10_, "") == 0) {
#line 681 "../src/Dimensions.vala"
			_tmp9_ = "ISOMORPHIC";
#line 3180 "Dimensions.c"
		} else {
#line 681 "../src/Dimensions.vala"
			_tmp9_ = ", ISOMORPHIC";
#line 3184 "Dimensions.c"
		}
#line 681 "../src/Dimensions.vala"
		_tmp11_ = named_modes;
#line 681 "../src/Dimensions.vala"
		_tmp12_ = g_strconcat (_tmp11_, _tmp9_, NULL);
#line 681 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 681 "../src/Dimensions.vala"
		named_modes = _tmp12_;
#line 3194 "Dimensions.c"
	}
#line 682 "../src/Dimensions.vala"
	if (zoom_state_is_max (&(*self))) {
#line 3198 "Dimensions.c"
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 683 "../src/Dimensions.vala"
		_tmp14_ = named_modes;
#line 683 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp14_, "") == 0) {
#line 683 "../src/Dimensions.vala"
			_tmp13_ = "MAX";
#line 3209 "Dimensions.c"
		} else {
#line 683 "../src/Dimensions.vala"
			_tmp13_ = ", MAX";
#line 3213 "Dimensions.c"
		}
#line 683 "../src/Dimensions.vala"
		_tmp15_ = named_modes;
#line 683 "../src/Dimensions.vala"
		_tmp16_ = g_strconcat (_tmp15_, _tmp13_, NULL);
#line 683 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 683 "../src/Dimensions.vala"
		named_modes = _tmp16_;
#line 3223 "Dimensions.c"
	}
#line 684 "../src/Dimensions.vala"
	_tmp17_ = named_modes;
#line 684 "../src/Dimensions.vala"
	if (g_strcmp0 (_tmp17_, "") == 0) {
#line 3229 "Dimensions.c"
		gchar* _tmp18_;
#line 685 "../src/Dimensions.vala"
		_tmp18_ = g_strdup ("(none)");
#line 685 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 685 "../src/Dimensions.vala"
		named_modes = _tmp18_;
#line 3237 "Dimensions.c"
	}
#line 687 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp19_);
#line 687 "../src/Dimensions.vala"
	viewing_rect = _tmp19_;
#line 689 "../src/Dimensions.vala"
	_tmp20_ = (*self).content_dimensions;
#line 689 "../src/Dimensions.vala"
	_tmp21_ = (*self).content_dimensions;
#line 689 "../src/Dimensions.vala"
	_tmp22_ = (*self).viewport_dimensions;
#line 689 "../src/Dimensions.vala"
	_tmp23_ = (*self).viewport_dimensions;
#line 689 "../src/Dimensions.vala"
	_tmp24_ = named_modes;
#line 689 "../src/Dimensions.vala"
	_tmp25_ = viewing_rect;
#line 689 "../src/Dimensions.vala"
	_tmp26_ = viewing_rect;
#line 689 "../src/Dimensions.vala"
	_tmp27_ = viewing_rect;
#line 689 "../src/Dimensions.vala"
	_tmp28_ = viewing_rect;
#line 689 "../src/Dimensions.vala"
	_tmp29_ = (*self).viewport_center;
#line 689 "../src/Dimensions.vala"
	_tmp30_ = (*self).viewport_center;
#line 689 "../src/Dimensions.vala"
	_tmp31_ = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", _tmp20_.width, _tmp21_.height, _tmp22_.width, _tmp23_.height, (*self).min_factor, (*self).max_factor, (*self).zoom_factor, zoom_state_get_zoomed_width (&(*self)), zoom_state_get_zoomed_height (&(*self)), _tmp24_, _tmp25_.x, _tmp26_.y, _tmp27_.width, _tmp28_.height, _tmp29_.x, _tmp30_.y);
#line 689 "../src/Dimensions.vala"
	result = _tmp31_;
#line 689 "../src/Dimensions.vala"
	_g_free0 (named_modes);
#line 689 "../src/Dimensions.vala"
	return result;
#line 3273 "Dimensions.c"
}

gboolean
zoom_state_is_min (ZoomState *self)
{
	gboolean result;
#line 701 "../src/Dimensions.vala"
	result = (*self).zoom_factor == (*self).min_factor;
#line 701 "../src/Dimensions.vala"
	return result;
#line 3284 "Dimensions.c"
}

gboolean
zoom_state_is_default (ZoomState *self)
{
	gboolean result;
#line 705 "../src/Dimensions.vala"
	result = zoom_state_is_min (&(*self));
#line 705 "../src/Dimensions.vala"
	return result;
#line 3295 "Dimensions.c"
}

gboolean
zoom_state_is_max (ZoomState *self)
{
	gboolean result;
#line 709 "../src/Dimensions.vala"
	result = (*self).zoom_factor == (*self).max_factor;
#line 709 "../src/Dimensions.vala"
	return result;
#line 3306 "Dimensions.c"
}

gboolean
zoom_state_is_isomorphic (ZoomState *self)
{
	gboolean result;
#line 713 "../src/Dimensions.vala"
	result = (*self).zoom_factor == 1.0;
#line 713 "../src/Dimensions.vala"
	return result;
#line 3317 "Dimensions.c"
}

gboolean
zoom_state_equals (ZoomState *self,
                   ZoomState* other)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	ZoomState _tmp5_;
	ZoomState _tmp6_;
	GdkPoint _tmp7_;
	ZoomState _tmp8_;
	GdkPoint _tmp9_;
	GdkPoint _tmp10_;
	ZoomState _tmp11_;
	GdkPoint _tmp12_;
	gboolean result;
#line 716 "../src/Dimensions.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 717 "../src/Dimensions.vala"
	_tmp0_ = *other;
#line 717 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 717 "../src/Dimensions.vala"
	if (!dimensions_equals (&(*self).content_dimensions, &_tmp1_)) {
#line 718 "../src/Dimensions.vala"
		result = FALSE;
#line 718 "../src/Dimensions.vala"
		return result;
#line 3350 "Dimensions.c"
	}
#line 719 "../src/Dimensions.vala"
	_tmp2_ = *other;
#line 719 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 719 "../src/Dimensions.vala"
	if (!dimensions_equals (&(*self).viewport_dimensions, &_tmp3_)) {
#line 720 "../src/Dimensions.vala"
		result = FALSE;
#line 720 "../src/Dimensions.vala"
		return result;
#line 3362 "Dimensions.c"
	}
#line 721 "../src/Dimensions.vala"
	_tmp4_ = *other;
#line 721 "../src/Dimensions.vala"
	if ((*self).zoom_factor != _tmp4_.zoom_factor) {
#line 722 "../src/Dimensions.vala"
		result = FALSE;
#line 722 "../src/Dimensions.vala"
		return result;
#line 3372 "Dimensions.c"
	}
#line 723 "../src/Dimensions.vala"
	_tmp5_ = *other;
#line 723 "../src/Dimensions.vala"
	if ((*self).min_factor != _tmp5_.min_factor) {
#line 724 "../src/Dimensions.vala"
		result = FALSE;
#line 724 "../src/Dimensions.vala"
		return result;
#line 3382 "Dimensions.c"
	}
#line 725 "../src/Dimensions.vala"
	_tmp6_ = *other;
#line 725 "../src/Dimensions.vala"
	if ((*self).max_factor != _tmp6_.max_factor) {
#line 726 "../src/Dimensions.vala"
		result = FALSE;
#line 726 "../src/Dimensions.vala"
		return result;
#line 3392 "Dimensions.c"
	}
#line 727 "../src/Dimensions.vala"
	_tmp7_ = (*self).viewport_center;
#line 727 "../src/Dimensions.vala"
	_tmp8_ = *other;
#line 727 "../src/Dimensions.vala"
	_tmp9_ = _tmp8_.viewport_center;
#line 727 "../src/Dimensions.vala"
	if (_tmp7_.x != _tmp9_.x) {
#line 728 "../src/Dimensions.vala"
		result = FALSE;
#line 728 "../src/Dimensions.vala"
		return result;
#line 3406 "Dimensions.c"
	}
#line 729 "../src/Dimensions.vala"
	_tmp10_ = (*self).viewport_center;
#line 729 "../src/Dimensions.vala"
	_tmp11_ = *other;
#line 729 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_.viewport_center;
#line 729 "../src/Dimensions.vala"
	if (_tmp10_.y != _tmp12_.y) {
#line 730 "../src/Dimensions.vala"
		result = FALSE;
#line 730 "../src/Dimensions.vala"
		return result;
#line 3420 "Dimensions.c"
	}
#line 732 "../src/Dimensions.vala"
	result = TRUE;
#line 732 "../src/Dimensions.vala"
	return result;
#line 3426 "Dimensions.c"
}

ZoomState*
zoom_state_dup (const ZoomState* self)
{
	ZoomState* dup;
#line 466 "../src/Dimensions.vala"
	dup = g_new0 (ZoomState, 1);
#line 466 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (ZoomState));
#line 466 "../src/Dimensions.vala"
	return dup;
#line 3439 "Dimensions.c"
}

void
zoom_state_free (ZoomState* self)
{
#line 466 "../src/Dimensions.vala"
	g_free (self);
#line 3447 "Dimensions.c"
}

static GType
zoom_state_get_type_once (void)
{
	GType zoom_state_type_id;
	zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
	return zoom_state_type_id;
}

GType
zoom_state_get_type (void)
{
	static volatile gsize zoom_state_type_id__once = 0;
	if (g_once_init_enter (&zoom_state_type_id__once)) {
		GType zoom_state_type_id;
		zoom_state_type_id = zoom_state_get_type_once ();
		g_once_init_leave (&zoom_state_type_id__once, zoom_state_type_id);
	}
	return zoom_state_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

