/* Db.c generated by valac 0.56.13, the Vala compiler
 * generated from Db.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <config.h>

#define DB_IN_MEMORY_NAME ":memory:"
#define DATABASE_TABLE_SCHEMA_VERSION 24
#define RESOURCES_APP_VERSION _VERSION
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	DB_VERIFY_RESULT_OK,
	DB_VERIFY_RESULT_FUTURE_VERSION,
	DB_VERIFY_RESULT_UPGRADE_ERROR,
	DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE
} DbVerifyResult;

#define DB_TYPE_VERIFY_RESULT (db_verify_result_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))

#define TYPE_FACE_TABLE (face_table_get_type ())
#define FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_TABLE, FaceTable))
#define FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_TABLE, FaceTableClass))
#define IS_FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_TABLE))
#define IS_FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_TABLE))
#define FACE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_TABLE, FaceTableClass))

typedef struct _FaceTable FaceTable;
typedef struct _FaceTableClass FaceTableClass;

#define TYPE_FACE_LOCATION_TABLE (face_location_table_get_type ())
#define FACE_LOCATION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_LOCATION_TABLE, FaceLocationTable))
#define FACE_LOCATION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_LOCATION_TABLE, FaceLocationTableClass))
#define IS_FACE_LOCATION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_LOCATION_TABLE))
#define IS_FACE_LOCATION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_LOCATION_TABLE))
#define FACE_LOCATION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_LOCATION_TABLE, FaceLocationTableClass))

typedef struct _FaceLocationTable FaceLocationTable;
typedef struct _FaceLocationTableClass FaceLocationTableClass;

#define TYPE_DATABASE_ERROR (database_error_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

VALA_EXTERN gchar* db_filename;
gchar* db_filename = NULL;

VALA_EXTERN void db_preconfigure (GFile* db_file);
VALA_EXTERN void db_init (GError** error);
VALA_EXTERN void database_table_init (const gchar* filename);
VALA_EXTERN void db_terminate (void);
VALA_EXTERN void database_table_terminate (void);
VALA_EXTERN GType db_verify_result_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DbVerifyResult db_verify_database (gchar** app_version,
                                   gint* schema_version);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType version_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VersionTable, database_table_unref)
VALA_EXTERN VersionTable* version_table_get_instance (void);
VALA_EXTERN gint version_table_get_version (VersionTable* self,
                                gchar** app_version);
VALA_EXTERN void version_table_set_version (VersionTable* self,
                                gint version,
                                const gchar* app_version,
                                const gchar* user_data);
VALA_EXTERN DbVerifyResult db_upgrade_database (gint input_version);
VALA_EXTERN gboolean database_table_has_column (const gchar* table_name,
                                    const gchar* column_name);
VALA_EXTERN gboolean database_table_add_column (const gchar* table_name,
                                    const gchar* column_name,
                                    const gchar* column_constraints);
VALA_EXTERN gboolean database_table_has_table (const gchar* table_name);
VALA_EXTERN gboolean database_table_ensure_column (const gchar* table_name,
                                       const gchar* column_name,
                                       const gchar* column_constraints,
                                       const gchar* upgrade_msg);
VALA_EXTERN void tag_table_upgrade_for_htags (void);
VALA_EXTERN void gsettings_configuration_engine_run_gsettings_migrator (void);
VALA_EXTERN gpointer application_ref (gpointer instance);
VALA_EXTERN void application_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_application (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_application (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_application (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_application (const GValue* value);
VALA_EXTERN GType application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Application, application_unref)
VALA_EXTERN Application* application_get_instance (void);
VALA_EXTERN void application_set_raw_thumbs_fix_required (Application* self,
                                              gboolean should_fixup);
VALA_EXTERN GType face_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceTable, database_table_unref)
VALA_EXTERN FaceTable* face_table_get_instance (void);
VALA_EXTERN GType face_location_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceLocationTable, database_table_unref)
VALA_EXTERN FaceLocationTable* face_location_table_get_instance (void);
VALA_EXTERN void gsettings_configuration_engine_run_gsettings_migrator_v2 (void);
VALA_EXTERN GQuark database_error_quark (void);
VALA_EXTERN GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_table_upgrade_for_unset_timestamp (GError** error);
VALA_EXTERN void video_table_upgrade_for_unset_timestamp (GError** error);
VALA_EXTERN void version_table_update_version (VersionTable* self,
                                   gint version,
                                   const gchar* app_version);

void
db_preconfigure (GFile* db_file)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_;
#line 14 "../src/db/Db.vala"
	g_return_if_fail ((db_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (db_file, g_file_get_type ()));
#line 15 "../src/db/Db.vala"
	if (db_file != NULL) {
#line 198 "Db.c"
		gchar* _tmp1_;
#line 15 "../src/db/Db.vala"
		_tmp1_ = g_file_get_path (db_file);
#line 15 "../src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "../src/db/Db.vala"
		_tmp0_ = _tmp1_;
#line 206 "Db.c"
	} else {
		gchar* _tmp2_;
#line 15 "../src/db/Db.vala"
		_tmp2_ = g_strdup (DB_IN_MEMORY_NAME);
#line 15 "../src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "../src/db/Db.vala"
		_tmp0_ = _tmp2_;
#line 215 "Db.c"
	}
#line 15 "../src/db/Db.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 15 "../src/db/Db.vala"
	_g_free0 (db_filename);
#line 15 "../src/db/Db.vala"
	db_filename = _tmp3_;
#line 14 "../src/db/Db.vala"
	_g_free0 (_tmp0_);
#line 225 "Db.c"
}

void
db_init (GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 19 "../src/db/Db.vala"
	_tmp0_ = db_filename;
#line 19 "../src/db/Db.vala"
	_vala_assert (_tmp0_ != NULL, "filename != null");
#line 21 "../src/db/Db.vala"
	_tmp1_ = db_filename;
#line 21 "../src/db/Db.vala"
	database_table_init (_tmp1_);
#line 241 "Db.c"
}

void
db_terminate (void)
{
#line 25 "../src/db/Db.vala"
	database_table_terminate ();
#line 249 "Db.c"
}

static GType
db_verify_result_get_type_once (void)
{
	static const GEnumValue values[] = {{DB_VERIFY_RESULT_OK, "DB_VERIFY_RESULT_OK", "ok"}, {DB_VERIFY_RESULT_FUTURE_VERSION, "DB_VERIFY_RESULT_FUTURE_VERSION", "future-version"}, {DB_VERIFY_RESULT_UPGRADE_ERROR, "DB_VERIFY_RESULT_UPGRADE_ERROR", "upgrade-error"}, {DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE, "DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE", "no-upgrade-available"}, {0, NULL, NULL}};
	GType db_verify_result_type_id;
	db_verify_result_type_id = g_enum_register_static ("DbVerifyResult", values);
	return db_verify_result_type_id;
}

GType
db_verify_result_get_type (void)
{
	static volatile gsize db_verify_result_type_id__once = 0;
	if (g_once_init_enter (&db_verify_result_type_id__once)) {
		GType db_verify_result_type_id;
		db_verify_result_type_id = db_verify_result_get_type_once ();
		g_once_init_leave (&db_verify_result_type_id__once, db_verify_result_type_id);
	}
	return db_verify_result_type_id__once;
}

DbVerifyResult
db_verify_database (gchar** app_version,
                    gint* schema_version)
{
	gchar* _vala_app_version = NULL;
	gint _vala_schema_version = 0;
	VersionTable* version_table = NULL;
	VersionTable* _tmp0_;
	VersionTable* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint _tmp3_;
	DbVerifyResult result;
#line 36 "../src/db/Db.vala"
	_tmp0_ = version_table_get_instance ();
#line 36 "../src/db/Db.vala"
	version_table = _tmp0_;
#line 37 "../src/db/Db.vala"
	_tmp1_ = version_table;
#line 37 "../src/db/Db.vala"
	_tmp3_ = version_table_get_version (_tmp1_, &_tmp2_);
#line 37 "../src/db/Db.vala"
	_g_free0 (_vala_app_version);
#line 37 "../src/db/Db.vala"
	_vala_app_version = _tmp2_;
#line 37 "../src/db/Db.vala"
	_vala_schema_version = _tmp3_;
#line 39 "../src/db/Db.vala"
	if (_vala_schema_version >= 0) {
#line 301 "Db.c"
		const gchar* _tmp4_;
#line 40 "../src/db/Db.vala"
		_tmp4_ = _vala_app_version;
#line 40 "../src/db/Db.vala"
		g_debug ("Db.vala:40: Database schema version %d created by app version %s", _vala_schema_version, _tmp4_);
#line 307 "Db.c"
	}
#line 42 "../src/db/Db.vala"
	if (_vala_schema_version == -1) {
#line 311 "Db.c"
		VersionTable* _tmp5_;
		gchar* _tmp6_;
#line 44 "../src/db/Db.vala"
		g_debug ("Db.vala:44: Creating database schema version %d for app version %s", DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION);
#line 46 "../src/db/Db.vala"
		_tmp5_ = version_table;
#line 46 "../src/db/Db.vala"
		version_table_set_version (_tmp5_, DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION, NULL);
#line 47 "../src/db/Db.vala"
		_tmp6_ = g_strdup (RESOURCES_APP_VERSION);
#line 47 "../src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 47 "../src/db/Db.vala"
		_vala_app_version = _tmp6_;
#line 48 "../src/db/Db.vala"
		_vala_schema_version = DATABASE_TABLE_SCHEMA_VERSION;
#line 328 "Db.c"
	} else {
#line 49 "../src/db/Db.vala"
		if (_vala_schema_version > DATABASE_TABLE_SCHEMA_VERSION) {
#line 51 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_FUTURE_VERSION;
#line 51 "../src/db/Db.vala"
			_database_table_unref0 (version_table);
#line 51 "../src/db/Db.vala"
			if (app_version) {
#line 51 "../src/db/Db.vala"
				*app_version = _vala_app_version;
#line 340 "Db.c"
			} else {
#line 51 "../src/db/Db.vala"
				_g_free0 (_vala_app_version);
#line 344 "Db.c"
			}
#line 51 "../src/db/Db.vala"
			if (schema_version) {
#line 51 "../src/db/Db.vala"
				*schema_version = _vala_schema_version;
#line 350 "Db.c"
			}
#line 51 "../src/db/Db.vala"
			return result;
#line 354 "Db.c"
		} else {
#line 52 "../src/db/Db.vala"
			if (_vala_schema_version < DATABASE_TABLE_SCHEMA_VERSION) {
#line 358 "Db.c"
				DbVerifyResult _result_ = 0;
#line 54 "../src/db/Db.vala"
				_result_ = db_upgrade_database (_vala_schema_version);
#line 55 "../src/db/Db.vala"
				if (_result_ != DB_VERIFY_RESULT_OK) {
#line 56 "../src/db/Db.vala"
					result = _result_;
#line 56 "../src/db/Db.vala"
					_database_table_unref0 (version_table);
#line 56 "../src/db/Db.vala"
					if (app_version) {
#line 56 "../src/db/Db.vala"
						*app_version = _vala_app_version;
#line 372 "Db.c"
					} else {
#line 56 "../src/db/Db.vala"
						_g_free0 (_vala_app_version);
#line 376 "Db.c"
					}
#line 56 "../src/db/Db.vala"
					if (schema_version) {
#line 56 "../src/db/Db.vala"
						*schema_version = _vala_schema_version;
#line 382 "Db.c"
					}
#line 56 "../src/db/Db.vala"
					return result;
#line 386 "Db.c"
				}
			}
		}
	}
#line 59 "../src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 59 "../src/db/Db.vala"
	_database_table_unref0 (version_table);
#line 59 "../src/db/Db.vala"
	if (app_version) {
#line 59 "../src/db/Db.vala"
		*app_version = _vala_app_version;
#line 399 "Db.c"
	} else {
#line 59 "../src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 403 "Db.c"
	}
#line 59 "../src/db/Db.vala"
	if (schema_version) {
#line 59 "../src/db/Db.vala"
		*schema_version = _vala_schema_version;
#line 409 "Db.c"
	}
#line 59 "../src/db/Db.vala"
	return result;
#line 413 "Db.c"
}

DbVerifyResult
db_upgrade_database (gint input_version)
{
	gint version = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	FaceTable* _tmp5_;
	FaceTable* _tmp6_;
	FaceLocationTable* _tmp7_;
	FaceLocationTable* _tmp8_;
	VersionTable* _tmp11_;
	VersionTable* _tmp12_;
	GError* _inner_error0_ = NULL;
	DbVerifyResult result;
#line 63 "../src/db/Db.vala"
	_vala_assert (input_version < DATABASE_TABLE_SCHEMA_VERSION, "input_version < DatabaseTable.SCHEMA_VERSION");
#line 65 "../src/db/Db.vala"
	version = input_version;
#line 68 "../src/db/Db.vala"
	if (version == 1) {
#line 69 "../src/db/Db.vala"
		result = DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE;
#line 69 "../src/db/Db.vala"
		return result;
#line 441 "Db.c"
	}
#line 71 "../src/db/Db.vala"
	g_message ("Db.vala:71: Upgrading database from schema version %d to %d", version, DATABASE_TABLE_SCHEMA_VERSION);
#line 83 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "flags")) {
#line 84 "../src/db/Db.vala"
		g_message ("Db.vala:84: upgrade_database: adding flags column to PhotoTable");
#line 85 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "flags", "INTEGER DEFAULT 0")) {
#line 86 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 86 "../src/db/Db.vala"
			return result;
#line 455 "Db.c"
		}
	}
#line 89 "../src/db/Db.vala"
	version = 3;
#line 100 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "file_format")) {
#line 101 "../src/db/Db.vala"
		g_message ("Db.vala:101: upgrade_database: adding file_format column to PhotoTable");
#line 102 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "file_format", "INTEGER DEFAULT 0")) {
#line 103 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 103 "../src/db/Db.vala"
			return result;
#line 470 "Db.c"
		}
	}
#line 106 "../src/db/Db.vala"
	version = 4;
#line 113 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "title")) {
#line 114 "../src/db/Db.vala"
		g_message ("Db.vala:114: upgrade_database: adding title column to PhotoTable");
#line 115 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "title", "TEXT")) {
#line 116 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 116 "../src/db/Db.vala"
			return result;
#line 485 "Db.c"
		}
	}
#line 119 "../src/db/Db.vala"
	version = 5;
#line 126 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "backlinks")) {
#line 127 "../src/db/Db.vala"
		g_message ("Db.vala:127: upgrade_database: adding backlinks column to PhotoTable");
#line 128 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "backlinks", "TEXT")) {
#line 129 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 129 "../src/db/Db.vala"
			return result;
#line 500 "Db.c"
		}
	}
#line 132 "../src/db/Db.vala"
	version = 6;
#line 146 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "time_reimported")) {
#line 147 "../src/db/Db.vala"
		g_message ("Db.vala:147: upgrade_database: adding time_reimported column to PhotoT" \
"able");
#line 148 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "time_reimported", "INTEGER")) {
#line 149 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 149 "../src/db/Db.vala"
			return result;
#line 515 "Db.c"
		}
	}
#line 152 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "editable_id")) {
#line 153 "../src/db/Db.vala"
		g_message ("Db.vala:153: upgrade_database: adding editable_id column to PhotoTable");
#line 154 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "editable_id", "INTEGER DEFAULT -1")) {
#line 155 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 155 "../src/db/Db.vala"
			return result;
#line 528 "Db.c"
		}
	}
#line 158 "../src/db/Db.vala"
	version = 7;
#line 170 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "rating")) {
#line 171 "../src/db/Db.vala"
		g_message ("Db.vala:171: upgrade_database: adding rating column to PhotoTable");
#line 172 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "rating", "INTEGER DEFAULT 0")) {
#line 173 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 173 "../src/db/Db.vala"
			return result;
#line 543 "Db.c"
		}
	}
#line 182 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "metadata_dirty")) {
#line 183 "../src/db/Db.vala"
		g_message ("Db.vala:183: upgrade_database: adding metadata_dirty column to PhotoTa" \
"ble");
#line 184 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "metadata_dirty", "INTEGER DEFAULT 1")) {
#line 185 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 185 "../src/db/Db.vala"
			return result;
#line 556 "Db.c"
		}
	}
#line 188 "../src/db/Db.vala"
	version = 9;
#line 195 "../src/db/Db.vala"
	if (database_table_has_table ("VideoTable")) {
#line 195 "../src/db/Db.vala"
		_tmp0_ = !database_table_has_column ("VideoTable", "flags");
#line 565 "Db.c"
	} else {
#line 195 "../src/db/Db.vala"
		_tmp0_ = FALSE;
#line 569 "Db.c"
	}
#line 195 "../src/db/Db.vala"
	if (_tmp0_) {
#line 196 "../src/db/Db.vala"
		g_message ("Db.vala:196: upgrade_database: adding flags column to VideoTable");
#line 197 "../src/db/Db.vala"
		if (!database_table_add_column ("VideoTable", "flags", "INTEGER DEFAULT 0")) {
#line 198 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 198 "../src/db/Db.vala"
			return result;
#line 581 "Db.c"
		}
	}
#line 201 "../src/db/Db.vala"
	version = 10;
#line 208 "../src/db/Db.vala"
	if (!database_table_has_column ("EventTable", "primary_source_id")) {
#line 209 "../src/db/Db.vala"
		g_message ("Db.vala:209: upgrade_database: adding primary_source_id column to Even" \
"tTable");
#line 210 "../src/db/Db.vala"
		if (!database_table_add_column ("EventTable", "primary_source_id", "TEXT")) {
#line 211 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 211 "../src/db/Db.vala"
			return result;
#line 596 "Db.c"
		}
	}
#line 214 "../src/db/Db.vala"
	version = 11;
#line 221 "../src/db/Db.vala"
	if (!database_table_ensure_column ("TombstoneTable", "reason", "INTEGER DEFAULT 0", "upgrade_database: adding reason column to TombstoneTable")) {
#line 223 "../src/db/Db.vala"
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 223 "../src/db/Db.vala"
		return result;
#line 607 "Db.c"
	}
#line 226 "../src/db/Db.vala"
	version = 12;
#line 233 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "developer")) {
#line 234 "../src/db/Db.vala"
		g_message ("Db.vala:234: upgrade_database: adding developer column to PhotoTable");
#line 235 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "developer", "TEXT")) {
#line 236 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 236 "../src/db/Db.vala"
			return result;
#line 621 "Db.c"
		}
	}
#line 239 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_shotwell_id")) {
#line 240 "../src/db/Db.vala"
		g_message ("Db.vala:240: upgrade_database: adding develop_shotwell_id column to Ph" \
"otoTable");
#line 241 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_shotwell_id", "INTEGER DEFAULT -1")) {
#line 242 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 242 "../src/db/Db.vala"
			return result;
#line 634 "Db.c"
		}
	}
#line 245 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_camera_id")) {
#line 246 "../src/db/Db.vala"
		g_message ("Db.vala:246: upgrade_database: adding develop_camera_id column to Phot" \
"oTable");
#line 247 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_camera_id", "INTEGER DEFAULT -1")) {
#line 248 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 248 "../src/db/Db.vala"
			return result;
#line 647 "Db.c"
		}
	}
#line 251 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_embedded_id")) {
#line 252 "../src/db/Db.vala"
		g_message ("Db.vala:252: upgrade_database: adding develop_embedded_id column to Ph" \
"otoTable");
#line 253 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_embedded_id", "INTEGER DEFAULT -1")) {
#line 254 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 254 "../src/db/Db.vala"
			return result;
#line 660 "Db.c"
		}
	}
#line 257 "../src/db/Db.vala"
	version = 13;
#line 264 "../src/db/Db.vala"
	if (input_version < 14) {
#line 265 "../src/db/Db.vala"
		tag_table_upgrade_for_htags ();
#line 669 "Db.c"
	}
#line 267 "../src/db/Db.vala"
	version = 14;
#line 279 "../src/db/Db.vala"
	version = 15;
#line 289 "../src/db/Db.vala"
	if (input_version < 16) {
#line 292 "../src/db/Db.vala"
		gsettings_configuration_engine_run_gsettings_migrator ();
#line 679 "Db.c"
	}
#line 295 "../src/db/Db.vala"
	version = 16;
#line 302 "../src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "comment")) {
#line 303 "../src/db/Db.vala"
		g_message ("Db.vala:303: upgrade_database: adding comment column to PhotoTable");
#line 304 "../src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "comment", "TEXT")) {
#line 305 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 305 "../src/db/Db.vala"
			return result;
#line 693 "Db.c"
		}
	}
#line 307 "../src/db/Db.vala"
	if (database_table_has_table ("VideoTable") & (!database_table_has_column ("VideoTable", "comment"))) {
#line 308 "../src/db/Db.vala"
		g_message ("Db.vala:308: upgrade_database: adding comment column to VideoTable");
#line 309 "../src/db/Db.vala"
		if (!database_table_add_column ("VideoTable", "comment", "TEXT")) {
#line 310 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 310 "../src/db/Db.vala"
			return result;
#line 706 "Db.c"
		}
	}
#line 313 "../src/db/Db.vala"
	version = 17;
#line 320 "../src/db/Db.vala"
	if (!database_table_has_column ("EventTable", "comment")) {
#line 321 "../src/db/Db.vala"
		g_message ("Db.vala:321: upgrade_database: adding comment column to EventTable");
#line 322 "../src/db/Db.vala"
		if (!database_table_add_column ("EventTable", "comment", "TEXT")) {
#line 323 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 323 "../src/db/Db.vala"
			return result;
#line 721 "Db.c"
		}
	}
#line 326 "../src/db/Db.vala"
	version = 18;
#line 337 "../src/db/Db.vala"
	if (input_version < 19) {
#line 728 "Db.c"
		Application* _tmp1_;
		Application* _tmp2_;
#line 338 "../src/db/Db.vala"
		_tmp1_ = application_get_instance ();
#line 338 "../src/db/Db.vala"
		_tmp2_ = _tmp1_;
#line 338 "../src/db/Db.vala"
		application_set_raw_thumbs_fix_required (_tmp2_, TRUE);
#line 338 "../src/db/Db.vala"
		_application_unref0 (_tmp2_);
#line 739 "Db.c"
	}
#line 341 "../src/db/Db.vala"
	version = 19;
#line 351 "../src/db/Db.vala"
	version = 20;
#line 358 "../src/db/Db.vala"
	if (!database_table_ensure_column ("PhotoTable", "has_gps", "INTEGER DEFAULT -1", "upgrade_database: adding gps_lat column to PhotoTable")) {
#line 358 "../src/db/Db.vala"
		_tmp4_ = TRUE;
#line 749 "Db.c"
	} else {
#line 360 "../src/db/Db.vala"
		_tmp4_ = !database_table_ensure_column ("PhotoTable", "gps_lat", "REAL", "upgrade_database: adding gps_lat column to PhotoTable");
#line 753 "Db.c"
	}
#line 358 "../src/db/Db.vala"
	if (_tmp4_) {
#line 358 "../src/db/Db.vala"
		_tmp3_ = TRUE;
#line 759 "Db.c"
	} else {
#line 362 "../src/db/Db.vala"
		_tmp3_ = !database_table_ensure_column ("PhotoTable", "gps_lon", "REAL", "upgrade_database: adding gps_lon column to PhotoTable");
#line 763 "Db.c"
	}
#line 358 "../src/db/Db.vala"
	if (_tmp3_) {
#line 364 "../src/db/Db.vala"
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 364 "../src/db/Db.vala"
		return result;
#line 771 "Db.c"
	}
#line 367 "../src/db/Db.vala"
	version = 21;
#line 375 "../src/db/Db.vala"
	_tmp5_ = face_table_get_instance ();
#line 375 "../src/db/Db.vala"
	_tmp6_ = _tmp5_;
#line 375 "../src/db/Db.vala"
	_database_table_unref0 (_tmp6_);
#line 376 "../src/db/Db.vala"
	_tmp7_ = face_location_table_get_instance ();
#line 376 "../src/db/Db.vala"
	_tmp8_ = _tmp7_;
#line 376 "../src/db/Db.vala"
	_database_table_unref0 (_tmp8_);
#line 377 "../src/db/Db.vala"
	if (!database_table_has_column ("FaceLocationTable", "vec")) {
#line 378 "../src/db/Db.vala"
		g_message ("Db.vala:378: upgrade_database: adding vec column to FaceLocationTable");
#line 379 "../src/db/Db.vala"
		if (!database_table_add_column ("FaceLocationTable", "vec", "TEXT")) {
#line 380 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 380 "../src/db/Db.vala"
			return result;
#line 797 "Db.c"
		}
	}
#line 382 "../src/db/Db.vala"
	if (!database_table_has_column ("FaceLocationTable", "guess")) {
#line 383 "../src/db/Db.vala"
		g_message ("Db.vala:383: upgrade_database: adding guess column to FaceLocationTabl" \
"e");
#line 384 "../src/db/Db.vala"
		if (!database_table_add_column ("FaceLocationTable", "guess", "INTEGER DEFAULT 0")) {
#line 385 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 385 "../src/db/Db.vala"
			return result;
#line 810 "Db.c"
		}
	}
#line 387 "../src/db/Db.vala"
	if (!database_table_has_column ("FaceTable", "ref")) {
#line 388 "../src/db/Db.vala"
		g_message ("Db.vala:388: upgrade_database: adding ref column to FaceTable");
#line 389 "../src/db/Db.vala"
		if (!database_table_add_column ("FaceTable", "ref", "INTEGER DEFAULT -1")) {
#line 390 "../src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 390 "../src/db/Db.vala"
			return result;
#line 823 "Db.c"
		}
	}
#line 393 "../src/db/Db.vala"
	version = 22;
#line 399 "../src/db/Db.vala"
	if (input_version < 23) {
#line 401 "../src/db/Db.vala"
		gsettings_configuration_engine_run_gsettings_migrator_v2 ();
#line 832 "Db.c"
	}
#line 404 "../src/db/Db.vala"
	version = 23;
#line 406 "../src/db/Db.vala"
	if (input_version < 24) {
#line 408 "../src/db/Db.vala"
		g_message ("Db.vala:408: upgrade_database: Shifting times from 0 to null for unset" \
" times");
#line 840 "Db.c"
		{
#line 410 "../src/db/Db.vala"
			photo_table_upgrade_for_unset_timestamp (&_inner_error0_);
#line 410 "../src/db/Db.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 410 "../src/db/Db.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 848 "Db.c"
					goto __catch0_database_error;
				}
#line 410 "../src/db/Db.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 410 "../src/db/Db.vala"
				g_clear_error (&_inner_error0_);
#line 410 "../src/db/Db.vala"
				return 0;
#line 857 "Db.c"
			}
#line 411 "../src/db/Db.vala"
			video_table_upgrade_for_unset_timestamp (&_inner_error0_);
#line 411 "../src/db/Db.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 411 "../src/db/Db.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 865 "Db.c"
					goto __catch0_database_error;
				}
#line 411 "../src/db/Db.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../src/db/Db.vala"
				g_clear_error (&_inner_error0_);
#line 411 "../src/db/Db.vala"
				return 0;
#line 874 "Db.c"
			}
#line 412 "../src/db/Db.vala"
			version = 24;
#line 878 "Db.c"
		}
		goto __finally0;
		__catch0_database_error:
		{
			GError* err = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 409 "../src/db/Db.vala"
			err = _inner_error0_;
#line 409 "../src/db/Db.vala"
			_inner_error0_ = NULL;
#line 414 "../src/db/Db.vala"
			_tmp9_ = err;
#line 414 "../src/db/Db.vala"
			_tmp10_ = _tmp9_->message;
#line 414 "../src/db/Db.vala"
			g_critical ("Db.vala:414: Failed to upgrade database to version 24: %s", _tmp10_);
#line 409 "../src/db/Db.vala"
			_g_error_free0 (err);
#line 898 "Db.c"
		}
		__finally0:
#line 409 "../src/db/Db.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 409 "../src/db/Db.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 409 "../src/db/Db.vala"
			g_clear_error (&_inner_error0_);
#line 409 "../src/db/Db.vala"
			return 0;
#line 909 "Db.c"
		}
	}
#line 418 "../src/db/Db.vala"
	_vala_assert (version == DATABASE_TABLE_SCHEMA_VERSION, "version == DatabaseTable.SCHEMA_VERSION");
#line 419 "../src/db/Db.vala"
	_tmp11_ = version_table_get_instance ();
#line 419 "../src/db/Db.vala"
	_tmp12_ = _tmp11_;
#line 419 "../src/db/Db.vala"
	version_table_update_version (_tmp12_, version, RESOURCES_APP_VERSION);
#line 419 "../src/db/Db.vala"
	_database_table_unref0 (_tmp12_);
#line 421 "../src/db/Db.vala"
	g_message ("Db.vala:421: Database upgrade to schema version %d successful", version);
#line 423 "../src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 423 "../src/db/Db.vala"
	return result;
#line 928 "Db.c"
}

