/* FaceTable.c generated by valac 0.56.13, the Vala compiler
 * generated from FaceTable.vala, do not modify */

/* Copyright 2018 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <gee.h>

#define FACE_ID_INVALID ((gint64) -1)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_FACE_ID (face_id_get_type ())
typedef struct _FaceID FaceID;

#define TYPE_FACE_ROW (face_row_get_type ())
#define FACE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_ROW, FaceRow))
#define FACE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_ROW, FaceRowClass))
#define IS_FACE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_ROW))
#define IS_FACE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_ROW))
#define FACE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_ROW, FaceRowClass))

typedef struct _FaceRow FaceRow;
typedef struct _FaceRowClass FaceRowClass;
typedef struct _FaceRowPrivate FaceRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecFaceRow ParamSpecFaceRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_FACE_TABLE (face_table_get_type ())
#define FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_TABLE, FaceTable))
#define FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_TABLE, FaceTableClass))
#define IS_FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_TABLE))
#define IS_FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_TABLE))
#define FACE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_TABLE, FaceTableClass))

typedef struct _FaceTable FaceTable;
typedef struct _FaceTableClass FaceTableClass;
typedef struct _FaceTablePrivate FaceTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_DATABASE_ERROR (database_error_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _face_row_unref0(var) ((var == NULL) ? NULL : (var = (face_row_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FaceID {
	gint64 id;
};

struct _PhotoID {
	gint64 id;
};

struct _FaceRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FaceRowPrivate * priv;
	FaceID face_id;
	gchar* name;
	gint64 time_created;
	PhotoID ref;
	gchar* vec;
};

struct _FaceRowClass {
	GTypeClass parent_class;
	void (*finalize) (FaceRow *self);
};

struct _ParamSpecFaceRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _FaceTable {
	DatabaseTable parent_instance;
	FaceTablePrivate * priv;
};

struct _FaceTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer face_row_parent_class = NULL;
static gpointer face_table_parent_class = NULL;
static FaceTable* face_table_instance;
static FaceTable* face_table_instance = NULL;
VALA_EXTERN sqlite3* database_table_db;

VALA_EXTERN GType face_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FaceID* face_id_dup (const FaceID* self);
VALA_EXTERN void face_id_free (FaceID* self);
VALA_EXTERN void face_id_init (FaceID *self,
                   gint64 id);
VALA_EXTERN gboolean face_id_is_invalid (FaceID *self);
VALA_EXTERN gboolean face_id_is_valid (FaceID *self);
VALA_EXTERN gpointer face_row_ref (gpointer instance);
VALA_EXTERN void face_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_face_row (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags);
VALA_EXTERN void value_set_face_row (GValue* value,
                         gpointer v_object);
VALA_EXTERN void value_take_face_row (GValue* value,
                          gpointer v_object);
VALA_EXTERN gpointer value_get_face_row (const GValue* value);
VALA_EXTERN GType face_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceRow, face_row_unref)
VALA_EXTERN GType photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoID* photo_id_dup (const PhotoID* self);
VALA_EXTERN void photo_id_free (PhotoID* self);
VALA_EXTERN FaceRow* face_row_new (void);
VALA_EXTERN FaceRow* face_row_construct (GType object_type);
static void face_row_finalize (FaceRow * obj);
static GType face_row_get_type_once (void);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType face_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceTable, database_table_unref)
static FaceTable* face_table_new (void);
static FaceTable* face_table_construct (GType object_type);
VALA_EXTERN DatabaseTable* database_table_construct (GType object_type);
VALA_EXTERN void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VALA_EXTERN void database_table_fatal (const gchar* op,
                           gint res);
VALA_EXTERN FaceTable* face_table_get_instance (void);
VALA_EXTERN GQuark database_error_quark (void);
VALA_EXTERN GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FaceRow* face_table_add (FaceTable* self,
                         const gchar* name,
                         GError** error);
VALA_EXTERN gint64 now_sec (void);
VALA_EXTERN void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
VALA_EXTERN void face_table_create_from_row (FaceTable* self,
                                 FaceRow* row,
                                 FaceID* result,
                                 GError** error);
VALA_EXTERN void face_table_remove (FaceTable* self,
                        FaceID* face_id,
                        GError** error);
VALA_EXTERN void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
VALA_EXTERN gchar* face_table_get_name (FaceTable* self,
                            FaceID* face_id,
                            GError** error);
VALA_EXTERN gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt** stmt);
VALA_EXTERN FaceRow* face_table_get_row (FaceTable* self,
                             FaceID* face_id,
                             GError** error);
VALA_EXTERN GeeList* face_table_get_all_rows (FaceTable* self,
                                  GError** error);
VALA_EXTERN void face_table_rename (FaceTable* self,
                        FaceID* face_id,
                        const gchar* new_name,
                        GError** error);
VALA_EXTERN void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
VALA_EXTERN void face_table_set_reference (FaceTable* self,
                               FaceID* face_id,
                               PhotoID* photo_id,
                               GError** error);
VALA_EXTERN GeeList* face_table_get_ref_rows (FaceTable* self,
                                  GError** error);
VALA_EXTERN void photo_id_init (PhotoID *self,
                    gint64 id);
static void face_table_finalize (DatabaseTable * obj);
static GType face_table_get_type_once (void);

void
face_id_init (FaceID *self,
              gint64 id)
{
#line 12 "../src/db/FaceTable.vala"
	memset (self, 0, sizeof (FaceID));
#line 13 "../src/db/FaceTable.vala"
	(*self).id = id;
#line 257 "FaceTable.c"
}

gboolean
face_id_is_invalid (FaceID *self)
{
	gboolean result;
#line 17 "../src/db/FaceTable.vala"
	result = (*self).id == FACE_ID_INVALID;
#line 17 "../src/db/FaceTable.vala"
	return result;
#line 268 "FaceTable.c"
}

gboolean
face_id_is_valid (FaceID *self)
{
	gboolean result;
#line 21 "../src/db/FaceTable.vala"
	result = (*self).id != FACE_ID_INVALID;
#line 21 "../src/db/FaceTable.vala"
	return result;
#line 279 "FaceTable.c"
}

FaceID*
face_id_dup (const FaceID* self)
{
	FaceID* dup;
#line 7 "../src/db/FaceTable.vala"
	dup = g_new0 (FaceID, 1);
#line 7 "../src/db/FaceTable.vala"
	memcpy (dup, self, sizeof (FaceID));
#line 7 "../src/db/FaceTable.vala"
	return dup;
#line 292 "FaceTable.c"
}

void
face_id_free (FaceID* self)
{
#line 7 "../src/db/FaceTable.vala"
	g_free (self);
#line 300 "FaceTable.c"
}

static GType
face_id_get_type_once (void)
{
	GType face_id_type_id;
	face_id_type_id = g_boxed_type_register_static ("FaceID", (GBoxedCopyFunc) face_id_dup, (GBoxedFreeFunc) face_id_free);
	return face_id_type_id;
}

GType
face_id_get_type (void)
{
	static volatile gsize face_id_type_id__once = 0;
	if (g_once_init_enter (&face_id_type_id__once)) {
		GType face_id_type_id;
		face_id_type_id = face_id_get_type_once ();
		g_once_init_leave (&face_id_type_id__once, face_id_type_id);
	}
	return face_id_type_id__once;
}

FaceRow*
face_row_construct (GType object_type)
{
	FaceRow* self = NULL;
#line 25 "../src/db/FaceTable.vala"
	self = (FaceRow*) g_type_create_instance (object_type);
#line 25 "../src/db/FaceTable.vala"
	return self;
#line 331 "FaceTable.c"
}

FaceRow*
face_row_new (void)
{
#line 25 "../src/db/FaceTable.vala"
	return face_row_construct (TYPE_FACE_ROW);
#line 339 "FaceTable.c"
}

static void
value_face_row_init (GValue* value)
{
#line 25 "../src/db/FaceTable.vala"
	value->data[0].v_pointer = NULL;
#line 347 "FaceTable.c"
}

static void
value_face_row_free_value (GValue* value)
{
#line 25 "../src/db/FaceTable.vala"
	if (value->data[0].v_pointer) {
#line 25 "../src/db/FaceTable.vala"
		face_row_unref (value->data[0].v_pointer);
#line 357 "FaceTable.c"
	}
}

static void
value_face_row_copy_value (const GValue* src_value,
                           GValue* dest_value)
{
#line 25 "../src/db/FaceTable.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "../src/db/FaceTable.vala"
		dest_value->data[0].v_pointer = face_row_ref (src_value->data[0].v_pointer);
#line 369 "FaceTable.c"
	} else {
#line 25 "../src/db/FaceTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 373 "FaceTable.c"
	}
}

static gpointer
value_face_row_peek_pointer (const GValue* value)
{
#line 25 "../src/db/FaceTable.vala"
	return value->data[0].v_pointer;
#line 382 "FaceTable.c"
}

static gchar*
value_face_row_collect_value (GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
#line 25 "../src/db/FaceTable.vala"
	if (collect_values[0].v_pointer) {
#line 393 "FaceTable.c"
		FaceRow * object;
		object = collect_values[0].v_pointer;
#line 25 "../src/db/FaceTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "../src/db/FaceTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 400 "FaceTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "../src/db/FaceTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 404 "FaceTable.c"
		}
#line 25 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = face_row_ref (object);
#line 408 "FaceTable.c"
	} else {
#line 25 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 412 "FaceTable.c"
	}
#line 25 "../src/db/FaceTable.vala"
	return NULL;
#line 416 "FaceTable.c"
}

static gchar*
value_face_row_lcopy_value (const GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
	FaceRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "../src/db/FaceTable.vala"
	if (!object_p) {
#line 25 "../src/db/FaceTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 431 "FaceTable.c"
	}
#line 25 "../src/db/FaceTable.vala"
	if (!value->data[0].v_pointer) {
#line 25 "../src/db/FaceTable.vala"
		*object_p = NULL;
#line 437 "FaceTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "../src/db/FaceTable.vala"
		*object_p = value->data[0].v_pointer;
#line 441 "FaceTable.c"
	} else {
#line 25 "../src/db/FaceTable.vala"
		*object_p = face_row_ref (value->data[0].v_pointer);
#line 445 "FaceTable.c"
	}
#line 25 "../src/db/FaceTable.vala"
	return NULL;
#line 449 "FaceTable.c"
}

GParamSpec*
param_spec_face_row (const gchar* name,
                     const gchar* nick,
                     const gchar* blurb,
                     GType object_type,
                     GParamFlags flags)
{
	ParamSpecFaceRow* spec;
#line 25 "../src/db/FaceTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FACE_ROW), NULL);
#line 25 "../src/db/FaceTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "../src/db/FaceTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "../src/db/FaceTable.vala"
	return G_PARAM_SPEC (spec);
#line 468 "FaceTable.c"
}

gpointer
value_get_face_row (const GValue* value)
{
#line 25 "../src/db/FaceTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW), NULL);
#line 25 "../src/db/FaceTable.vala"
	return value->data[0].v_pointer;
#line 478 "FaceTable.c"
}

void
value_set_face_row (GValue* value,
                    gpointer v_object)
{
	FaceRow * old;
#line 25 "../src/db/FaceTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW));
#line 25 "../src/db/FaceTable.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/db/FaceTable.vala"
	if (v_object) {
#line 25 "../src/db/FaceTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FACE_ROW));
#line 25 "../src/db/FaceTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = v_object;
#line 25 "../src/db/FaceTable.vala"
		face_row_ref (value->data[0].v_pointer);
#line 500 "FaceTable.c"
	} else {
#line 25 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 504 "FaceTable.c"
	}
#line 25 "../src/db/FaceTable.vala"
	if (old) {
#line 25 "../src/db/FaceTable.vala"
		face_row_unref (old);
#line 510 "FaceTable.c"
	}
}

void
value_take_face_row (GValue* value,
                     gpointer v_object)
{
	FaceRow * old;
#line 25 "../src/db/FaceTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW));
#line 25 "../src/db/FaceTable.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/db/FaceTable.vala"
	if (v_object) {
#line 25 "../src/db/FaceTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FACE_ROW));
#line 25 "../src/db/FaceTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = v_object;
#line 531 "FaceTable.c"
	} else {
#line 25 "../src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 535 "FaceTable.c"
	}
#line 25 "../src/db/FaceTable.vala"
	if (old) {
#line 25 "../src/db/FaceTable.vala"
		face_row_unref (old);
#line 541 "FaceTable.c"
	}
}

static void
face_row_class_init (FaceRowClass * klass,
                     gpointer klass_data)
{
#line 25 "../src/db/FaceTable.vala"
	face_row_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/db/FaceTable.vala"
	((FaceRowClass *) klass)->finalize = face_row_finalize;
#line 553 "FaceTable.c"
}

static void
face_row_instance_init (FaceRow * self,
                        gpointer klass)
{
#line 25 "../src/db/FaceTable.vala"
	self->ref_count = 1;
#line 562 "FaceTable.c"
}

static void
face_row_finalize (FaceRow * obj)
{
	FaceRow * self;
#line 25 "../src/db/FaceTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FACE_ROW, FaceRow);
#line 25 "../src/db/FaceTable.vala"
	g_signal_handlers_destroy (self);
#line 27 "../src/db/FaceTable.vala"
	_g_free0 (self->name);
#line 30 "../src/db/FaceTable.vala"
	_g_free0 (self->vec);
#line 577 "FaceTable.c"
}

static GType
face_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_face_row_init, value_face_row_free_value, value_face_row_copy_value, value_face_row_peek_pointer, "p", value_face_row_collect_value, "p", value_face_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (FaceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceRow), 0, (GInstanceInitFunc) face_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType face_row_type_id;
	face_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FaceRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return face_row_type_id;
}

GType
face_row_get_type (void)
{
	static volatile gsize face_row_type_id__once = 0;
	if (g_once_init_enter (&face_row_type_id__once)) {
		GType face_row_type_id;
		face_row_type_id = face_row_get_type_once ();
		g_once_init_leave (&face_row_type_id__once, face_row_type_id);
	}
	return face_row_type_id__once;
}

gpointer
face_row_ref (gpointer instance)
{
	FaceRow * self;
	self = instance;
#line 25 "../src/db/FaceTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "../src/db/FaceTable.vala"
	return instance;
#line 612 "FaceTable.c"
}

void
face_row_unref (gpointer instance)
{
	FaceRow * self;
	self = instance;
#line 25 "../src/db/FaceTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "../src/db/FaceTable.vala"
		FACE_ROW_GET_CLASS (self)->finalize (self);
#line 25 "../src/db/FaceTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 626 "FaceTable.c"
	}
}

static FaceTable*
face_table_construct (GType object_type)
{
	FaceTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
#line 36 "../src/db/FaceTable.vala"
	self = (FaceTable*) database_table_construct (object_type);
#line 37 "../src/db/FaceTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "FaceTable");
#line 40 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 40 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "FaceTable " "(" "id INTEGER NOT NULL PRIMARY KEY, " "name TEXT NOT NULL, " "time_created TIMESTAMP, " "ref INTEGER DEFAULT -1" ")", -1, &_tmp1_, NULL);
#line 40 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 40 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 40 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 48 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 50 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 50 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp3_);
#line 51 "../src/db/FaceTable.vala"
	if (res != SQLITE_DONE) {
#line 52 "../src/db/FaceTable.vala"
		database_table_fatal ("create FaceTable", res);
#line 664 "FaceTable.c"
	}
#line 36 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 36 "../src/db/FaceTable.vala"
	return self;
#line 670 "FaceTable.c"
}

static FaceTable*
face_table_new (void)
{
#line 36 "../src/db/FaceTable.vala"
	return face_table_construct (TYPE_FACE_TABLE);
#line 678 "FaceTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 59 "../src/db/FaceTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 686 "FaceTable.c"
}

FaceTable*
face_table_get_instance (void)
{
	FaceTable* _tmp0_;
	FaceTable* _tmp2_;
	FaceTable* _tmp3_;
	FaceTable* result;
#line 56 "../src/db/FaceTable.vala"
	_tmp0_ = face_table_instance;
#line 56 "../src/db/FaceTable.vala"
	if (_tmp0_ == NULL) {
#line 700 "FaceTable.c"
		FaceTable* _tmp1_;
#line 57 "../src/db/FaceTable.vala"
		_tmp1_ = face_table_new ();
#line 57 "../src/db/FaceTable.vala"
		_database_table_unref0 (face_table_instance);
#line 57 "../src/db/FaceTable.vala"
		face_table_instance = _tmp1_;
#line 708 "FaceTable.c"
	}
#line 59 "../src/db/FaceTable.vala"
	_tmp2_ = face_table_instance;
#line 59 "../src/db/FaceTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 59 "../src/db/FaceTable.vala"
	result = _tmp3_;
#line 59 "../src/db/FaceTable.vala"
	return result;
#line 718 "FaceTable.c"
}

FaceRow*
face_table_add (FaceTable* self,
                const gchar* name,
                GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	FaceRow* row = NULL;
	FaceRow* _tmp8_;
	FaceRow* _tmp9_;
	sqlite3* _tmp10_;
	FaceRow* _tmp11_;
	gchar* _tmp12_;
	FaceRow* _tmp13_;
	GError* _inner_error0_ = NULL;
	FaceRow* result;
#line 62 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 62 "../src/db/FaceTable.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 64 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 64 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 64 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 64 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 64 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 66 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 68 "../src/db/FaceTable.vala"
	time_created = now_sec ();
#line 70 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 70 "../src/db/FaceTable.vala"
	_tmp4_ = g_strdup (name);
#line 70 "../src/db/FaceTable.vala"
	_tmp5_ = g_free;
#line 70 "../src/db/FaceTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 71 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 72 "../src/db/FaceTable.vala"
	_tmp6_ = stmt;
#line 72 "../src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 2, time_created);
#line 73 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 75 "../src/db/FaceTable.vala"
	_tmp7_ = stmt;
#line 75 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp7_);
#line 76 "../src/db/FaceTable.vala"
	if (res != SQLITE_DONE) {
#line 77 "../src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.add", res, &_inner_error0_);
#line 77 "../src/db/FaceTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/db/FaceTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 77 "../src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 77 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 77 "../src/db/FaceTable.vala"
				return NULL;
#line 798 "FaceTable.c"
			} else {
#line 77 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 77 "../src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/db/FaceTable.vala"
				g_clear_error (&_inner_error0_);
#line 77 "../src/db/FaceTable.vala"
				return NULL;
#line 808 "FaceTable.c"
			}
		}
	}
#line 79 "../src/db/FaceTable.vala"
	_tmp8_ = face_row_new ();
#line 79 "../src/db/FaceTable.vala"
	row = _tmp8_;
#line 80 "../src/db/FaceTable.vala"
	_tmp9_ = row;
#line 80 "../src/db/FaceTable.vala"
	_tmp10_ = database_table_db;
#line 80 "../src/db/FaceTable.vala"
	face_id_init (&_tmp9_->face_id, sqlite3_last_insert_rowid (_tmp10_));
#line 81 "../src/db/FaceTable.vala"
	_tmp11_ = row;
#line 81 "../src/db/FaceTable.vala"
	_tmp12_ = g_strdup (name);
#line 81 "../src/db/FaceTable.vala"
	_g_free0 (_tmp11_->name);
#line 81 "../src/db/FaceTable.vala"
	_tmp11_->name = _tmp12_;
#line 82 "../src/db/FaceTable.vala"
	_tmp13_ = row;
#line 82 "../src/db/FaceTable.vala"
	_tmp13_->time_created = time_created;
#line 84 "../src/db/FaceTable.vala"
	result = row;
#line 84 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 84 "../src/db/FaceTable.vala"
	return result;
#line 840 "FaceTable.c"
}

void
face_table_create_from_row (FaceTable* self,
                            FaceRow* row,
                            FaceID* result,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3* _tmp9_;
	FaceID _tmp10_ = {0};
	GError* _inner_error0_ = NULL;
#line 87 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 87 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_ROW (row));
#line 89 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 89 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 89 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 89 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 89 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 91 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 93 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 93 "../src/db/FaceTable.vala"
	_tmp4_ = row->name;
#line 93 "../src/db/FaceTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 93 "../src/db/FaceTable.vala"
	_tmp6_ = g_free;
#line 93 "../src/db/FaceTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
#line 94 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 95 "../src/db/FaceTable.vala"
	_tmp7_ = stmt;
#line 95 "../src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 2, row->time_created);
#line 96 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 98 "../src/db/FaceTable.vala"
	_tmp8_ = stmt;
#line 98 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp8_);
#line 99 "../src/db/FaceTable.vala"
	if (res != SQLITE_DONE) {
#line 100 "../src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.create_from_row", res, &_inner_error0_);
#line 100 "../src/db/FaceTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/db/FaceTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 100 "../src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 100 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 100 "../src/db/FaceTable.vala"
				return;
#line 915 "FaceTable.c"
			} else {
#line 100 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 100 "../src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../src/db/FaceTable.vala"
				g_clear_error (&_inner_error0_);
#line 100 "../src/db/FaceTable.vala"
				return;
#line 925 "FaceTable.c"
			}
		}
	}
#line 102 "../src/db/FaceTable.vala"
	_tmp9_ = database_table_db;
#line 102 "../src/db/FaceTable.vala"
	face_id_init (&_tmp10_, sqlite3_last_insert_rowid (_tmp9_));
#line 102 "../src/db/FaceTable.vala"
	*result = _tmp10_;
#line 102 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 102 "../src/db/FaceTable.vala"
	return;
#line 939 "FaceTable.c"
}

void
face_table_remove (FaceTable* self,
                   FaceID* face_id,
                   GError** error)
{
	FaceID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 105 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 105 "../src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 106 "../src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 106 "../src/db/FaceTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, &_inner_error0_);
#line 106 "../src/db/FaceTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/db/FaceTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 106 "../src/db/FaceTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 106 "../src/db/FaceTable.vala"
			return;
#line 965 "FaceTable.c"
		} else {
#line 106 "../src/db/FaceTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../src/db/FaceTable.vala"
			g_clear_error (&_inner_error0_);
#line 106 "../src/db/FaceTable.vala"
			return;
#line 973 "FaceTable.c"
		}
	}
}

gchar*
face_table_get_name (FaceTable* self,
                     FaceID* face_id,
                     GError** error)
{
	sqlite3_stmt* stmt = NULL;
	FaceID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 109 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 109 "../src/db/FaceTable.vala"
	g_return_val_if_fail (face_id != NULL, NULL);
#line 111 "../src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 111 "../src/db/FaceTable.vala"
	_tmp2_ = database_table_select_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "name", &_tmp1_);
#line 111 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 111 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 111 "../src/db/FaceTable.vala"
	if (!_tmp2_) {
#line 112 "../src/db/FaceTable.vala"
		result = NULL;
#line 112 "../src/db/FaceTable.vala"
		_sqlite3_finalize0 (stmt);
#line 112 "../src/db/FaceTable.vala"
		return result;
#line 1011 "FaceTable.c"
	}
#line 114 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 114 "../src/db/FaceTable.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 114 "../src/db/FaceTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 114 "../src/db/FaceTable.vala"
	result = _tmp5_;
#line 114 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 114 "../src/db/FaceTable.vala"
	return result;
#line 1025 "FaceTable.c"
}

FaceRow*
face_table_get_row (FaceTable* self,
                    FaceID* face_id,
                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	FaceID _tmp4_;
	sqlite3_stmt* _tmp5_;
	FaceRow* row = NULL;
	FaceRow* _tmp6_;
	FaceRow* _tmp7_;
	FaceID _tmp8_;
	FaceRow* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	FaceRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	GError* _inner_error0_ = NULL;
	FaceRow* result;
#line 117 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 117 "../src/db/FaceTable.vala"
	g_return_val_if_fail (face_id != NULL, NULL);
#line 119 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 119 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT name, time_created FROM FaceTable WHERE id=?", -1, &_tmp1_, NULL);
#line 119 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 119 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 119 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 121 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 123 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 123 "../src/db/FaceTable.vala"
	_tmp4_ = *face_id;
#line 123 "../src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 124 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 126 "../src/db/FaceTable.vala"
	_tmp5_ = stmt;
#line 126 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp5_);
#line 127 "../src/db/FaceTable.vala"
	if (res == SQLITE_DONE) {
#line 128 "../src/db/FaceTable.vala"
		result = NULL;
#line 128 "../src/db/FaceTable.vala"
		_sqlite3_finalize0 (stmt);
#line 128 "../src/db/FaceTable.vala"
		return result;
#line 1089 "FaceTable.c"
	} else {
#line 129 "../src/db/FaceTable.vala"
		if (res != SQLITE_ROW) {
#line 130 "../src/db/FaceTable.vala"
			database_table_throw_error ("FaceTable.get_row", res, &_inner_error0_);
#line 130 "../src/db/FaceTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../src/db/FaceTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 130 "../src/db/FaceTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 130 "../src/db/FaceTable.vala"
					_sqlite3_finalize0 (stmt);
#line 130 "../src/db/FaceTable.vala"
					return NULL;
#line 1105 "FaceTable.c"
				} else {
#line 130 "../src/db/FaceTable.vala"
					_sqlite3_finalize0 (stmt);
#line 130 "../src/db/FaceTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "../src/db/FaceTable.vala"
					g_clear_error (&_inner_error0_);
#line 130 "../src/db/FaceTable.vala"
					return NULL;
#line 1115 "FaceTable.c"
				}
			}
		}
	}
#line 132 "../src/db/FaceTable.vala"
	_tmp6_ = face_row_new ();
#line 132 "../src/db/FaceTable.vala"
	row = _tmp6_;
#line 133 "../src/db/FaceTable.vala"
	_tmp7_ = row;
#line 133 "../src/db/FaceTable.vala"
	_tmp8_ = *face_id;
#line 133 "../src/db/FaceTable.vala"
	_tmp7_->face_id = _tmp8_;
#line 134 "../src/db/FaceTable.vala"
	_tmp9_ = row;
#line 134 "../src/db/FaceTable.vala"
	_tmp10_ = stmt;
#line 134 "../src/db/FaceTable.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 134 "../src/db/FaceTable.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 134 "../src/db/FaceTable.vala"
	_g_free0 (_tmp9_->name);
#line 134 "../src/db/FaceTable.vala"
	_tmp9_->name = _tmp12_;
#line 135 "../src/db/FaceTable.vala"
	_tmp13_ = row;
#line 135 "../src/db/FaceTable.vala"
	_tmp14_ = stmt;
#line 135 "../src/db/FaceTable.vala"
	_tmp13_->time_created = sqlite3_column_int64 (_tmp14_, 1);
#line 137 "../src/db/FaceTable.vala"
	result = row;
#line 137 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 137 "../src/db/FaceTable.vala"
	return result;
#line 1154 "FaceTable.c"
}

GeeList*
face_table_get_all_rows (FaceTable* self,
                         GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeList* rows = NULL;
	GeeArrayList* _tmp3_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 140 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 142 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 142 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, name, time_created FROM FaceTable", -1, &_tmp1_, NULL);
#line 142 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 142 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 142 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 144 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 146 "../src/db/FaceTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_FACE_ROW, (GBoxedCopyFunc) face_row_ref, (GDestroyNotify) face_row_unref, NULL, NULL, NULL);
#line 146 "../src/db/FaceTable.vala"
	rows = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList);
#line 1188 "FaceTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 148 "../src/db/FaceTable.vala"
		_tmp4_ = TRUE;
#line 148 "../src/db/FaceTable.vala"
		while (TRUE) {
#line 1195 "FaceTable.c"
			sqlite3_stmt* _tmp5_;
			FaceRow* row = NULL;
			FaceRow* _tmp6_;
			FaceRow* _tmp7_;
			sqlite3_stmt* _tmp8_;
			FaceRow* _tmp9_;
			sqlite3_stmt* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			FaceRow* _tmp13_;
			sqlite3_stmt* _tmp14_;
			GeeList* _tmp15_;
			FaceRow* _tmp16_;
#line 148 "../src/db/FaceTable.vala"
			if (!_tmp4_) {
#line 1211 "FaceTable.c"
			}
#line 148 "../src/db/FaceTable.vala"
			_tmp4_ = FALSE;
#line 149 "../src/db/FaceTable.vala"
			_tmp5_ = stmt;
#line 149 "../src/db/FaceTable.vala"
			res = sqlite3_step (_tmp5_);
#line 150 "../src/db/FaceTable.vala"
			if (res == SQLITE_DONE) {
#line 151 "../src/db/FaceTable.vala"
				break;
#line 1223 "FaceTable.c"
			} else {
#line 152 "../src/db/FaceTable.vala"
				if (res != SQLITE_ROW) {
#line 153 "../src/db/FaceTable.vala"
					database_table_throw_error ("FaceTable.get_all_rows", res, &_inner_error0_);
#line 153 "../src/db/FaceTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "../src/db/FaceTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 153 "../src/db/FaceTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 153 "../src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 153 "../src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 153 "../src/db/FaceTable.vala"
							return NULL;
#line 1241 "FaceTable.c"
						} else {
#line 153 "../src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 153 "../src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 153 "../src/db/FaceTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 153 "../src/db/FaceTable.vala"
							g_clear_error (&_inner_error0_);
#line 153 "../src/db/FaceTable.vala"
							return NULL;
#line 1253 "FaceTable.c"
						}
					}
				}
			}
#line 156 "../src/db/FaceTable.vala"
			_tmp6_ = face_row_new ();
#line 156 "../src/db/FaceTable.vala"
			row = _tmp6_;
#line 157 "../src/db/FaceTable.vala"
			_tmp7_ = row;
#line 157 "../src/db/FaceTable.vala"
			_tmp8_ = stmt;
#line 157 "../src/db/FaceTable.vala"
			face_id_init (&_tmp7_->face_id, sqlite3_column_int64 (_tmp8_, 0));
#line 158 "../src/db/FaceTable.vala"
			_tmp9_ = row;
#line 158 "../src/db/FaceTable.vala"
			_tmp10_ = stmt;
#line 158 "../src/db/FaceTable.vala"
			_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 158 "../src/db/FaceTable.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 158 "../src/db/FaceTable.vala"
			_g_free0 (_tmp9_->name);
#line 158 "../src/db/FaceTable.vala"
			_tmp9_->name = _tmp12_;
#line 159 "../src/db/FaceTable.vala"
			_tmp13_ = row;
#line 159 "../src/db/FaceTable.vala"
			_tmp14_ = stmt;
#line 159 "../src/db/FaceTable.vala"
			_tmp13_->time_created = sqlite3_column_int64 (_tmp14_, 2);
#line 161 "../src/db/FaceTable.vala"
			_tmp15_ = rows;
#line 161 "../src/db/FaceTable.vala"
			_tmp16_ = row;
#line 161 "../src/db/FaceTable.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection), _tmp16_);
#line 148 "../src/db/FaceTable.vala"
			_face_row_unref0 (row);
#line 1294 "FaceTable.c"
		}
	}
#line 164 "../src/db/FaceTable.vala"
	result = rows;
#line 164 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 164 "../src/db/FaceTable.vala"
	return result;
#line 1303 "FaceTable.c"
}

void
face_table_rename (FaceTable* self,
                   FaceID* face_id,
                   const gchar* new_name,
                   GError** error)
{
	FaceID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 167 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 167 "../src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 167 "../src/db/FaceTable.vala"
	g_return_if_fail (new_name != NULL);
#line 168 "../src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 168 "../src/db/FaceTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "name", new_name, &_inner_error0_);
#line 168 "../src/db/FaceTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 168 "../src/db/FaceTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 168 "../src/db/FaceTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 168 "../src/db/FaceTable.vala"
			return;
#line 1332 "FaceTable.c"
		} else {
#line 168 "../src/db/FaceTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "../src/db/FaceTable.vala"
			g_clear_error (&_inner_error0_);
#line 168 "../src/db/FaceTable.vala"
			return;
#line 1340 "FaceTable.c"
		}
	}
}

void
face_table_set_reference (FaceTable* self,
                          FaceID* face_id,
                          PhotoID* photo_id,
                          GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	PhotoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	FaceID _tmp6_;
	sqlite3_stmt* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 171 "../src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 171 "../src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 171 "../src/db/FaceTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 174 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 174 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE FaceTable SET ref=? WHERE id=?", -1, &_tmp1_, NULL);
#line 174 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 174 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 174 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 175 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 176 "../src/db/FaceTable.vala"
	_tmp3_ = stmt;
#line 176 "../src/db/FaceTable.vala"
	_tmp4_ = *photo_id;
#line 176 "../src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 177 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 178 "../src/db/FaceTable.vala"
	_tmp5_ = stmt;
#line 178 "../src/db/FaceTable.vala"
	_tmp6_ = *face_id;
#line 178 "../src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp5_, 2, _tmp6_.id);
#line 179 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 181 "../src/db/FaceTable.vala"
	_tmp7_ = stmt;
#line 181 "../src/db/FaceTable.vala"
	res = sqlite3_step (_tmp7_);
#line 182 "../src/db/FaceTable.vala"
	if (res != SQLITE_DONE) {
#line 183 "../src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.set_reference", res, &_inner_error0_);
#line 183 "../src/db/FaceTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/db/FaceTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 183 "../src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 183 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 183 "../src/db/FaceTable.vala"
				return;
#line 1414 "FaceTable.c"
			} else {
#line 183 "../src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 183 "../src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../src/db/FaceTable.vala"
				g_clear_error (&_inner_error0_);
#line 183 "../src/db/FaceTable.vala"
				return;
#line 1424 "FaceTable.c"
			}
		}
	}
#line 171 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1430 "FaceTable.c"
}

GeeList*
face_table_get_ref_rows (FaceTable* self,
                         GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeList* rows = NULL;
	GeeArrayList* _tmp3_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 186 "../src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 188 "../src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 188 "../src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, name, time_created, ref FROM FaceTable WHERE ref != -1", -1, &_tmp1_, NULL);
#line 188 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 188 "../src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 188 "../src/db/FaceTable.vala"
	res = _tmp2_;
#line 190 "../src/db/FaceTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 192 "../src/db/FaceTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_FACE_ROW, (GBoxedCopyFunc) face_row_ref, (GDestroyNotify) face_row_unref, NULL, NULL, NULL);
#line 192 "../src/db/FaceTable.vala"
	rows = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList);
#line 1464 "FaceTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 194 "../src/db/FaceTable.vala"
		_tmp4_ = TRUE;
#line 194 "../src/db/FaceTable.vala"
		while (TRUE) {
#line 1471 "FaceTable.c"
			sqlite3_stmt* _tmp5_;
			FaceRow* row = NULL;
			FaceRow* _tmp6_;
			FaceRow* _tmp7_;
			sqlite3_stmt* _tmp8_;
			FaceRow* _tmp9_;
			sqlite3_stmt* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			FaceRow* _tmp13_;
			sqlite3_stmt* _tmp14_;
			FaceRow* _tmp15_;
			sqlite3_stmt* _tmp16_;
			GeeList* _tmp17_;
			FaceRow* _tmp18_;
#line 194 "../src/db/FaceTable.vala"
			if (!_tmp4_) {
#line 1489 "FaceTable.c"
			}
#line 194 "../src/db/FaceTable.vala"
			_tmp4_ = FALSE;
#line 195 "../src/db/FaceTable.vala"
			_tmp5_ = stmt;
#line 195 "../src/db/FaceTable.vala"
			res = sqlite3_step (_tmp5_);
#line 196 "../src/db/FaceTable.vala"
			if (res == SQLITE_DONE) {
#line 197 "../src/db/FaceTable.vala"
				break;
#line 1501 "FaceTable.c"
			} else {
#line 198 "../src/db/FaceTable.vala"
				if (res != SQLITE_ROW) {
#line 199 "../src/db/FaceTable.vala"
					database_table_throw_error ("FaceTable.get_all_rows", res, &_inner_error0_);
#line 199 "../src/db/FaceTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/db/FaceTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 199 "../src/db/FaceTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 199 "../src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 199 "../src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 199 "../src/db/FaceTable.vala"
							return NULL;
#line 1519 "FaceTable.c"
						} else {
#line 199 "../src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 199 "../src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 199 "../src/db/FaceTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../src/db/FaceTable.vala"
							g_clear_error (&_inner_error0_);
#line 199 "../src/db/FaceTable.vala"
							return NULL;
#line 1531 "FaceTable.c"
						}
					}
				}
			}
#line 202 "../src/db/FaceTable.vala"
			_tmp6_ = face_row_new ();
#line 202 "../src/db/FaceTable.vala"
			row = _tmp6_;
#line 203 "../src/db/FaceTable.vala"
			_tmp7_ = row;
#line 203 "../src/db/FaceTable.vala"
			_tmp8_ = stmt;
#line 203 "../src/db/FaceTable.vala"
			face_id_init (&_tmp7_->face_id, sqlite3_column_int64 (_tmp8_, 0));
#line 204 "../src/db/FaceTable.vala"
			_tmp9_ = row;
#line 204 "../src/db/FaceTable.vala"
			_tmp10_ = stmt;
#line 204 "../src/db/FaceTable.vala"
			_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 204 "../src/db/FaceTable.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 204 "../src/db/FaceTable.vala"
			_g_free0 (_tmp9_->name);
#line 204 "../src/db/FaceTable.vala"
			_tmp9_->name = _tmp12_;
#line 205 "../src/db/FaceTable.vala"
			_tmp13_ = row;
#line 205 "../src/db/FaceTable.vala"
			_tmp14_ = stmt;
#line 205 "../src/db/FaceTable.vala"
			_tmp13_->time_created = sqlite3_column_int64 (_tmp14_, 2);
#line 206 "../src/db/FaceTable.vala"
			_tmp15_ = row;
#line 206 "../src/db/FaceTable.vala"
			_tmp16_ = stmt;
#line 206 "../src/db/FaceTable.vala"
			photo_id_init (&_tmp15_->ref, sqlite3_column_int64 (_tmp16_, 3));
#line 208 "../src/db/FaceTable.vala"
			_tmp17_ = rows;
#line 208 "../src/db/FaceTable.vala"
			_tmp18_ = row;
#line 208 "../src/db/FaceTable.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), _tmp18_);
#line 194 "../src/db/FaceTable.vala"
			_face_row_unref0 (row);
#line 1578 "FaceTable.c"
		}
	}
#line 211 "../src/db/FaceTable.vala"
	result = rows;
#line 211 "../src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 211 "../src/db/FaceTable.vala"
	return result;
#line 1587 "FaceTable.c"
}

static void
face_table_class_init (FaceTableClass * klass,
                       gpointer klass_data)
{
#line 33 "../src/db/FaceTable.vala"
	face_table_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/db/FaceTable.vala"
	((DatabaseTableClass *) klass)->finalize = face_table_finalize;
#line 1598 "FaceTable.c"
}

static void
face_table_instance_init (FaceTable * self,
                          gpointer klass)
{
}

static void
face_table_finalize (DatabaseTable * obj)
{
	FaceTable * self;
#line 33 "../src/db/FaceTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FACE_TABLE, FaceTable);
#line 33 "../src/db/FaceTable.vala"
	DATABASE_TABLE_CLASS (face_table_parent_class)->finalize (obj);
#line 1615 "FaceTable.c"
}

static GType
face_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FaceTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceTable), 0, (GInstanceInitFunc) face_table_instance_init, NULL };
	GType face_table_type_id;
	face_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "FaceTable", &g_define_type_info, 0);
	return face_table_type_id;
}

GType
face_table_get_type (void)
{
	static volatile gsize face_table_type_id__once = 0;
	if (g_once_init_enter (&face_table_type_id__once)) {
		GType face_table_type_id;
		face_table_type_id = face_table_get_type_once ();
		g_once_init_leave (&face_table_type_id__once, face_table_type_id);
	}
	return face_table_type_id__once;
}

