/* VideoMetadata.c generated by valac 0.56.13, the Vala compiler
 * generated from VideoMetadata.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "metadata.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "shotwell-internal-video-metadata-handling.h"

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_VIDEO_METADATA (video_metadata_get_type ())
#define VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_METADATA, VideoMetadata))
#define VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_METADATA, VideoMetadataClass))
#define IS_VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_METADATA))
#define IS_VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_METADATA))
#define VIDEO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_METADATA, VideoMetadataClass))

typedef struct _VideoMetadata VideoMetadata;
typedef struct _VideoMetadataClass VideoMetadataClass;
typedef struct _VideoMetadataPrivate VideoMetadataPrivate;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _quick_time_metadata_loader_unref0(var) ((var == NULL) ? NULL : (var = (quick_time_metadata_loader_unref (var), NULL)))
#define _avi_metadata_loader_unref0(var) ((var == NULL) ? NULL : (var = (avi_metadata_loader_unref (var), NULL)))

struct _VideoMetadata {
	MediaMetadata parent_instance;
	VideoMetadataPrivate * priv;
};

struct _VideoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _VideoMetadataPrivate {
	MetadataDateTime* timestamp;
	gchar* title;
	gchar* comment;
};

static gint VideoMetadata_private_offset;
static gpointer video_metadata_parent_class = NULL;

VALA_EXTERN GType video_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoMetadata, media_metadata_unref)
VALA_EXTERN VideoMetadata* video_metadata_new (void);
VALA_EXTERN VideoMetadata* video_metadata_construct (GType object_type);
static void video_metadata_real_read_from_file (MediaMetadata* base,
                                         GFile* file,
                                         GError** error);
static MetadataDateTime* video_metadata_real_get_creation_date_time (MediaMetadata* base);
static gchar* video_metadata_real_get_title (MediaMetadata* base);
static gchar* video_metadata_real_get_comment (MediaMetadata* base);
static void video_metadata_finalize (MediaMetadata * obj);
static GType video_metadata_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
video_metadata_get_instance_private (VideoMetadata* self)
{
	return G_STRUCT_MEMBER_P (self, VideoMetadata_private_offset);
}

VideoMetadata*
video_metadata_construct (GType object_type)
{
	VideoMetadata* self = NULL;
#line 13 "../src/video-support/VideoMetadata.vala"
	self = (VideoMetadata*) media_metadata_construct (object_type);
#line 13 "../src/video-support/VideoMetadata.vala"
	return self;
#line 91 "VideoMetadata.c"
}

VideoMetadata*
video_metadata_new (void)
{
#line 13 "../src/video-support/VideoMetadata.vala"
	return video_metadata_construct (TYPE_VIDEO_METADATA);
#line 99 "VideoMetadata.c"
}

static void
video_metadata_real_read_from_file (MediaMetadata* base,
                                    GFile* file,
                                    GError** error)
{
	VideoMetadata * self;
	QuickTimeMetadataLoader* quicktime = NULL;
	QuickTimeMetadataLoader* _tmp0_;
	QuickTimeMetadataLoader* _tmp1_;
	AVIMetadataLoader* avi = NULL;
	AVIMetadataLoader* _tmp6_;
	AVIMetadataLoader* _tmp7_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GError* _tmp14_;
	GError* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 19 "../src/video-support/VideoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_METADATA, VideoMetadata);
#line 19 "../src/video-support/VideoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 20 "../src/video-support/VideoMetadata.vala"
	_tmp0_ = quick_time_metadata_loader_new (file);
#line 20 "../src/video-support/VideoMetadata.vala"
	quicktime = _tmp0_;
#line 21 "../src/video-support/VideoMetadata.vala"
	_tmp1_ = quicktime;
#line 21 "../src/video-support/VideoMetadata.vala"
	if (quick_time_metadata_loader_is_supported (_tmp1_)) {
#line 131 "VideoMetadata.c"
		QuickTimeMetadataLoader* _tmp2_;
		MetadataDateTime* _tmp3_;
		QuickTimeMetadataLoader* _tmp4_;
		gchar* _tmp5_;
#line 22 "../src/video-support/VideoMetadata.vala"
		_tmp2_ = quicktime;
#line 22 "../src/video-support/VideoMetadata.vala"
		_tmp3_ = quick_time_metadata_loader_get_creation_date_time (_tmp2_);
#line 22 "../src/video-support/VideoMetadata.vala"
		_metadata_date_time_unref0 (self->priv->timestamp);
#line 22 "../src/video-support/VideoMetadata.vala"
		self->priv->timestamp = _tmp3_;
#line 23 "../src/video-support/VideoMetadata.vala"
		_tmp4_ = quicktime;
#line 23 "../src/video-support/VideoMetadata.vala"
		_tmp5_ = quick_time_metadata_loader_get_title (_tmp4_);
#line 23 "../src/video-support/VideoMetadata.vala"
		_g_free0 (self->priv->title);
#line 23 "../src/video-support/VideoMetadata.vala"
		self->priv->title = _tmp5_;
#line 25 "../src/video-support/VideoMetadata.vala"
		_g_free0 (self->priv->comment);
#line 25 "../src/video-support/VideoMetadata.vala"
		self->priv->comment = NULL;
#line 26 "../src/video-support/VideoMetadata.vala"
		_quick_time_metadata_loader_unref0 (quicktime);
#line 26 "../src/video-support/VideoMetadata.vala"
		return;
#line 160 "VideoMetadata.c"
	}
#line 28 "../src/video-support/VideoMetadata.vala"
	_tmp6_ = avi_metadata_loader_new (file);
#line 28 "../src/video-support/VideoMetadata.vala"
	avi = _tmp6_;
#line 29 "../src/video-support/VideoMetadata.vala"
	_tmp7_ = avi;
#line 29 "../src/video-support/VideoMetadata.vala"
	if (avi_metadata_loader_is_supported (_tmp7_)) {
#line 170 "VideoMetadata.c"
		AVIMetadataLoader* _tmp8_;
		MetadataDateTime* _tmp9_;
		AVIMetadataLoader* _tmp10_;
		gchar* _tmp11_;
#line 30 "../src/video-support/VideoMetadata.vala"
		_tmp8_ = avi;
#line 30 "../src/video-support/VideoMetadata.vala"
		_tmp9_ = avi_metadata_loader_get_creation_date_time (_tmp8_);
#line 30 "../src/video-support/VideoMetadata.vala"
		_metadata_date_time_unref0 (self->priv->timestamp);
#line 30 "../src/video-support/VideoMetadata.vala"
		self->priv->timestamp = _tmp9_;
#line 31 "../src/video-support/VideoMetadata.vala"
		_tmp10_ = avi;
#line 31 "../src/video-support/VideoMetadata.vala"
		_tmp11_ = avi_metadata_loader_get_title (_tmp10_);
#line 31 "../src/video-support/VideoMetadata.vala"
		_g_free0 (self->priv->title);
#line 31 "../src/video-support/VideoMetadata.vala"
		self->priv->title = _tmp11_;
#line 32 "../src/video-support/VideoMetadata.vala"
		_g_free0 (self->priv->comment);
#line 32 "../src/video-support/VideoMetadata.vala"
		self->priv->comment = NULL;
#line 33 "../src/video-support/VideoMetadata.vala"
		_avi_metadata_loader_unref0 (avi);
#line 33 "../src/video-support/VideoMetadata.vala"
		_quick_time_metadata_loader_unref0 (quicktime);
#line 33 "../src/video-support/VideoMetadata.vala"
		return;
#line 201 "VideoMetadata.c"
	}
#line 36 "../src/video-support/VideoMetadata.vala"
	_tmp12_ = g_file_get_path (file);
#line 36 "../src/video-support/VideoMetadata.vala"
	_tmp13_ = _tmp12_;
#line 36 "../src/video-support/VideoMetadata.vala"
	_tmp14_ = g_error_new (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "File %s is not a supported video format", _tmp13_);
#line 36 "../src/video-support/VideoMetadata.vala"
	_tmp15_ = _tmp14_;
#line 36 "../src/video-support/VideoMetadata.vala"
	_g_free0 (_tmp13_);
#line 36 "../src/video-support/VideoMetadata.vala"
	_inner_error0_ = _tmp15_;
#line 36 "../src/video-support/VideoMetadata.vala"
	g_propagate_error (error, _inner_error0_);
#line 36 "../src/video-support/VideoMetadata.vala"
	_avi_metadata_loader_unref0 (avi);
#line 36 "../src/video-support/VideoMetadata.vala"
	_quick_time_metadata_loader_unref0 (quicktime);
#line 36 "../src/video-support/VideoMetadata.vala"
	return;
#line 223 "VideoMetadata.c"
}

static gpointer
_metadata_date_time_ref0 (gpointer self)
{
#line 40 "../src/video-support/VideoMetadata.vala"
	return self ? metadata_date_time_ref (self) : NULL;
#line 231 "VideoMetadata.c"
}

static MetadataDateTime*
video_metadata_real_get_creation_date_time (MediaMetadata* base)
{
	VideoMetadata * self;
	MetadataDateTime* _tmp0_;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 39 "../src/video-support/VideoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_METADATA, VideoMetadata);
#line 40 "../src/video-support/VideoMetadata.vala"
	_tmp0_ = self->priv->timestamp;
#line 40 "../src/video-support/VideoMetadata.vala"
	_tmp1_ = _metadata_date_time_ref0 (_tmp0_);
#line 40 "../src/video-support/VideoMetadata.vala"
	result = _tmp1_;
#line 40 "../src/video-support/VideoMetadata.vala"
	return result;
#line 251 "VideoMetadata.c"
}

static gchar*
video_metadata_real_get_title (MediaMetadata* base)
{
	VideoMetadata * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 43 "../src/video-support/VideoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_METADATA, VideoMetadata);
#line 44 "../src/video-support/VideoMetadata.vala"
	_tmp0_ = self->priv->title;
#line 44 "../src/video-support/VideoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 44 "../src/video-support/VideoMetadata.vala"
	result = _tmp1_;
#line 44 "../src/video-support/VideoMetadata.vala"
	return result;
#line 271 "VideoMetadata.c"
}

static gchar*
video_metadata_real_get_comment (MediaMetadata* base)
{
	VideoMetadata * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 47 "../src/video-support/VideoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_METADATA, VideoMetadata);
#line 48 "../src/video-support/VideoMetadata.vala"
	_tmp0_ = self->priv->comment;
#line 48 "../src/video-support/VideoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 48 "../src/video-support/VideoMetadata.vala"
	result = _tmp1_;
#line 48 "../src/video-support/VideoMetadata.vala"
	return result;
#line 291 "VideoMetadata.c"
}

static void
video_metadata_class_init (VideoMetadataClass * klass,
                           gpointer klass_data)
{
#line 7 "../src/video-support/VideoMetadata.vala"
	video_metadata_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/video-support/VideoMetadata.vala"
	((MediaMetadataClass *) klass)->finalize = video_metadata_finalize;
#line 7 "../src/video-support/VideoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &VideoMetadata_private_offset);
#line 7 "../src/video-support/VideoMetadata.vala"
	((MediaMetadataClass *) klass)->read_from_file = (void (*) (MediaMetadata*, GFile*, GError**)) video_metadata_real_read_from_file;
#line 7 "../src/video-support/VideoMetadata.vala"
	((MediaMetadataClass *) klass)->get_creation_date_time = (MetadataDateTime* (*) (MediaMetadata*)) video_metadata_real_get_creation_date_time;
#line 7 "../src/video-support/VideoMetadata.vala"
	((MediaMetadataClass *) klass)->get_title = (gchar* (*) (MediaMetadata*)) video_metadata_real_get_title;
#line 7 "../src/video-support/VideoMetadata.vala"
	((MediaMetadataClass *) klass)->get_comment = (gchar* (*) (MediaMetadata*)) video_metadata_real_get_comment;
#line 312 "VideoMetadata.c"
}

static void
video_metadata_instance_init (VideoMetadata * self,
                              gpointer klass)
{
#line 7 "../src/video-support/VideoMetadata.vala"
	self->priv = video_metadata_get_instance_private (self);
#line 9 "../src/video-support/VideoMetadata.vala"
	self->priv->timestamp = NULL;
#line 10 "../src/video-support/VideoMetadata.vala"
	self->priv->title = NULL;
#line 11 "../src/video-support/VideoMetadata.vala"
	self->priv->comment = NULL;
#line 327 "VideoMetadata.c"
}

static void
video_metadata_finalize (MediaMetadata * obj)
{
	VideoMetadata * self;
#line 7 "../src/video-support/VideoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_METADATA, VideoMetadata);
#line 9 "../src/video-support/VideoMetadata.vala"
	_metadata_date_time_unref0 (self->priv->timestamp);
#line 10 "../src/video-support/VideoMetadata.vala"
	_g_free0 (self->priv->title);
#line 11 "../src/video-support/VideoMetadata.vala"
	_g_free0 (self->priv->comment);
#line 7 "../src/video-support/VideoMetadata.vala"
	MEDIA_METADATA_CLASS (video_metadata_parent_class)->finalize (obj);
#line 344 "VideoMetadata.c"
}

static GType
video_metadata_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VideoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoMetadata), 0, (GInstanceInitFunc) video_metadata_instance_init, NULL };
	GType video_metadata_type_id;
	video_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "VideoMetadata", &g_define_type_info, 0);
	VideoMetadata_private_offset = g_type_add_instance_private (video_metadata_type_id, sizeof (VideoMetadataPrivate));
	return video_metadata_type_id;
}

GType
video_metadata_get_type (void)
{
	static volatile gsize video_metadata_type_id__once = 0;
	if (g_once_init_enter (&video_metadata_type_id__once)) {
		GType video_metadata_type_id;
		video_metadata_type_id = video_metadata_get_type_once ();
		g_once_init_leave (&video_metadata_type_id__once, video_metadata_type_id);
	}
	return video_metadata_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

