/* VideoReader.c generated by valac 0.56.13, the Vala compiler
 * generated from VideoReader.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include "metadata.h"
#include <locale.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#define VIDEO_READER_UNKNOWN_CLIP_DURATION (-1.0)
#define VIDEO_READER_THUMBNAILER_TIMEOUT ((guint) 10000)
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define VIDEO_ID_INVALID ((gint64) -1)
#define EVENT_ID_INVALID ((gint64) -1)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_VIDEO_ERROR (video_error_get_type ())

#define TYPE_VIDEO_READER (video_reader_get_type ())
#define VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_READER, VideoReader))
#define VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_READER, VideoReaderClass))
#define IS_VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_READER))
#define IS_VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_READER))
#define VIDEO_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_READER, VideoReaderClass))

typedef struct _VideoReader VideoReader;
typedef struct _VideoReaderClass VideoReaderClass;
typedef struct _VideoReaderPrivate VideoReaderPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_VIDEO_IMPORT_PARAMS (video_import_params_get_type ())
#define VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParams))
#define VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))
#define IS_VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_IMPORT_PARAMS))
#define IS_VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_IMPORT_PARAMS))
#define VIDEO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))

typedef struct _VideoImportParams VideoImportParams;
typedef struct _VideoImportParamsClass VideoImportParamsClass;
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
typedef struct _VideoImportParamsPrivate VideoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
#define _video_reader_unref0(var) ((var == NULL) ? NULL : (var = (video_reader_unref (var), NULL)))

#define TYPE_VIDEO_METADATA (video_metadata_get_type ())
#define VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_METADATA, VideoMetadata))
#define VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_METADATA, VideoMetadataClass))
#define IS_VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_METADATA))
#define IS_VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_METADATA))
#define VIDEO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_METADATA, VideoMetadataClass))

typedef struct _VideoMetadata VideoMetadata;
typedef struct _VideoMetadataClass VideoMetadataClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
typedef struct _Block17Data Block17Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _ParamSpecVideoReader ParamSpecVideoReader;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	VIDEO_ERROR_FILE,
	VIDEO_ERROR_CONTENTS
} VideoError;
#define VIDEO_ERROR video_error_quark ()

struct _VideoReader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoReaderPrivate * priv;
};

struct _VideoReaderClass {
	GTypeClass parent_class;
	void (*finalize) (VideoReader *self);
};

struct _VideoReaderPrivate {
	gdouble clip_duration;
	GdkPixbuf* preview_frame;
	GFile* file;
	GSubprocess* thumbnailer_process;
	GDateTime* _timestamp;
};

struct _ImportID {
	gint64 id;
};

struct _VideoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoImportParamsPrivate * priv;
	GFile* file;
	ImportID import_id;
	gchar* md5;
	GDateTime* exposure_time_override;
	Thumbnails* thumbnails;
	VideoRow* row;
};

struct _VideoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (VideoImportParams *self);
};

struct _VideoID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	GDateTime* timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	GDateTime* exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	gint64 time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	gint64 time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _Block16Data {
	int _ref_count_;
	VideoReader* self;
	guint id;
};

struct _Block17Data {
	int _ref_count_;
	Block16Data * _data16_;
	GCancellable* cancellable;
};

struct _ParamSpecVideoReader {
	GParamSpec parent_instance;
};

static gint VideoReader_private_offset;
static gpointer video_reader_parent_class = NULL;

VALA_EXTERN GQuark video_error_quark (void);
VALA_EXTERN GType video_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer video_reader_ref (gpointer instance);
VALA_EXTERN void video_reader_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_reader (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_video_reader (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_video_reader (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_video_reader (const GValue* value);
VALA_EXTERN GType video_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoReader, video_reader_unref)
VALA_EXTERN VideoReader* video_reader_new (GFile* file);
VALA_EXTERN VideoReader* video_reader_construct (GType object_type,
                                     GFile* file);
VALA_EXTERN gboolean video_reader_is_supported_video_file (GFile* file);
VALA_EXTERN gboolean video_reader_is_supported_video_filename (const gchar* filename);
VALA_EXTERN void disassemble_filename (const gchar* basename,
                           gchar** name,
                           gchar** ext);
VALA_EXTERN gint utf8_ci_compare (const gchar* a,
                      const gchar* b);
VALA_EXTERN gpointer video_import_params_ref (gpointer instance);
VALA_EXTERN void video_import_params_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_video_import_params (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_video_import_params (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_video_import_params (const GValue* value);
VALA_EXTERN GType video_import_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoImportParams, video_import_params_unref)
VALA_EXTERN GType import_result_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportResult video_reader_prepare_for_import (VideoImportParams* params);
VALA_EXTERN GType import_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportID* import_id_dup (const ImportID* self);
VALA_EXTERN void import_id_free (ImportID* self);
VALA_EXTERN gpointer thumbnails_ref (gpointer instance);
VALA_EXTERN void thumbnails_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_thumbnails (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_thumbnails (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_thumbnails (const GValue* value);
VALA_EXTERN GType thumbnails_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnails, thumbnails_unref)
VALA_EXTERN gpointer video_row_ref (gpointer instance);
VALA_EXTERN void video_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_video_row (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_video_row (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_video_row (const GValue* value);
VALA_EXTERN GType video_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoRow, video_row_unref)
VALA_EXTERN GDateTime* coarsify_date_time (GDateTime* dt);
VALA_EXTERN GdkPixbuf* video_reader_read_preview_frame (VideoReader* self);
VALA_EXTERN gdouble video_reader_read_clip_duration (VideoReader* self,
                                         GError** error);
VALA_EXTERN GType video_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoMetadata, media_metadata_unref)
VALA_EXTERN VideoMetadata* video_reader_read_metadata (VideoReader* self,
                                           GError** error);
VALA_EXTERN GDateTime* video_reader_get_timestamp (VideoReader* self);
VALA_EXTERN GType video_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VideoID* video_id_dup (const VideoID* self);
VALA_EXTERN void video_id_free (VideoID* self);
VALA_EXTERN GType event_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EventID* event_id_dup (const EventID* self);
VALA_EXTERN void event_id_free (EventID* self);
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void video_id_init (VideoID *self,
                    gint64 id);
VALA_EXTERN void event_id_init (EventID *self,
                    gint64 id);
VALA_EXTERN Thumbnails* thumbnails_new (void);
VALA_EXTERN Thumbnails* thumbnails_construct (GType object_type);
VALA_EXTERN void thumbnail_cache_generate_for_video_frame (Thumbnails* thumbnails,
                                               GdkPixbuf* preview_frame);
static void video_reader_read_internal (VideoReader* self,
                                 GError** error);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static gboolean video_reader_does_file_exist (VideoReader* self);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static gboolean ___lambda11_ (Block17Data* _data17_);
static gboolean ____lambda11__gsource_func (gpointer self);
VALA_EXTERN GFile* app_dirs_get_metadata_helper (void);
static void video_reader_set_timestamp (VideoReader* self,
                                 GDateTime* value);
static gboolean video_reader_on_thumbnailer_timer (VideoReader* self);
static GdkPixbuf* video_reader_thumbnailer (VideoReader* self,
                                     const gchar* video_file);
VALA_EXTERN GFile* app_dirs_get_thumbnailer_bin (void);
static gboolean _video_reader_on_thumbnailer_timer_gsource_func (gpointer self);
VALA_EXTERN GdkPixbuf* resources_get_noninterpretable_badge_pixbuf (void);
VALA_EXTERN VideoMetadata* video_metadata_new (void);
VALA_EXTERN VideoMetadata* video_metadata_construct (GType object_type);
static void video_reader_finalize (VideoReader * obj);
static GType video_reader_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar* VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS[4] = {"bdm", "bdmv", "cpi", "mpl"};

GQuark
video_error_quark (void)
{
	return g_quark_from_static_string ("video-error-quark");
}

static GType
video_error_get_type_once (void)
{
	static const GEnumValue values[] = {{VIDEO_ERROR_FILE, "VIDEO_ERROR_FILE", "file"}, {VIDEO_ERROR_CONTENTS, "VIDEO_ERROR_CONTENTS", "contents"}, {0, NULL, NULL}};
	GType video_error_type_id;
	video_error_type_id = g_enum_register_static ("VideoError", values);
	return video_error_type_id;
}

GType
video_error_get_type (void)
{
	static volatile gsize video_error_type_id__once = 0;
	if (g_once_init_enter (&video_error_type_id__once)) {
		GType video_error_type_id;
		video_error_type_id = video_error_get_type_once ();
		g_once_init_leave (&video_error_type_id__once, video_error_type_id);
	}
	return video_error_type_id__once;
}

static inline gpointer
video_reader_get_instance_private (VideoReader* self)
{
	return G_STRUCT_MEMBER_P (self, VideoReader_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/video-support/VideoReader.vala"
	return self ? g_object_ref (self) : NULL;
#line 421 "VideoReader.c"
}

VideoReader*
video_reader_construct (GType object_type,
                        GFile* file)
{
	VideoReader* self = NULL;
	GFile* _tmp0_;
#line 28 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 28 "../src/video-support/VideoReader.vala"
	self = (VideoReader*) g_type_create_instance (object_type);
#line 29 "../src/video-support/VideoReader.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 29 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->file);
#line 29 "../src/video-support/VideoReader.vala"
	self->priv->file = _tmp0_;
#line 28 "../src/video-support/VideoReader.vala"
	return self;
#line 442 "VideoReader.c"
}

VideoReader*
video_reader_new (GFile* file)
{
#line 28 "../src/video-support/VideoReader.vala"
	return video_reader_construct (TYPE_VIDEO_READER, file);
#line 450 "VideoReader.c"
}

gboolean
video_reader_is_supported_video_file (GFile* file)
{
	gchar* mime_type = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 32 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp0_ = g_file_get_basename (file);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_new0 (guchar, 0);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3__length1 = 0;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_content_type_guess (_tmp1_, _tmp3_, (gsize) 0, NULL);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 33 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp1_);
#line 33 "../src/video-support/VideoReader.vala"
	mime_type = _tmp5_;
#line 35 "../src/video-support/VideoReader.vala"
	_tmp7_ = mime_type;
#line 35 "../src/video-support/VideoReader.vala"
	if (g_strcmp0 (_tmp7_, "audio/ogg") == 0) {
#line 35 "../src/video-support/VideoReader.vala"
		_tmp6_ = g_file_has_uri_scheme (file, "file");
#line 499 "VideoReader.c"
	} else {
#line 35 "../src/video-support/VideoReader.vala"
		_tmp6_ = FALSE;
#line 503 "VideoReader.c"
	}
#line 35 "../src/video-support/VideoReader.vala"
	if (_tmp6_) {
#line 507 "VideoReader.c"
		{
			GFileInfo* info = NULL;
			GFileInfo* _tmp8_;
			gchar* content_type = NULL;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
#line 37 "../src/video-support/VideoReader.vala"
			_tmp8_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 37 "../src/video-support/VideoReader.vala"
			info = _tmp8_;
#line 37 "../src/video-support/VideoReader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 523 "VideoReader.c"
				goto __catch0_g_error;
			}
#line 39 "../src/video-support/VideoReader.vala"
			_tmp9_ = info;
#line 39 "../src/video-support/VideoReader.vala"
			_tmp10_ = g_file_info_get_content_type (_tmp9_);
#line 39 "../src/video-support/VideoReader.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 39 "../src/video-support/VideoReader.vala"
			content_type = _tmp11_;
#line 40 "../src/video-support/VideoReader.vala"
			_tmp13_ = content_type;
#line 40 "../src/video-support/VideoReader.vala"
			if (_tmp13_ != NULL) {
#line 538 "VideoReader.c"
				const gchar* _tmp14_;
#line 40 "../src/video-support/VideoReader.vala"
				_tmp14_ = content_type;
#line 40 "../src/video-support/VideoReader.vala"
				_tmp12_ = g_str_has_prefix (_tmp14_, "video/");
#line 544 "VideoReader.c"
			} else {
#line 40 "../src/video-support/VideoReader.vala"
				_tmp12_ = FALSE;
#line 548 "VideoReader.c"
			}
#line 40 "../src/video-support/VideoReader.vala"
			if (_tmp12_) {
#line 41 "../src/video-support/VideoReader.vala"
				result = TRUE;
#line 41 "../src/video-support/VideoReader.vala"
				_g_free0 (content_type);
#line 41 "../src/video-support/VideoReader.vala"
				_g_object_unref0 (info);
#line 41 "../src/video-support/VideoReader.vala"
				_g_free0 (mime_type);
#line 41 "../src/video-support/VideoReader.vala"
				return result;
#line 562 "VideoReader.c"
			}
#line 36 "../src/video-support/VideoReader.vala"
			_g_free0 (content_type);
#line 36 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 568 "VideoReader.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 36 "../src/video-support/VideoReader.vala"
			_error_ = _inner_error0_;
#line 36 "../src/video-support/VideoReader.vala"
			_inner_error0_ = NULL;
#line 44 "../src/video-support/VideoReader.vala"
			_tmp15_ = _error_;
#line 44 "../src/video-support/VideoReader.vala"
			_tmp16_ = _tmp15_->message;
#line 44 "../src/video-support/VideoReader.vala"
			g_debug ("VideoReader.vala:44: Failed to query content type: %s", _tmp16_);
#line 36 "../src/video-support/VideoReader.vala"
			_g_error_free0 (_error_);
#line 588 "VideoReader.c"
		}
		__finally0:
#line 36 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 593 "VideoReader.c"
			gboolean _tmp17_ = FALSE;
#line 36 "../src/video-support/VideoReader.vala"
			_g_free0 (mime_type);
#line 36 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 36 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 36 "../src/video-support/VideoReader.vala"
			return _tmp17_;
#line 603 "VideoReader.c"
		}
	}
#line 48 "../src/video-support/VideoReader.vala"
	_tmp18_ = g_file_get_basename (file);
#line 48 "../src/video-support/VideoReader.vala"
	_tmp19_ = _tmp18_;
#line 48 "../src/video-support/VideoReader.vala"
	_tmp20_ = video_reader_is_supported_video_filename (_tmp19_);
#line 48 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp19_);
#line 48 "../src/video-support/VideoReader.vala"
	result = _tmp20_;
#line 48 "../src/video-support/VideoReader.vala"
	_g_free0 (mime_type);
#line 48 "../src/video-support/VideoReader.vala"
	return result;
#line 620 "VideoReader.c"
}

gboolean
video_reader_is_supported_video_filename (const gchar* filename)
{
	gchar* mime_type = NULL;
	guchar* _tmp0_;
	guchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gboolean result;
#line 51 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 53 "../src/video-support/VideoReader.vala"
	_tmp0_ = g_new0 (guchar, 0);
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1__length1 = 0;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_content_type_guess (filename, _tmp1_, (gsize) 0, NULL);
#line 53 "../src/video-support/VideoReader.vala"
	_g_free0 (mime_type);
#line 53 "../src/video-support/VideoReader.vala"
	mime_type = _tmp2_;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 55 "../src/video-support/VideoReader.vala"
	_tmp5_ = mime_type;
#line 55 "../src/video-support/VideoReader.vala"
	if (g_str_has_prefix (_tmp5_, "video/")) {
#line 55 "../src/video-support/VideoReader.vala"
		_tmp4_ = TRUE;
#line 657 "VideoReader.c"
	} else {
		const gchar* _tmp6_;
#line 56 "../src/video-support/VideoReader.vala"
		_tmp6_ = mime_type;
#line 56 "../src/video-support/VideoReader.vala"
		_tmp4_ = g_str_has_suffix (_tmp6_, "mp4");
#line 664 "VideoReader.c"
	}
#line 55 "../src/video-support/VideoReader.vala"
	if (_tmp4_) {
#line 55 "../src/video-support/VideoReader.vala"
		_tmp3_ = TRUE;
#line 670 "VideoReader.c"
	} else {
		const gchar* _tmp7_;
#line 57 "../src/video-support/VideoReader.vala"
		_tmp7_ = mime_type;
#line 57 "../src/video-support/VideoReader.vala"
		_tmp3_ = g_str_has_suffix (_tmp7_, "mxf");
#line 677 "VideoReader.c"
	}
#line 55 "../src/video-support/VideoReader.vala"
	if (_tmp3_) {
#line 681 "VideoReader.c"
		gchar* extension = NULL;
		gchar* name = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
#line 58 "../src/video-support/VideoReader.vala"
		extension = NULL;
#line 59 "../src/video-support/VideoReader.vala"
		name = NULL;
#line 60 "../src/video-support/VideoReader.vala"
		disassemble_filename (filename, &_tmp8_, &_tmp9_);
#line 60 "../src/video-support/VideoReader.vala"
		_g_free0 (name);
#line 60 "../src/video-support/VideoReader.vala"
		name = _tmp8_;
#line 60 "../src/video-support/VideoReader.vala"
		_g_free0 (extension);
#line 60 "../src/video-support/VideoReader.vala"
		extension = _tmp9_;
#line 62 "../src/video-support/VideoReader.vala"
		_tmp10_ = extension;
#line 62 "../src/video-support/VideoReader.vala"
		if (_tmp10_ == NULL) {
#line 63 "../src/video-support/VideoReader.vala"
			result = TRUE;
#line 63 "../src/video-support/VideoReader.vala"
			_g_free0 (name);
#line 63 "../src/video-support/VideoReader.vala"
			_g_free0 (extension);
#line 63 "../src/video-support/VideoReader.vala"
			_g_free0 (mime_type);
#line 63 "../src/video-support/VideoReader.vala"
			return result;
#line 715 "VideoReader.c"
		}
		{
			const gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 65 "../src/video-support/VideoReader.vala"
			s_collection = VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS;
#line 65 "../src/video-support/VideoReader.vala"
			s_collection_length1 = G_N_ELEMENTS (VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS);
#line 65 "../src/video-support/VideoReader.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 728 "VideoReader.c"
				gchar* _tmp11_;
				gchar* s = NULL;
#line 65 "../src/video-support/VideoReader.vala"
				_tmp11_ = g_strdup (s_collection[s_it]);
#line 65 "../src/video-support/VideoReader.vala"
				s = _tmp11_;
#line 735 "VideoReader.c"
				{
					const gchar* _tmp12_;
					const gchar* _tmp13_;
#line 66 "../src/video-support/VideoReader.vala"
					_tmp12_ = s;
#line 66 "../src/video-support/VideoReader.vala"
					_tmp13_ = extension;
#line 66 "../src/video-support/VideoReader.vala"
					if (utf8_ci_compare (_tmp12_, _tmp13_) == 0) {
#line 67 "../src/video-support/VideoReader.vala"
						result = FALSE;
#line 67 "../src/video-support/VideoReader.vala"
						_g_free0 (s);
#line 67 "../src/video-support/VideoReader.vala"
						_g_free0 (name);
#line 67 "../src/video-support/VideoReader.vala"
						_g_free0 (extension);
#line 67 "../src/video-support/VideoReader.vala"
						_g_free0 (mime_type);
#line 67 "../src/video-support/VideoReader.vala"
						return result;
#line 757 "VideoReader.c"
					}
#line 65 "../src/video-support/VideoReader.vala"
					_g_free0 (s);
#line 761 "VideoReader.c"
				}
			}
		}
#line 70 "../src/video-support/VideoReader.vala"
		result = TRUE;
#line 70 "../src/video-support/VideoReader.vala"
		_g_free0 (name);
#line 70 "../src/video-support/VideoReader.vala"
		_g_free0 (extension);
#line 70 "../src/video-support/VideoReader.vala"
		_g_free0 (mime_type);
#line 70 "../src/video-support/VideoReader.vala"
		return result;
#line 775 "VideoReader.c"
	} else {
		const gchar* _tmp14_;
#line 72 "../src/video-support/VideoReader.vala"
		_tmp14_ = mime_type;
#line 72 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:72: Skipping %s, unsupported mime type %s", filename, _tmp14_);
#line 73 "../src/video-support/VideoReader.vala"
		result = FALSE;
#line 73 "../src/video-support/VideoReader.vala"
		_g_free0 (mime_type);
#line 73 "../src/video-support/VideoReader.vala"
		return result;
#line 788 "VideoReader.c"
	}
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 106 "../src/video-support/VideoReader.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 797 "VideoReader.c"
}

ImportResult
video_reader_prepare_for_import (VideoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GDateTime* timestamp = NULL;
	GFileInfo* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	const gchar* _tmp16_;
	GDateTime* exposure_time = NULL;
	GDateTime* _tmp17_;
	GDateTime* _tmp18_;
	gchar* title = NULL;
	gchar* _tmp19_;
	gchar* comment = NULL;
	gchar* _tmp20_;
	VideoReader* reader = NULL;
	GFile* _tmp21_;
	VideoReader* _tmp22_;
	gboolean is_interpretable = FALSE;
	gdouble clip_duration = 0.0;
	GdkPixbuf* preview_frame = NULL;
	VideoReader* _tmp23_;
	GdkPixbuf* _tmp24_;
	GDateTime* _tmp52_;
	VideoRow* _tmp56_;
	VideoRow* _tmp57_;
	GFile* _tmp58_;
	gchar* _tmp59_;
	VideoRow* _tmp60_;
	GFileInfo* _tmp61_;
	VideoRow* _tmp62_;
	GDateTime* _tmp63_;
	GDateTime* _tmp64_;
	VideoRow* _tmp65_;
	GdkPixbuf* _tmp66_;
	gint _tmp67_;
	gint _tmp68_;
	VideoRow* _tmp69_;
	GdkPixbuf* _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	VideoRow* _tmp73_;
	VideoRow* _tmp74_;
	VideoRow* _tmp75_;
	GDateTime* _tmp76_;
	GDateTime* _tmp77_;
	VideoRow* _tmp78_;
	ImportID _tmp79_;
	VideoRow* _tmp80_;
	VideoRow* _tmp81_;
	const gchar* _tmp82_;
	gchar* _tmp83_;
	VideoRow* _tmp84_;
	VideoRow* _tmp85_;
	const gchar* _tmp86_;
	gchar* _tmp87_;
	VideoRow* _tmp88_;
	const gchar* _tmp89_;
	gchar* _tmp90_;
	VideoRow* _tmp91_;
	gchar* _tmp92_;
	VideoRow* _tmp93_;
	VideoRow* _tmp94_;
	Thumbnails* _tmp95_;
	GError* _inner_error0_ = NULL;
	ImportResult result;
#line 77 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_IMPORT_PARAMS (params), 0);
#line 81 "../src/video-support/VideoReader.vala"
	_tmp0_ = params->file;
#line 81 "../src/video-support/VideoReader.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 81 "../src/video-support/VideoReader.vala"
	file = _tmp1_;
#line 83 "../src/video-support/VideoReader.vala"
	info = NULL;
#line 884 "VideoReader.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 85 "../src/video-support/VideoReader.vala"
		_tmp3_ = file;
#line 85 "../src/video-support/VideoReader.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 85 "../src/video-support/VideoReader.vala"
		_tmp2_ = _tmp4_;
#line 85 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 898 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 85 "../src/video-support/VideoReader.vala"
		_tmp5_ = _tmp2_;
#line 85 "../src/video-support/VideoReader.vala"
		_tmp2_ = NULL;
#line 85 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 85 "../src/video-support/VideoReader.vala"
		info = _tmp5_;
#line 84 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp2_);
#line 911 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 84 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 88 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 88 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 88 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 88 "../src/video-support/VideoReader.vala"
		return result;
#line 926 "VideoReader.c"
	}
	__finally0:
#line 84 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 84 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 84 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 84 "../src/video-support/VideoReader.vala"
		return 0;
#line 941 "VideoReader.c"
	}
#line 91 "../src/video-support/VideoReader.vala"
	_tmp6_ = info;
#line 91 "../src/video-support/VideoReader.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 92 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 92 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 92 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 92 "../src/video-support/VideoReader.vala"
		return result;
#line 955 "VideoReader.c"
	}
#line 94 "../src/video-support/VideoReader.vala"
	_tmp7_ = file;
#line 94 "../src/video-support/VideoReader.vala"
	if (!video_reader_is_supported_video_file (_tmp7_)) {
#line 961 "VideoReader.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 95 "../src/video-support/VideoReader.vala"
		_tmp8_ = file;
#line 95 "../src/video-support/VideoReader.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 95 "../src/video-support/VideoReader.vala"
		_tmp10_ = _tmp9_;
#line 95 "../src/video-support/VideoReader.vala"
		g_message ("Not importing %s: file is marked as a video file but doesn't have a" "supported extension", _tmp10_);
#line 95 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp10_);
#line 98 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 98 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 98 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 98 "../src/video-support/VideoReader.vala"
		return result;
#line 983 "VideoReader.c"
	}
#line 101 "../src/video-support/VideoReader.vala"
	_tmp11_ = info;
#line 101 "../src/video-support/VideoReader.vala"
	_tmp12_ = g_file_info_get_modification_date_time (_tmp11_);
#line 101 "../src/video-support/VideoReader.vala"
	_tmp13_ = _tmp12_;
#line 101 "../src/video-support/VideoReader.vala"
	_tmp14_ = coarsify_date_time (_tmp13_);
#line 101 "../src/video-support/VideoReader.vala"
	_tmp15_ = _tmp14_;
#line 101 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (_tmp13_);
#line 101 "../src/video-support/VideoReader.vala"
	timestamp = _tmp15_;
#line 104 "../src/video-support/VideoReader.vala"
	_tmp16_ = params->md5;
#line 104 "../src/video-support/VideoReader.vala"
	_vala_assert (_tmp16_ != NULL, "params.md5 != null");
#line 106 "../src/video-support/VideoReader.vala"
	_tmp17_ = params->exposure_time_override;
#line 106 "../src/video-support/VideoReader.vala"
	_tmp18_ = _g_date_time_ref0 (_tmp17_);
#line 106 "../src/video-support/VideoReader.vala"
	exposure_time = _tmp18_;
#line 107 "../src/video-support/VideoReader.vala"
	_tmp19_ = g_strdup ("");
#line 107 "../src/video-support/VideoReader.vala"
	title = _tmp19_;
#line 108 "../src/video-support/VideoReader.vala"
	_tmp20_ = g_strdup ("");
#line 108 "../src/video-support/VideoReader.vala"
	comment = _tmp20_;
#line 110 "../src/video-support/VideoReader.vala"
	_tmp21_ = file;
#line 110 "../src/video-support/VideoReader.vala"
	_tmp22_ = video_reader_new (_tmp21_);
#line 110 "../src/video-support/VideoReader.vala"
	reader = _tmp22_;
#line 111 "../src/video-support/VideoReader.vala"
	is_interpretable = TRUE;
#line 112 "../src/video-support/VideoReader.vala"
	clip_duration = 0.0;
#line 113 "../src/video-support/VideoReader.vala"
	_tmp23_ = reader;
#line 113 "../src/video-support/VideoReader.vala"
	_tmp24_ = video_reader_read_preview_frame (_tmp23_);
#line 113 "../src/video-support/VideoReader.vala"
	preview_frame = _tmp24_;
#line 1033 "VideoReader.c"
	{
		gdouble _tmp25_ = 0.0;
		VideoReader* _tmp26_;
#line 115 "../src/video-support/VideoReader.vala"
		_tmp26_ = reader;
#line 115 "../src/video-support/VideoReader.vala"
		_tmp25_ = video_reader_read_clip_duration (_tmp26_, &_inner_error0_);
#line 115 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../src/video-support/VideoReader.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 1045 "VideoReader.c"
				goto __catch1_video_error;
			}
#line 115 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (preview_frame);
#line 115 "../src/video-support/VideoReader.vala"
			_video_reader_unref0 (reader);
#line 115 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 115 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 115 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (exposure_time);
#line 115 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (timestamp);
#line 115 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 115 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (file);
#line 115 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 115 "../src/video-support/VideoReader.vala"
			return 0;
#line 1070 "VideoReader.c"
		}
#line 115 "../src/video-support/VideoReader.vala"
		clip_duration = _tmp25_;
#line 1074 "VideoReader.c"
	}
	goto __finally1;
	__catch1_video_error:
	{
		GError* err = NULL;
		GError* _tmp27_;
#line 114 "../src/video-support/VideoReader.vala"
		err = _inner_error0_;
#line 114 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 117 "../src/video-support/VideoReader.vala"
		_tmp27_ = err;
#line 117 "../src/video-support/VideoReader.vala"
		if (g_error_matches (_tmp27_, VIDEO_ERROR, VIDEO_ERROR_FILE)) {
#line 118 "../src/video-support/VideoReader.vala"
			result = IMPORT_RESULT_FILE_ERROR;
#line 118 "../src/video-support/VideoReader.vala"
			_g_error_free0 (err);
#line 118 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (preview_frame);
#line 118 "../src/video-support/VideoReader.vala"
			_video_reader_unref0 (reader);
#line 118 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 118 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 118 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (exposure_time);
#line 118 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (timestamp);
#line 118 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 118 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (file);
#line 118 "../src/video-support/VideoReader.vala"
			return result;
#line 1111 "VideoReader.c"
		} else {
			GError* _tmp28_;
#line 119 "../src/video-support/VideoReader.vala"
			_tmp28_ = err;
#line 119 "../src/video-support/VideoReader.vala"
			if (g_error_matches (_tmp28_, VIDEO_ERROR, VIDEO_ERROR_CONTENTS)) {
#line 120 "../src/video-support/VideoReader.vala"
				is_interpretable = FALSE;
#line 121 "../src/video-support/VideoReader.vala"
				clip_duration = 0.0;
#line 1122 "VideoReader.c"
			} else {
#line 123 "../src/video-support/VideoReader.vala"
				g_error ("VideoReader.vala:123: can't prepare video for import: an unknown kind " \
"of video error occurred");
#line 1126 "VideoReader.c"
			}
		}
#line 114 "../src/video-support/VideoReader.vala"
		_g_error_free0 (err);
#line 1131 "VideoReader.c"
	}
	__finally1:
#line 114 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (preview_frame);
#line 114 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (reader);
#line 114 "../src/video-support/VideoReader.vala"
		_g_free0 (comment);
#line 114 "../src/video-support/VideoReader.vala"
		_g_free0 (title);
#line 114 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (exposure_time);
#line 114 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (timestamp);
#line 114 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 114 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 114 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 114 "../src/video-support/VideoReader.vala"
		return 0;
#line 1158 "VideoReader.c"
	}
	{
		VideoMetadata* metadata = NULL;
		VideoReader* _tmp29_;
		VideoMetadata* _tmp30_;
		MetadataDateTime* creation_date_time = NULL;
		VideoMetadata* _tmp31_;
		MetadataDateTime* _tmp32_;
		gboolean _tmp33_ = FALSE;
		MetadataDateTime* _tmp34_;
		gchar* video_title = NULL;
		VideoMetadata* _tmp40_;
		gchar* _tmp41_;
		gchar* video_comment = NULL;
		VideoMetadata* _tmp42_;
		gchar* _tmp43_;
		const gchar* _tmp44_;
		const gchar* _tmp47_;
#line 128 "../src/video-support/VideoReader.vala"
		_tmp29_ = reader;
#line 128 "../src/video-support/VideoReader.vala"
		_tmp30_ = video_reader_read_metadata (_tmp29_, &_inner_error0_);
#line 128 "../src/video-support/VideoReader.vala"
		metadata = _tmp30_;
#line 128 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1185 "VideoReader.c"
			goto __catch2_g_error;
		}
#line 129 "../src/video-support/VideoReader.vala"
		_tmp31_ = metadata;
#line 129 "../src/video-support/VideoReader.vala"
		_tmp32_ = media_metadata_get_creation_date_time (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 129 "../src/video-support/VideoReader.vala"
		creation_date_time = _tmp32_;
#line 131 "../src/video-support/VideoReader.vala"
		_tmp34_ = creation_date_time;
#line 131 "../src/video-support/VideoReader.vala"
		if (_tmp34_ != NULL) {
#line 1198 "VideoReader.c"
			MetadataDateTime* _tmp35_;
			GDateTime* _tmp36_;
			GDateTime* _tmp37_;
#line 131 "../src/video-support/VideoReader.vala"
			_tmp35_ = creation_date_time;
#line 131 "../src/video-support/VideoReader.vala"
			_tmp36_ = metadata_date_time_get_timestamp (_tmp35_);
#line 131 "../src/video-support/VideoReader.vala"
			_tmp37_ = _tmp36_;
#line 131 "../src/video-support/VideoReader.vala"
			_tmp33_ = _tmp37_ != NULL;
#line 131 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (_tmp37_);
#line 1212 "VideoReader.c"
		} else {
#line 131 "../src/video-support/VideoReader.vala"
			_tmp33_ = FALSE;
#line 1216 "VideoReader.c"
		}
#line 131 "../src/video-support/VideoReader.vala"
		if (_tmp33_) {
#line 1220 "VideoReader.c"
			MetadataDateTime* _tmp38_;
			GDateTime* _tmp39_;
#line 132 "../src/video-support/VideoReader.vala"
			_tmp38_ = creation_date_time;
#line 132 "../src/video-support/VideoReader.vala"
			_tmp39_ = metadata_date_time_get_timestamp (_tmp38_);
#line 132 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (exposure_time);
#line 132 "../src/video-support/VideoReader.vala"
			exposure_time = _tmp39_;
#line 1231 "VideoReader.c"
		}
#line 134 "../src/video-support/VideoReader.vala"
		_tmp40_ = metadata;
#line 134 "../src/video-support/VideoReader.vala"
		_tmp41_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 134 "../src/video-support/VideoReader.vala"
		video_title = _tmp41_;
#line 135 "../src/video-support/VideoReader.vala"
		_tmp42_ = metadata;
#line 135 "../src/video-support/VideoReader.vala"
		_tmp43_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 135 "../src/video-support/VideoReader.vala"
		video_comment = _tmp43_;
#line 136 "../src/video-support/VideoReader.vala"
		_tmp44_ = video_title;
#line 136 "../src/video-support/VideoReader.vala"
		if (_tmp44_ != NULL) {
#line 1249 "VideoReader.c"
			const gchar* _tmp45_;
			gchar* _tmp46_;
#line 137 "../src/video-support/VideoReader.vala"
			_tmp45_ = video_title;
#line 137 "../src/video-support/VideoReader.vala"
			_tmp46_ = g_strdup (_tmp45_);
#line 137 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 137 "../src/video-support/VideoReader.vala"
			title = _tmp46_;
#line 1260 "VideoReader.c"
		}
#line 138 "../src/video-support/VideoReader.vala"
		_tmp47_ = video_comment;
#line 138 "../src/video-support/VideoReader.vala"
		if (_tmp47_ != NULL) {
#line 1266 "VideoReader.c"
			const gchar* _tmp48_;
			gchar* _tmp49_;
#line 139 "../src/video-support/VideoReader.vala"
			_tmp48_ = video_comment;
#line 139 "../src/video-support/VideoReader.vala"
			_tmp49_ = g_strdup (_tmp48_);
#line 139 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 139 "../src/video-support/VideoReader.vala"
			comment = _tmp49_;
#line 1277 "VideoReader.c"
		}
#line 127 "../src/video-support/VideoReader.vala"
		_g_free0 (video_comment);
#line 127 "../src/video-support/VideoReader.vala"
		_g_free0 (video_title);
#line 127 "../src/video-support/VideoReader.vala"
		_metadata_date_time_unref0 (creation_date_time);
#line 127 "../src/video-support/VideoReader.vala"
		_media_metadata_unref0 (metadata);
#line 1287 "VideoReader.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		GError* _tmp50_;
		const gchar* _tmp51_;
#line 127 "../src/video-support/VideoReader.vala"
		err = _inner_error0_;
#line 127 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 141 "../src/video-support/VideoReader.vala"
		_tmp50_ = err;
#line 141 "../src/video-support/VideoReader.vala"
		_tmp51_ = _tmp50_->message;
#line 141 "../src/video-support/VideoReader.vala"
		g_warning ("VideoReader.vala:141: Unable to read video metadata: %s", _tmp51_);
#line 127 "../src/video-support/VideoReader.vala"
		_g_error_free0 (err);
#line 1307 "VideoReader.c"
	}
	__finally2:
#line 127 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 127 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (preview_frame);
#line 127 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (reader);
#line 127 "../src/video-support/VideoReader.vala"
		_g_free0 (comment);
#line 127 "../src/video-support/VideoReader.vala"
		_g_free0 (title);
#line 127 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (exposure_time);
#line 127 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (timestamp);
#line 127 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 127 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 127 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 127 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 127 "../src/video-support/VideoReader.vala"
		return 0;
#line 1334 "VideoReader.c"
	}
#line 144 "../src/video-support/VideoReader.vala"
	_tmp52_ = exposure_time;
#line 144 "../src/video-support/VideoReader.vala"
	if (_tmp52_ == NULL) {
#line 1340 "VideoReader.c"
		VideoReader* _tmp53_;
		GDateTime* _tmp54_;
		GDateTime* _tmp55_;
#line 146 "../src/video-support/VideoReader.vala"
		_tmp53_ = reader;
#line 146 "../src/video-support/VideoReader.vala"
		_tmp54_ = _tmp53_->priv->_timestamp;
#line 146 "../src/video-support/VideoReader.vala"
		_tmp55_ = _g_date_time_ref0 (_tmp54_);
#line 146 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (exposure_time);
#line 146 "../src/video-support/VideoReader.vala"
		exposure_time = _tmp55_;
#line 1354 "VideoReader.c"
	}
#line 149 "../src/video-support/VideoReader.vala"
	_tmp56_ = params->row;
#line 149 "../src/video-support/VideoReader.vala"
	video_id_init (&_tmp56_->video_id, VIDEO_ID_INVALID);
#line 150 "../src/video-support/VideoReader.vala"
	_tmp57_ = params->row;
#line 150 "../src/video-support/VideoReader.vala"
	_tmp58_ = file;
#line 150 "../src/video-support/VideoReader.vala"
	_tmp59_ = g_file_get_path (_tmp58_);
#line 150 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp57_->filepath);
#line 150 "../src/video-support/VideoReader.vala"
	_tmp57_->filepath = _tmp59_;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp60_ = params->row;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp61_ = info;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp60_->filesize = g_file_info_get_size (_tmp61_);
#line 152 "../src/video-support/VideoReader.vala"
	_tmp62_ = params->row;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp63_ = timestamp;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp64_ = _g_date_time_ref0 (_tmp63_);
#line 152 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (_tmp62_->timestamp);
#line 152 "../src/video-support/VideoReader.vala"
	_tmp62_->timestamp = _tmp64_;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp65_ = params->row;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp66_ = preview_frame;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp67_ = gdk_pixbuf_get_width (_tmp66_);
#line 153 "../src/video-support/VideoReader.vala"
	_tmp68_ = _tmp67_;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp65_->width = _tmp68_;
#line 154 "../src/video-support/VideoReader.vala"
	_tmp69_ = params->row;
#line 154 "../src/video-support/VideoReader.vala"
	_tmp70_ = preview_frame;
#line 154 "../src/video-support/VideoReader.vala"
	_tmp71_ = gdk_pixbuf_get_height (_tmp70_);
#line 154 "../src/video-support/VideoReader.vala"
	_tmp72_ = _tmp71_;
#line 154 "../src/video-support/VideoReader.vala"
	_tmp69_->height = _tmp72_;
#line 155 "../src/video-support/VideoReader.vala"
	_tmp73_ = params->row;
#line 155 "../src/video-support/VideoReader.vala"
	_tmp73_->clip_duration = clip_duration;
#line 156 "../src/video-support/VideoReader.vala"
	_tmp74_ = params->row;
#line 156 "../src/video-support/VideoReader.vala"
	_tmp74_->is_interpretable = is_interpretable;
#line 157 "../src/video-support/VideoReader.vala"
	_tmp75_ = params->row;
#line 157 "../src/video-support/VideoReader.vala"
	_tmp76_ = exposure_time;
#line 157 "../src/video-support/VideoReader.vala"
	_tmp77_ = _g_date_time_ref0 (_tmp76_);
#line 157 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (_tmp75_->exposure_time);
#line 157 "../src/video-support/VideoReader.vala"
	_tmp75_->exposure_time = _tmp77_;
#line 158 "../src/video-support/VideoReader.vala"
	_tmp78_ = params->row;
#line 158 "../src/video-support/VideoReader.vala"
	_tmp79_ = params->import_id;
#line 158 "../src/video-support/VideoReader.vala"
	_tmp78_->import_id = _tmp79_;
#line 159 "../src/video-support/VideoReader.vala"
	_tmp80_ = params->row;
#line 159 "../src/video-support/VideoReader.vala"
	event_id_init (&_tmp80_->event_id, EVENT_ID_INVALID);
#line 160 "../src/video-support/VideoReader.vala"
	_tmp81_ = params->row;
#line 160 "../src/video-support/VideoReader.vala"
	_tmp82_ = params->md5;
#line 160 "../src/video-support/VideoReader.vala"
	_tmp83_ = g_strdup (_tmp82_);
#line 160 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp81_->md5);
#line 160 "../src/video-support/VideoReader.vala"
	_tmp81_->md5 = _tmp83_;
#line 161 "../src/video-support/VideoReader.vala"
	_tmp84_ = params->row;
#line 161 "../src/video-support/VideoReader.vala"
	_tmp84_->time_created = (gint64) 0;
#line 162 "../src/video-support/VideoReader.vala"
	_tmp85_ = params->row;
#line 162 "../src/video-support/VideoReader.vala"
	_tmp86_ = title;
#line 162 "../src/video-support/VideoReader.vala"
	_tmp87_ = g_strdup (_tmp86_);
#line 162 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp85_->title);
#line 162 "../src/video-support/VideoReader.vala"
	_tmp85_->title = _tmp87_;
#line 163 "../src/video-support/VideoReader.vala"
	_tmp88_ = params->row;
#line 163 "../src/video-support/VideoReader.vala"
	_tmp89_ = comment;
#line 163 "../src/video-support/VideoReader.vala"
	_tmp90_ = g_strdup (_tmp89_);
#line 163 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp88_->comment);
#line 163 "../src/video-support/VideoReader.vala"
	_tmp88_->comment = _tmp90_;
#line 164 "../src/video-support/VideoReader.vala"
	_tmp91_ = params->row;
#line 164 "../src/video-support/VideoReader.vala"
	_tmp92_ = g_strdup ("");
#line 164 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp91_->backlinks);
#line 164 "../src/video-support/VideoReader.vala"
	_tmp91_->backlinks = _tmp92_;
#line 165 "../src/video-support/VideoReader.vala"
	_tmp93_ = params->row;
#line 165 "../src/video-support/VideoReader.vala"
	_tmp93_->time_reimported = (gint64) 0;
#line 166 "../src/video-support/VideoReader.vala"
	_tmp94_ = params->row;
#line 166 "../src/video-support/VideoReader.vala"
	_tmp94_->flags = (guint64) 0;
#line 168 "../src/video-support/VideoReader.vala"
	_tmp95_ = params->thumbnails;
#line 168 "../src/video-support/VideoReader.vala"
	if (_tmp95_ != NULL) {
#line 1488 "VideoReader.c"
		Thumbnails* _tmp96_;
		Thumbnails* _tmp97_;
		GdkPixbuf* _tmp98_;
#line 169 "../src/video-support/VideoReader.vala"
		_tmp96_ = thumbnails_new ();
#line 169 "../src/video-support/VideoReader.vala"
		_thumbnails_unref0 (params->thumbnails);
#line 169 "../src/video-support/VideoReader.vala"
		params->thumbnails = _tmp96_;
#line 170 "../src/video-support/VideoReader.vala"
		_tmp97_ = params->thumbnails;
#line 170 "../src/video-support/VideoReader.vala"
		_tmp98_ = preview_frame;
#line 170 "../src/video-support/VideoReader.vala"
		thumbnail_cache_generate_for_video_frame (_tmp97_, _tmp98_);
#line 1504 "VideoReader.c"
	}
#line 176 "../src/video-support/VideoReader.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 176 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (preview_frame);
#line 176 "../src/video-support/VideoReader.vala"
	_video_reader_unref0 (reader);
#line 176 "../src/video-support/VideoReader.vala"
	_g_free0 (comment);
#line 176 "../src/video-support/VideoReader.vala"
	_g_free0 (title);
#line 176 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (exposure_time);
#line 176 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (timestamp);
#line 176 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (info);
#line 176 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (file);
#line 176 "../src/video-support/VideoReader.vala"
	return result;
#line 1526 "VideoReader.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 179 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 179 "../src/video-support/VideoReader.vala"
	return _data16_;
#line 1536 "VideoReader.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 179 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 1546 "VideoReader.c"
		VideoReader* self;
#line 179 "../src/video-support/VideoReader.vala"
		self = _data16_->self;
#line 179 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (self);
#line 179 "../src/video-support/VideoReader.vala"
		g_slice_free (Block16Data, _data16_);
#line 1554 "VideoReader.c"
	}
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 185 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 185 "../src/video-support/VideoReader.vala"
	return _data17_;
#line 1565 "VideoReader.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 185 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 1575 "VideoReader.c"
		VideoReader* self;
#line 185 "../src/video-support/VideoReader.vala"
		self = _data17_->_data16_->self;
#line 185 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_data17_->cancellable);
#line 185 "../src/video-support/VideoReader.vala"
		block16_data_unref (_data17_->_data16_);
#line 185 "../src/video-support/VideoReader.vala"
		_data17_->_data16_ = NULL;
#line 185 "../src/video-support/VideoReader.vala"
		g_slice_free (Block17Data, _data17_);
#line 1587 "VideoReader.c"
	}
}

static gboolean
___lambda11_ (Block17Data* _data17_)
{
	Block16Data* _data16_;
	VideoReader* self;
	GCancellable* _tmp0_;
	gboolean result;
#line 188 "../src/video-support/VideoReader.vala"
	_data16_ = _data17_->_data16_;
#line 188 "../src/video-support/VideoReader.vala"
	self = _data16_->self;
#line 189 "../src/video-support/VideoReader.vala"
	_tmp0_ = _data17_->cancellable;
#line 189 "../src/video-support/VideoReader.vala"
	g_cancellable_cancel (_tmp0_);
#line 190 "../src/video-support/VideoReader.vala"
	_data16_->id = (guint) 0;
#line 192 "../src/video-support/VideoReader.vala"
	result = FALSE;
#line 192 "../src/video-support/VideoReader.vala"
	return result;
#line 1612 "VideoReader.c"
}

static gboolean
____lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda11_ (self);
#line 188 "../src/video-support/VideoReader.vala"
	return result;
#line 1622 "VideoReader.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 1635 "VideoReader.c"
}

static void
video_reader_read_internal (VideoReader* self,
                            GError** error)
{
	Block16Data* _data16_;
	GError* _inner_error0_ = NULL;
#line 179 "../src/video-support/VideoReader.vala"
	g_return_if_fail (IS_VIDEO_READER (self));
#line 179 "../src/video-support/VideoReader.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 179 "../src/video-support/VideoReader.vala"
	_data16_->_ref_count_ = 1;
#line 179 "../src/video-support/VideoReader.vala"
	_data16_->self = video_reader_ref (self);
#line 180 "../src/video-support/VideoReader.vala"
	if (!video_reader_does_file_exist (self)) {
#line 1654 "VideoReader.c"
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 181 "../src/video-support/VideoReader.vala"
		_tmp0_ = self->priv->file;
#line 181 "../src/video-support/VideoReader.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 181 "../src/video-support/VideoReader.vala"
		_tmp2_ = _tmp1_;
#line 181 "../src/video-support/VideoReader.vala"
		_tmp3_ = g_strdup_printf ("video file '%s' does not exist or is inaccessible", _tmp2_);
#line 181 "../src/video-support/VideoReader.vala"
		_tmp4_ = _tmp3_;
#line 181 "../src/video-support/VideoReader.vala"
		_tmp5_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_FILE, _tmp4_);
#line 181 "../src/video-support/VideoReader.vala"
		_tmp6_ = _tmp5_;
#line 181 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp4_);
#line 181 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp2_);
#line 181 "../src/video-support/VideoReader.vala"
		_inner_error0_ = _tmp6_;
#line 181 "../src/video-support/VideoReader.vala"
		if (_inner_error0_->domain == VIDEO_ERROR) {
#line 181 "../src/video-support/VideoReader.vala"
			g_propagate_error (error, _inner_error0_);
#line 181 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 181 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 181 "../src/video-support/VideoReader.vala"
			return;
#line 1692 "VideoReader.c"
		} else {
#line 181 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 181 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 181 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 181 "../src/video-support/VideoReader.vala"
			return;
#line 1704 "VideoReader.c"
		}
	}
#line 184 "../src/video-support/VideoReader.vala"
	_data16_->id = (guint) 0;
#line 1709 "VideoReader.c"
	{
		Block17Data* _data17_;
		GCancellable* _tmp7_;
		GBytes* stdout_buf = NULL;
		GBytes* stderr_buf = NULL;
		GSubprocess* process = NULL;
		GFile* _tmp8_;
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GSubprocess* _tmp15_;
		GSubprocess* _tmp16_;
		gboolean _result_ = FALSE;
		GSubprocess* _tmp17_;
		GCancellable* _tmp18_;
		GBytes* _tmp19_ = NULL;
		GBytes* _tmp20_ = NULL;
		gboolean _tmp21_;
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_ = FALSE;
#line 185 "../src/video-support/VideoReader.vala"
		_data17_ = g_slice_new0 (Block17Data);
#line 185 "../src/video-support/VideoReader.vala"
		_data17_->_ref_count_ = 1;
#line 185 "../src/video-support/VideoReader.vala"
		_data17_->_data16_ = block16_data_ref (_data16_);
#line 186 "../src/video-support/VideoReader.vala"
		_tmp7_ = g_cancellable_new ();
#line 186 "../src/video-support/VideoReader.vala"
		_data17_->cancellable = _tmp7_;
#line 188 "../src/video-support/VideoReader.vala"
		_data16_->id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 10, ____lambda11__gsource_func, block17_data_ref (_data17_), block17_data_unref);
#line 195 "../src/video-support/VideoReader.vala"
		stdout_buf = NULL;
#line 196 "../src/video-support/VideoReader.vala"
		stderr_buf = NULL;
#line 198 "../src/video-support/VideoReader.vala"
		_tmp8_ = app_dirs_get_metadata_helper ();
#line 198 "../src/video-support/VideoReader.vala"
		_tmp9_ = _tmp8_;
#line 198 "../src/video-support/VideoReader.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 198 "../src/video-support/VideoReader.vala"
		_tmp11_ = _tmp10_;
#line 198 "../src/video-support/VideoReader.vala"
		_tmp12_ = self->priv->file;
#line 198 "../src/video-support/VideoReader.vala"
		_tmp13_ = g_file_get_uri (_tmp12_);
#line 198 "../src/video-support/VideoReader.vala"
		_tmp14_ = _tmp13_;
#line 198 "../src/video-support/VideoReader.vala"
		_tmp15_ = g_subprocess_new (G_SUBPROCESS_FLAGS_STDOUT_PIPE, &_inner_error0_, _tmp11_, _tmp14_, NULL);
#line 198 "../src/video-support/VideoReader.vala"
		_tmp16_ = _tmp15_;
#line 198 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp14_);
#line 198 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp11_);
#line 198 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp9_);
#line 198 "../src/video-support/VideoReader.vala"
		process = _tmp16_;
#line 198 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stderr_buf);
#line 198 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stdout_buf);
#line 198 "../src/video-support/VideoReader.vala"
			block17_data_unref (_data17_);
#line 198 "../src/video-support/VideoReader.vala"
			_data17_ = NULL;
#line 1787 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 199 "../src/video-support/VideoReader.vala"
		_tmp17_ = process;
#line 199 "../src/video-support/VideoReader.vala"
		_tmp18_ = _data17_->cancellable;
#line 199 "../src/video-support/VideoReader.vala"
		_tmp21_ = g_subprocess_communicate (_tmp17_, NULL, _tmp18_, &_tmp19_, &_tmp20_, &_inner_error0_);
#line 199 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stdout_buf);
#line 199 "../src/video-support/VideoReader.vala"
		stdout_buf = _tmp19_;
#line 199 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stderr_buf);
#line 199 "../src/video-support/VideoReader.vala"
		stderr_buf = _tmp20_;
#line 199 "../src/video-support/VideoReader.vala"
		_result_ = _tmp21_;
#line 199 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (process);
#line 199 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stderr_buf);
#line 199 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stdout_buf);
#line 199 "../src/video-support/VideoReader.vala"
			block17_data_unref (_data17_);
#line 199 "../src/video-support/VideoReader.vala"
			_data17_ = NULL;
#line 1818 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 200 "../src/video-support/VideoReader.vala"
		if (_result_) {
#line 1823 "VideoReader.c"
			GSubprocess* _tmp26_;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp26_ = process;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp25_ = g_subprocess_get_if_exited (_tmp26_);
#line 1829 "VideoReader.c"
		} else {
#line 200 "../src/video-support/VideoReader.vala"
			_tmp25_ = FALSE;
#line 1833 "VideoReader.c"
		}
#line 200 "../src/video-support/VideoReader.vala"
		if (_tmp25_) {
#line 1837 "VideoReader.c"
			GSubprocess* _tmp27_;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp27_ = process;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp24_ = g_subprocess_get_exit_status (_tmp27_) == 0;
#line 1843 "VideoReader.c"
		} else {
#line 200 "../src/video-support/VideoReader.vala"
			_tmp24_ = FALSE;
#line 1847 "VideoReader.c"
		}
#line 200 "../src/video-support/VideoReader.vala"
		if (_tmp24_) {
#line 1851 "VideoReader.c"
			GBytes* _tmp28_;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp28_ = stdout_buf;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp23_ = _tmp28_ != NULL;
#line 1857 "VideoReader.c"
		} else {
#line 200 "../src/video-support/VideoReader.vala"
			_tmp23_ = FALSE;
#line 1861 "VideoReader.c"
		}
#line 200 "../src/video-support/VideoReader.vala"
		if (_tmp23_) {
#line 1865 "VideoReader.c"
			GBytes* _tmp29_;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp29_ = stdout_buf;
#line 200 "../src/video-support/VideoReader.vala"
			_tmp22_ = g_bytes_get_size (_tmp29_) > ((gsize) 0);
#line 1871 "VideoReader.c"
		} else {
#line 200 "../src/video-support/VideoReader.vala"
			_tmp22_ = FALSE;
#line 1875 "VideoReader.c"
		}
#line 200 "../src/video-support/VideoReader.vala"
		if (_tmp22_) {
#line 1879 "VideoReader.c"
			gchar** lines = NULL;
			GBytes* _tmp30_;
			gsize _tmp31_ = 0;
			guint8* _tmp32_;
			gchar** _tmp33_;
			gchar** _tmp34_;
			gint lines_length1;
			gint _lines_size_;
			gchar* old = NULL;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			gchar** _tmp37_;
			gint _tmp37__length1;
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			gchar** _tmp40_;
			gint _tmp40__length1;
			const gchar* _tmp41_;
#line 201 "../src/video-support/VideoReader.vala"
			_tmp30_ = stdout_buf;
#line 201 "../src/video-support/VideoReader.vala"
			_tmp32_ = g_bytes_get_data (_tmp30_, &_tmp31_);
#line 201 "../src/video-support/VideoReader.vala"
			_tmp34_ = _tmp33_ = g_strsplit ((const gchar*) _tmp32_, "\n", 0);
#line 201 "../src/video-support/VideoReader.vala"
			lines = _tmp34_;
#line 201 "../src/video-support/VideoReader.vala"
			lines_length1 = _vala_array_length (_tmp33_);
#line 201 "../src/video-support/VideoReader.vala"
			_lines_size_ = lines_length1;
#line 203 "../src/video-support/VideoReader.vala"
			_tmp35_ = setlocale (LC_NUMERIC, "C");
#line 203 "../src/video-support/VideoReader.vala"
			_tmp36_ = g_strdup (_tmp35_);
#line 203 "../src/video-support/VideoReader.vala"
			old = _tmp36_;
#line 204 "../src/video-support/VideoReader.vala"
			_tmp37_ = lines;
#line 204 "../src/video-support/VideoReader.vala"
			_tmp37__length1 = lines_length1;
#line 204 "../src/video-support/VideoReader.vala"
			_tmp38_ = _tmp37_[0];
#line 204 "../src/video-support/VideoReader.vala"
			self->priv->clip_duration = double_parse (_tmp38_);
#line 205 "../src/video-support/VideoReader.vala"
			_tmp39_ = old;
#line 205 "../src/video-support/VideoReader.vala"
			setlocale (LC_NUMERIC, _tmp39_);
#line 206 "../src/video-support/VideoReader.vala"
			_tmp40_ = lines;
#line 206 "../src/video-support/VideoReader.vala"
			_tmp40__length1 = lines_length1;
#line 206 "../src/video-support/VideoReader.vala"
			_tmp41_ = _tmp40_[1];
#line 206 "../src/video-support/VideoReader.vala"
			if (g_strcmp0 (_tmp41_, "none") != 0) {
#line 1936 "VideoReader.c"
				gchar** _tmp42_;
				gint _tmp42__length1;
				const gchar* _tmp43_;
				GDateTime* _tmp44_;
				GDateTime* _tmp45_;
#line 207 "../src/video-support/VideoReader.vala"
				_tmp42_ = lines;
#line 207 "../src/video-support/VideoReader.vala"
				_tmp42__length1 = lines_length1;
#line 207 "../src/video-support/VideoReader.vala"
				_tmp43_ = _tmp42_[1];
#line 207 "../src/video-support/VideoReader.vala"
				_tmp44_ = g_date_time_new_from_iso8601 (_tmp43_, NULL);
#line 207 "../src/video-support/VideoReader.vala"
				_tmp45_ = _tmp44_;
#line 207 "../src/video-support/VideoReader.vala"
				video_reader_set_timestamp (self, _tmp45_);
#line 207 "../src/video-support/VideoReader.vala"
				_g_date_time_unref0 (_tmp45_);
#line 1956 "VideoReader.c"
			}
#line 200 "../src/video-support/VideoReader.vala"
			_g_free0 (old);
#line 200 "../src/video-support/VideoReader.vala"
			lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 1962 "VideoReader.c"
		} else {
			gchar* message = NULL;
			gchar* _tmp46_;
			gboolean _tmp47_ = FALSE;
			GBytes* _tmp48_;
#line 209 "../src/video-support/VideoReader.vala"
			_tmp46_ = g_strdup ("");
#line 209 "../src/video-support/VideoReader.vala"
			message = _tmp46_;
#line 210 "../src/video-support/VideoReader.vala"
			_tmp48_ = stderr_buf;
#line 210 "../src/video-support/VideoReader.vala"
			if (_tmp48_ != NULL) {
#line 1976 "VideoReader.c"
				GBytes* _tmp49_;
#line 210 "../src/video-support/VideoReader.vala"
				_tmp49_ = stderr_buf;
#line 210 "../src/video-support/VideoReader.vala"
				_tmp47_ = g_bytes_get_size (_tmp49_) > ((gsize) 0);
#line 1982 "VideoReader.c"
			} else {
#line 210 "../src/video-support/VideoReader.vala"
				_tmp47_ = FALSE;
#line 1986 "VideoReader.c"
			}
#line 210 "../src/video-support/VideoReader.vala"
			if (_tmp47_) {
#line 1990 "VideoReader.c"
				GBytes* _tmp50_;
				gsize _tmp51_ = 0;
				guint8* _tmp52_;
				gchar* _tmp53_;
#line 211 "../src/video-support/VideoReader.vala"
				_tmp50_ = stderr_buf;
#line 211 "../src/video-support/VideoReader.vala"
				_tmp52_ = g_bytes_get_data (_tmp50_, &_tmp51_);
#line 211 "../src/video-support/VideoReader.vala"
				_tmp53_ = g_strdup ((const gchar*) _tmp52_);
#line 211 "../src/video-support/VideoReader.vala"
				_g_free0 (message);
#line 211 "../src/video-support/VideoReader.vala"
				message = _tmp53_;
#line 2005 "VideoReader.c"
			}
#line 213 "../src/video-support/VideoReader.vala"
			g_warning ("VideoReader.vala:213: External Metadata helper failed");
#line 200 "../src/video-support/VideoReader.vala"
			_g_free0 (message);
#line 2011 "VideoReader.c"
		}
#line 185 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (process);
#line 185 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stderr_buf);
#line 185 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stdout_buf);
#line 185 "../src/video-support/VideoReader.vala"
		block17_data_unref (_data17_);
#line 185 "../src/video-support/VideoReader.vala"
		_data17_ = NULL;
#line 2023 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp54_;
		const gchar* _tmp55_;
		GError* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		GError* _tmp60_;
		GError* _tmp61_;
#line 185 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 185 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 216 "../src/video-support/VideoReader.vala"
		_tmp54_ = e;
#line 216 "../src/video-support/VideoReader.vala"
		_tmp55_ = _tmp54_->message;
#line 216 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:216: Video read error: %s", _tmp55_);
#line 217 "../src/video-support/VideoReader.vala"
		_tmp56_ = e;
#line 217 "../src/video-support/VideoReader.vala"
		_tmp57_ = _tmp56_->message;
#line 217 "../src/video-support/VideoReader.vala"
		_tmp58_ = g_strdup_printf ("GStreamer couldn't extract clip information: %s", _tmp57_);
#line 217 "../src/video-support/VideoReader.vala"
		_tmp59_ = _tmp58_;
#line 217 "../src/video-support/VideoReader.vala"
		_tmp60_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_CONTENTS, _tmp59_);
#line 217 "../src/video-support/VideoReader.vala"
		_tmp61_ = _tmp60_;
#line 217 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp59_);
#line 217 "../src/video-support/VideoReader.vala"
		_inner_error0_ = _tmp61_;
#line 217 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 2065 "VideoReader.c"
		goto __finally0;
	}
	__finally0:
#line 185 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "../src/video-support/VideoReader.vala"
		if (_inner_error0_->domain == VIDEO_ERROR) {
#line 185 "../src/video-support/VideoReader.vala"
			g_propagate_error (error, _inner_error0_);
#line 185 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 185 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 185 "../src/video-support/VideoReader.vala"
			return;
#line 2081 "VideoReader.c"
		} else {
#line 185 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 185 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 185 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 185 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 185 "../src/video-support/VideoReader.vala"
			return;
#line 2093 "VideoReader.c"
		}
	}
#line 221 "../src/video-support/VideoReader.vala"
	if (_data16_->id != ((guint) 0)) {
#line 222 "../src/video-support/VideoReader.vala"
		g_source_remove (_data16_->id);
#line 2100 "VideoReader.c"
	}
#line 179 "../src/video-support/VideoReader.vala"
	block16_data_unref (_data16_);
#line 179 "../src/video-support/VideoReader.vala"
	_data16_ = NULL;
#line 2106 "VideoReader.c"
}

static gboolean
video_reader_on_thumbnailer_timer (VideoReader* self)
{
	GSubprocess* _tmp0_;
	gboolean result;
#line 227 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
#line 228 "../src/video-support/VideoReader.vala"
	g_debug ("VideoReader.vala:228: Thumbnailer timer called");
#line 229 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->thumbnailer_process;
#line 229 "../src/video-support/VideoReader.vala"
	if (_tmp0_ != NULL) {
#line 2122 "VideoReader.c"
		GSubprocess* _tmp1_;
#line 230 "../src/video-support/VideoReader.vala"
		_tmp1_ = self->priv->thumbnailer_process;
#line 230 "../src/video-support/VideoReader.vala"
		g_subprocess_force_exit (_tmp1_);
#line 2128 "VideoReader.c"
	}
#line 232 "../src/video-support/VideoReader.vala"
	result = FALSE;
#line 232 "../src/video-support/VideoReader.vala"
	return result;
#line 2134 "VideoReader.c"
}

static gboolean
_video_reader_on_thumbnailer_timer_gsource_func (gpointer self)
{
	gboolean result;
	result = video_reader_on_thumbnailer_timer ((VideoReader*) self);
#line 258 "../src/video-support/VideoReader.vala"
	return result;
#line 2144 "VideoReader.c"
}

static GdkPixbuf*
video_reader_thumbnailer (VideoReader* self,
                          const gchar* video_file)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFileIOStream* stream = NULL;
	GFile* output_file = NULL;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 237 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 237 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (video_file != NULL, NULL);
#line 239 "../src/video-support/VideoReader.vala"
	_tmp0_ = app_dirs_get_thumbnailer_bin ();
#line 239 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 239 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 239 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 239 "../src/video-support/VideoReader.vala"
	g_debug ("VideoReader.vala:239: Launching thumbnailer process: %s", _tmp3_);
#line 239 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp3_);
#line 239 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (_tmp1_);
#line 2177 "VideoReader.c"
	{
		GFile* _tmp4_ = NULL;
		GFileIOStream* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 243 "../src/video-support/VideoReader.vala"
		_tmp6_ = g_file_new_tmp (NULL, &_tmp5_, &_inner_error0_);
#line 243 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (stream);
#line 243 "../src/video-support/VideoReader.vala"
		stream = _tmp5_;
#line 243 "../src/video-support/VideoReader.vala"
		_tmp4_ = _tmp6_;
#line 243 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2193 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 243 "../src/video-support/VideoReader.vala"
		_tmp7_ = _tmp4_;
#line 243 "../src/video-support/VideoReader.vala"
		_tmp4_ = NULL;
#line 243 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (output_file);
#line 243 "../src/video-support/VideoReader.vala"
		output_file = _tmp7_;
#line 242 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp4_);
#line 2206 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 242 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 242 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 245 "../src/video-support/VideoReader.vala"
		_tmp8_ = e;
#line 245 "../src/video-support/VideoReader.vala"
		_tmp9_ = _tmp8_->message;
#line 245 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:245: Failed to create temporary file: %s", _tmp9_);
#line 246 "../src/video-support/VideoReader.vala"
		result = NULL;
#line 246 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 246 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (output_file);
#line 246 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (stream);
#line 246 "../src/video-support/VideoReader.vala"
		return result;
#line 2234 "VideoReader.c"
	}
	__finally0:
#line 242 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 242 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (output_file);
#line 242 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (stream);
#line 242 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 242 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 242 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2249 "VideoReader.c"
	}
	{
		GSubprocess* _tmp10_ = NULL;
		GFile* _tmp11_;
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GFile* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GSubprocess* _tmp18_;
		GSubprocess* _tmp19_;
		GSubprocess* _tmp20_;
#line 250 "../src/video-support/VideoReader.vala"
		_tmp11_ = app_dirs_get_thumbnailer_bin ();
#line 250 "../src/video-support/VideoReader.vala"
		_tmp12_ = _tmp11_;
#line 250 "../src/video-support/VideoReader.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 250 "../src/video-support/VideoReader.vala"
		_tmp14_ = _tmp13_;
#line 250 "../src/video-support/VideoReader.vala"
		_tmp15_ = output_file;
#line 250 "../src/video-support/VideoReader.vala"
		_tmp16_ = g_file_get_path (_tmp15_);
#line 250 "../src/video-support/VideoReader.vala"
		_tmp17_ = _tmp16_;
#line 250 "../src/video-support/VideoReader.vala"
		_tmp18_ = g_subprocess_new (G_SUBPROCESS_FLAGS_NONE, &_inner_error0_, _tmp14_, video_file, _tmp17_, NULL);
#line 250 "../src/video-support/VideoReader.vala"
		_tmp19_ = _tmp18_;
#line 250 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp17_);
#line 250 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp14_);
#line 250 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp12_);
#line 250 "../src/video-support/VideoReader.vala"
		_tmp10_ = _tmp19_;
#line 250 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2291 "VideoReader.c"
			goto __catch1_g_error;
		}
#line 250 "../src/video-support/VideoReader.vala"
		_tmp20_ = _tmp10_;
#line 250 "../src/video-support/VideoReader.vala"
		_tmp10_ = NULL;
#line 250 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (self->priv->thumbnailer_process);
#line 250 "../src/video-support/VideoReader.vala"
		self->priv->thumbnailer_process = _tmp20_;
#line 249 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp10_);
#line 2304 "VideoReader.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 249 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 249 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 253 "../src/video-support/VideoReader.vala"
		_tmp21_ = e;
#line 253 "../src/video-support/VideoReader.vala"
		_tmp22_ = _tmp21_->message;
#line 253 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:253: Error spawning process: %s", _tmp22_);
#line 254 "../src/video-support/VideoReader.vala"
		result = NULL;
#line 254 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 254 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (output_file);
#line 254 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (stream);
#line 254 "../src/video-support/VideoReader.vala"
		return result;
#line 2332 "VideoReader.c"
	}
	__finally1:
#line 249 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 249 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (output_file);
#line 249 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (stream);
#line 249 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 249 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 249 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2347 "VideoReader.c"
	}
#line 258 "../src/video-support/VideoReader.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, VIDEO_READER_THUMBNAILER_TIMEOUT, _video_reader_on_thumbnailer_timer_gsource_func, video_reader_ref (self), video_reader_unref);
#line 2351 "VideoReader.c"
	{
		GSubprocess* _tmp23_;
		GdkPixbuf* buf = NULL;
#line 262 "../src/video-support/VideoReader.vala"
		_tmp23_ = self->priv->thumbnailer_process;
#line 262 "../src/video-support/VideoReader.vala"
		g_subprocess_wait_check (_tmp23_, NULL, &_inner_error0_);
#line 262 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2361 "VideoReader.c"
			goto __catch2_g_error;
		}
#line 265 "../src/video-support/VideoReader.vala"
		buf = NULL;
#line 2366 "VideoReader.c"
		{
			GdkPixbuf* _tmp24_ = NULL;
			GFileIOStream* _tmp25_;
			GInputStream* _tmp26_;
			GdkPixbuf* _tmp27_;
			GdkPixbuf* _tmp28_;
#line 267 "../src/video-support/VideoReader.vala"
			_tmp25_ = stream;
#line 267 "../src/video-support/VideoReader.vala"
			_tmp26_ = g_io_stream_get_input_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, g_io_stream_get_type (), GIOStream));
#line 267 "../src/video-support/VideoReader.vala"
			_tmp27_ = gdk_pixbuf_new_from_stream (_tmp26_, NULL, &_inner_error0_);
#line 267 "../src/video-support/VideoReader.vala"
			_tmp24_ = _tmp27_;
#line 267 "../src/video-support/VideoReader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2383 "VideoReader.c"
				goto __catch3_g_error;
			}
#line 267 "../src/video-support/VideoReader.vala"
			_tmp28_ = _tmp24_;
#line 267 "../src/video-support/VideoReader.vala"
			_tmp24_ = NULL;
#line 267 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (buf);
#line 267 "../src/video-support/VideoReader.vala"
			buf = _tmp28_;
#line 268 "../src/video-support/VideoReader.vala"
			result = buf;
#line 268 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (_tmp24_);
#line 268 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (output_file);
#line 268 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (stream);
#line 268 "../src/video-support/VideoReader.vala"
			return result;
#line 2404 "VideoReader.c"
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			GError* _tmp29_;
			const gchar* _tmp30_;
#line 266 "../src/video-support/VideoReader.vala"
			e = _inner_error0_;
#line 266 "../src/video-support/VideoReader.vala"
			_inner_error0_ = NULL;
#line 270 "../src/video-support/VideoReader.vala"
			_tmp29_ = e;
#line 270 "../src/video-support/VideoReader.vala"
			_tmp30_ = _tmp29_->message;
#line 270 "../src/video-support/VideoReader.vala"
			g_debug ("VideoReader.vala:270: Error creating pixbuf: %s", _tmp30_);
#line 266 "../src/video-support/VideoReader.vala"
			_g_error_free0 (e);
#line 2424 "VideoReader.c"
		}
		__finally3:
#line 266 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 266 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (buf);
#line 2431 "VideoReader.c"
			goto __catch2_g_error;
		}
#line 261 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 2436 "VideoReader.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
#line 261 "../src/video-support/VideoReader.vala"
		err = _inner_error0_;
#line 261 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 273 "../src/video-support/VideoReader.vala"
		_tmp31_ = err;
#line 273 "../src/video-support/VideoReader.vala"
		_tmp32_ = _tmp31_->message;
#line 273 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:273: Thumbnailer process exited with error: %s", _tmp32_);
#line 261 "../src/video-support/VideoReader.vala"
		_g_error_free0 (err);
#line 2456 "VideoReader.c"
	}
	__finally2:
#line 261 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (output_file);
#line 261 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (stream);
#line 261 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 261 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2471 "VideoReader.c"
	}
	{
		GFile* _tmp33_;
#line 277 "../src/video-support/VideoReader.vala"
		_tmp33_ = output_file;
#line 277 "../src/video-support/VideoReader.vala"
		g_file_delete (_tmp33_, NULL, &_inner_error0_);
#line 277 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2481 "VideoReader.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* err = NULL;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 276 "../src/video-support/VideoReader.vala"
		err = _inner_error0_;
#line 276 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 279 "../src/video-support/VideoReader.vala"
		_tmp34_ = err;
#line 279 "../src/video-support/VideoReader.vala"
		_tmp35_ = _tmp34_->message;
#line 279 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:279: Failed to remove temporary file: %s", _tmp35_);
#line 276 "../src/video-support/VideoReader.vala"
		_g_error_free0 (err);
#line 2503 "VideoReader.c"
	}
	__finally4:
#line 276 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 276 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (output_file);
#line 276 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (stream);
#line 276 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 276 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 276 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2518 "VideoReader.c"
	}
#line 282 "../src/video-support/VideoReader.vala"
	result = NULL;
#line 282 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (output_file);
#line 282 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (stream);
#line 282 "../src/video-support/VideoReader.vala"
	return result;
#line 2528 "VideoReader.c"
}

static gboolean
video_reader_does_file_exist (VideoReader* self)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 285 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
#line 286 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->file;
#line 286 "../src/video-support/VideoReader.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 286 "../src/video-support/VideoReader.vala"
	_tmp2_ = _tmp1_;
#line 286 "../src/video-support/VideoReader.vala"
	_tmp3_ = g_file_test (_tmp2_, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR);
#line 286 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp2_);
#line 286 "../src/video-support/VideoReader.vala"
	result = _tmp3_;
#line 286 "../src/video-support/VideoReader.vala"
	return result;
#line 2555 "VideoReader.c"
}

GdkPixbuf*
video_reader_read_preview_frame (VideoReader* self)
{
	GdkPixbuf* _tmp0_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* result;
#line 289 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 290 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->preview_frame;
#line 290 "../src/video-support/VideoReader.vala"
	if (_tmp0_ != NULL) {
#line 2576 "VideoReader.c"
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 291 "../src/video-support/VideoReader.vala"
		_tmp1_ = self->priv->preview_frame;
#line 291 "../src/video-support/VideoReader.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 291 "../src/video-support/VideoReader.vala"
		result = _tmp2_;
#line 291 "../src/video-support/VideoReader.vala"
		return result;
#line 2587 "VideoReader.c"
	}
#line 293 "../src/video-support/VideoReader.vala"
	if (!video_reader_does_file_exist (self)) {
#line 294 "../src/video-support/VideoReader.vala"
		result = NULL;
#line 294 "../src/video-support/VideoReader.vala"
		return result;
#line 2595 "VideoReader.c"
	}
#line 297 "../src/video-support/VideoReader.vala"
	_tmp3_ = self->priv->file;
#line 297 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 297 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 297 "../src/video-support/VideoReader.vala"
	_tmp6_ = video_reader_thumbnailer (self, _tmp5_);
#line 297 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->preview_frame);
#line 297 "../src/video-support/VideoReader.vala"
	self->priv->preview_frame = _tmp6_;
#line 297 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp5_);
#line 298 "../src/video-support/VideoReader.vala"
	_tmp7_ = self->priv->preview_frame;
#line 298 "../src/video-support/VideoReader.vala"
	if (NULL == _tmp7_) {
#line 2615 "VideoReader.c"
		GdkPixbuf* _tmp8_;
#line 299 "../src/video-support/VideoReader.vala"
		_tmp8_ = resources_get_noninterpretable_badge_pixbuf ();
#line 299 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (self->priv->preview_frame);
#line 299 "../src/video-support/VideoReader.vala"
		self->priv->preview_frame = _tmp8_;
#line 2623 "VideoReader.c"
	}
#line 301 "../src/video-support/VideoReader.vala"
	_tmp9_ = self->priv->preview_frame;
#line 301 "../src/video-support/VideoReader.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 301 "../src/video-support/VideoReader.vala"
	result = _tmp10_;
#line 301 "../src/video-support/VideoReader.vala"
	return result;
#line 2633 "VideoReader.c"
}

gdouble
video_reader_read_clip_duration (VideoReader* self,
                                 GError** error)
{
	GError* _inner_error0_ = NULL;
	gdouble result;
#line 304 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), 0.0);
#line 305 "../src/video-support/VideoReader.vala"
	if (self->priv->clip_duration == VIDEO_READER_UNKNOWN_CLIP_DURATION) {
#line 306 "../src/video-support/VideoReader.vala"
		video_reader_read_internal (self, &_inner_error0_);
#line 306 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 306 "../src/video-support/VideoReader.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 2652 "VideoReader.c"
				gdouble _tmp0_ = -1.0;
#line 306 "../src/video-support/VideoReader.vala"
				g_propagate_error (error, _inner_error0_);
#line 306 "../src/video-support/VideoReader.vala"
				return _tmp0_;
#line 2658 "VideoReader.c"
			} else {
				gdouble _tmp1_ = -1.0;
#line 306 "../src/video-support/VideoReader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 306 "../src/video-support/VideoReader.vala"
				g_clear_error (&_inner_error0_);
#line 306 "../src/video-support/VideoReader.vala"
				return _tmp1_;
#line 2667 "VideoReader.c"
			}
		}
	}
#line 308 "../src/video-support/VideoReader.vala"
	result = self->priv->clip_duration;
#line 308 "../src/video-support/VideoReader.vala"
	return result;
#line 2675 "VideoReader.c"
}

VideoMetadata*
video_reader_read_metadata (VideoReader* self,
                            GError** error)
{
	VideoMetadata* metadata = NULL;
	VideoMetadata* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	VideoMetadata* result;
#line 311 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 312 "../src/video-support/VideoReader.vala"
	_tmp0_ = video_metadata_new ();
#line 312 "../src/video-support/VideoReader.vala"
	metadata = _tmp0_;
#line 313 "../src/video-support/VideoReader.vala"
	_tmp1_ = self->priv->file;
#line 313 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 313 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 313 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 313 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 313 "../src/video-support/VideoReader.vala"
	media_metadata_read_from_file (G_TYPE_CHECK_INSTANCE_CAST (metadata, TYPE_MEDIA_METADATA, MediaMetadata), _tmp5_, &_inner_error0_);
#line 313 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (_tmp5_);
#line 313 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp3_);
#line 313 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "../src/video-support/VideoReader.vala"
		g_propagate_error (error, _inner_error0_);
#line 313 "../src/video-support/VideoReader.vala"
		_media_metadata_unref0 (metadata);
#line 313 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2721 "VideoReader.c"
	}
#line 315 "../src/video-support/VideoReader.vala"
	result = metadata;
#line 315 "../src/video-support/VideoReader.vala"
	return result;
#line 2727 "VideoReader.c"
}

GDateTime*
video_reader_get_timestamp (VideoReader* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 26 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->_timestamp;
#line 26 "../src/video-support/VideoReader.vala"
	result = _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	return result;
#line 2743 "VideoReader.c"
}

static void
video_reader_set_timestamp (VideoReader* self,
                            GDateTime* value)
{
	GDateTime* _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	g_return_if_fail (IS_VIDEO_READER (self));
#line 26 "../src/video-support/VideoReader.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 26 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (self->priv->_timestamp);
#line 26 "../src/video-support/VideoReader.vala"
	self->priv->_timestamp = _tmp0_;
#line 2759 "VideoReader.c"
}

static void
value_video_reader_init (GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	value->data[0].v_pointer = NULL;
#line 2767 "VideoReader.c"
}

static void
value_video_reader_free_value (GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (value->data[0].v_pointer);
#line 2777 "VideoReader.c"
	}
}

static void
value_video_reader_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (src_value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		dest_value->data[0].v_pointer = video_reader_ref (src_value->data[0].v_pointer);
#line 2789 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2793 "VideoReader.c"
	}
}

static gpointer
value_video_reader_peek_pointer (const GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	return value->data[0].v_pointer;
#line 2802 "VideoReader.c"
}

static gchar*
value_video_reader_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (collect_values[0].v_pointer) {
#line 2813 "VideoReader.c"
		VideoReader * object;
		object = collect_values[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
		if (object->parent_instance.g_class == NULL) {
#line 15 "../src/video-support/VideoReader.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2820 "VideoReader.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 15 "../src/video-support/VideoReader.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2824 "VideoReader.c"
		}
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = video_reader_ref (object);
#line 2828 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2832 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	return NULL;
#line 2836 "VideoReader.c"
}

static gchar*
value_video_reader_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	VideoReader ** object_p;
	object_p = collect_values[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (!object_p) {
#line 15 "../src/video-support/VideoReader.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2851 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (!value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = NULL;
#line 2857 "VideoReader.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = value->data[0].v_pointer;
#line 2861 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = video_reader_ref (value->data[0].v_pointer);
#line 2865 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	return NULL;
#line 2869 "VideoReader.c"
}

GParamSpec*
param_spec_video_reader (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecVideoReader* spec;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_READER), NULL);
#line 15 "../src/video-support/VideoReader.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 15 "../src/video-support/VideoReader.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 15 "../src/video-support/VideoReader.vala"
	return G_PARAM_SPEC (spec);
#line 2888 "VideoReader.c"
}

gpointer
value_get_video_reader (const GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER), NULL);
#line 15 "../src/video-support/VideoReader.vala"
	return value->data[0].v_pointer;
#line 2898 "VideoReader.c"
}

void
value_set_video_reader (GValue* value,
                        gpointer v_object)
{
	VideoReader * old;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
	old = value->data[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (v_object) {
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = v_object;
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_ref (value->data[0].v_pointer);
#line 2920 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2924 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (old) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (old);
#line 2930 "VideoReader.c"
	}
}

void
value_take_video_reader (GValue* value,
                         gpointer v_object)
{
	VideoReader * old;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
	old = value->data[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (v_object) {
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = v_object;
#line 2951 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2955 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (old) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (old);
#line 2961 "VideoReader.c"
	}
}

static void
video_reader_class_init (VideoReaderClass * klass,
                         gpointer klass_data)
{
#line 15 "../src/video-support/VideoReader.vala"
	video_reader_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/video-support/VideoReader.vala"
	((VideoReaderClass *) klass)->finalize = video_reader_finalize;
#line 15 "../src/video-support/VideoReader.vala"
	g_type_class_adjust_private_offset (klass, &VideoReader_private_offset);
#line 2975 "VideoReader.c"
}

static void
video_reader_instance_init (VideoReader * self,
                            gpointer klass)
{
#line 15 "../src/video-support/VideoReader.vala"
	self->priv = video_reader_get_instance_private (self);
#line 22 "../src/video-support/VideoReader.vala"
	self->priv->clip_duration = VIDEO_READER_UNKNOWN_CLIP_DURATION;
#line 23 "../src/video-support/VideoReader.vala"
	self->priv->preview_frame = NULL;
#line 24 "../src/video-support/VideoReader.vala"
	self->priv->file = NULL;
#line 25 "../src/video-support/VideoReader.vala"
	self->priv->thumbnailer_process = NULL;
#line 26 "../src/video-support/VideoReader.vala"
	self->priv->_timestamp = NULL;
#line 15 "../src/video-support/VideoReader.vala"
	self->ref_count = 1;
#line 2996 "VideoReader.c"
}

static void
video_reader_finalize (VideoReader * obj)
{
	VideoReader * self;
#line 15 "../src/video-support/VideoReader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_READER, VideoReader);
#line 15 "../src/video-support/VideoReader.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->preview_frame);
#line 24 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->file);
#line 25 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->thumbnailer_process);
#line 26 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (self->priv->_timestamp);
#line 3015 "VideoReader.c"
}

static GType
video_reader_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_video_reader_init, value_video_reader_free_value, value_video_reader_copy_value, value_video_reader_peek_pointer, "p", value_video_reader_collect_value, "p", value_video_reader_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (VideoReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoReader), 0, (GInstanceInitFunc) video_reader_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType video_reader_type_id;
	video_reader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoReader", &g_define_type_info, &g_define_type_fundamental_info, 0);
	VideoReader_private_offset = g_type_add_instance_private (video_reader_type_id, sizeof (VideoReaderPrivate));
	return video_reader_type_id;
}

GType
video_reader_get_type (void)
{
	static volatile gsize video_reader_type_id__once = 0;
	if (g_once_init_enter (&video_reader_type_id__once)) {
		GType video_reader_type_id;
		video_reader_type_id = video_reader_get_type_once ();
		g_once_init_leave (&video_reader_type_id__once, video_reader_type_id);
	}
	return video_reader_type_id__once;
}

gpointer
video_reader_ref (gpointer instance)
{
	VideoReader * self;
	self = instance;
#line 15 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&self->ref_count);
#line 15 "../src/video-support/VideoReader.vala"
	return instance;
#line 3051 "VideoReader.c"
}

void
video_reader_unref (gpointer instance)
{
	VideoReader * self;
	self = instance;
#line 15 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 15 "../src/video-support/VideoReader.vala"
		VIDEO_READER_GET_CLASS (self)->finalize (self);
#line 15 "../src/video-support/VideoReader.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3065 "VideoReader.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

